# -*- text -*-

----------------------------------------------------------------------

Changes: V5.9.4.rc1 -> V5.9.4

commit 5289dca2699acb24e4ba92bc20fd1079484eb0fb
Author: Wes Hardaker <opensource@hardakers.net>
Date:   Tue Aug 15 13:28:30 2023 -0700

    added a note about TLS

commit 54f9a73ebdcc7e038f1f9a2612115b3f909ec871
Author: Wes Hardaker <opensource@hardakers.net>
Date:   Tue Aug 15 13:18:19 2023 -0700

    remove 5-9 patches

commit 7e527d309934c8c28e55de4c1d856a9cae137a7e
Author: Wes Hardaker <opensource@hardakers.net>
Date:   Tue Aug 15 13:17:47 2023 -0700

    Version number update: 5.9.4

commit 04b98f6b3c939382e697a85a10569299eb74b46e
Author: Wes Hardaker <opensource@hardakers.net>
Date:   Tue Aug 15 13:16:36 2023 -0700

    better debug message

commit 100c0d989079cd36954e3000591fd1ef9e6859a1
Author: Wes Hardaker <opensource@hardakers.net>
Date:   Tue Aug 15 13:16:09 2023 -0700

    changes and news

----------------------------------------------------------------------

Changes: V5.9.4.pre3 -> V5.9.4.rc1

commit bb7eb41a74cb11a212cc7b69bde09d10290f7824
Author: Wes Hardaker <opensource@hardakers.net>
Date:   Thu Jun 22 08:00:33 2023 -0700

    Release Candidate for V5-9-patches

commit ab9840507a39b68fa7bf3ebc1b03b4725ceaea1a
Author: Wes Hardaker <opensource@hardakers.net>
Date:   Thu Jun 22 08:00:31 2023 -0700

    Version number update: 5.9.4.rc1

commit d4db247d68c868452d4fe876796e2cd1e8326239
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Tue Jun 20 06:59:15 2023 -0700

    configure: Remove -Wno-deprecated
    
    Remove this compiler option now that a better solution is available for
    suppressing warnings from the OpenSSL library about using deprecated functions.

commit d9be7344eeec10d139789f2cbac9ab0a7791f24d
Author: Niels Baggesen <nba@users.sourceforge.net>
Date:   Mon Jun 19 10:05:50 2023 +0200

    libsnmp: Declare OpenSSL API version
    
    Add the include/net-snmp/library/openssl_config.h header file. This suppresses
    warnings from the OpenSSL 3.0+ library about using deprecated API functions.
    
    Fixes: https://github.com/net-snmp/net-snmp/pull/591
    
    [ bvanassche: edited patch description ]

commit d78add0cdb953775786e040f2a6e92b578e84699
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Wed Jun 7 08:04:06 2023 -0700

    ci: Upgrade Github checkout action
    
    This patch addresses the following warning:
    
    Node.js 12 actions are deprecated. Please update the following actions to use
    Node.js 16: actions/checkout@v2. For more information see:
    https://github.blog/changelog/2022-09-22-github-actions-all-actions-will-begin-running-on-node16-instead-of-node12/.

commit 83a42cbb2fafcb228795be561d4cda2b1357a18e
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Jan 21 15:55:55 2023 -0800

    ci: Drop support for Travis CI
    
    CI support for open source projects ceased on travis-ci.org in June 2021.
    Hence remove support for Travis CI.

commit 45cca4ef4babd5ee32961f92d69027774fe0aa02
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Wed Dec 21 17:08:52 2022 -0800

    ci/perl.bat: Fix a syntax error

commit 50b7683008534ed4201e2e7796bd6f584c746852
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Tue Sep 13 13:43:02 2022 -0700

    .cirrus.yml: Update to the current Cirrus CI syntax
    
    Additionally, do not install pkgconf since it breaks the Net-SNMP build.

commit b6569d5af51d2d6d158621b8c8b4c04cbf1666a8
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Aug 7 15:34:32 2022 -0700

    Make the shell scripts again compatible with the POSIX shell
    
    Although /bin/sh is a soft link to /bin/bash on many Linux systems, this is
    not always the case. Use the POSIX shell syntax in shell scripts instead of
    bash extensions.

commit a7dbdfb70cd82a8bc5563aa5a97c579c0f42a714
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Fri Aug 5 17:10:46 2022 -0700

    ci/net-snmp-configure: Only apply Travis workarounds for Travis CI

commit f120aa7d59c2b3554ab0c9f20da5424491c429d4
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Jul 30 20:06:29 2022 -0700

    ci: Build with OpenSSL and wolfSSL

commit f3b8e895ea273a08fd013c7a430844df8988c829
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Jul 30 20:49:34 2022 -0700

    ci/net-snmp-configure: Remove the OpenSSL version querying code

commit 6c7ec60055a2e35e34c69bd24ec5ac68bd16d68b
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Tue Jun 6 11:39:28 2023 -0700

    ci: Improve .appveyor.yml
    
    Reduce the build time by excluding configurations that are skipped. Add the
    Ubuntu2004 image. Switch from Visual Studio 2019 to Visual Studio 2022. Switch
    from macos-mojave to macos-monterey.

commit e1fdcba82e5d8dff9c22de4f8307cc262d537977
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Tue Sep 13 13:39:42 2022 -0700

    ci: Use /bin/sh instead of /bin/bash
    
    Use /bin/sh since /bin/bash is not installed by default in the Cirrus CI
    FreeBSD VMs.

commit 79204e14f69ffb8b2f5204a3c9df8b5e79136366
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Thu Aug 4 14:01:19 2022 -0700

    ci/install.sh: Install packages quietly

commit a0d72fb33567dcd9faaa44479a6501f1843efd9e
Author: Florian Koehler <floriankoehler@siemens.com>
Date:   Mon Mar 6 15:45:30 2023 +0100

    Added fix for TSM segfault.

commit a99eee78c38b62567ab0ff55b8c04b2d8656bc54
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Jun 4 13:49:51 2023 -0700

    testing/fulltests/unit-tests/T021netsnmp_sprint_integer_clib.c: Add this test
    
    Add a reproducer for https://bugs.chromium.org/p/oss-fuzz/issues/detail?id=59491.

commit a9fba9a2f23a06a4d01482ccdb96b8ba70c1b0de
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Jun 4 14:33:14 2023 -0700

    libsnmp: Reject invalid DISPLAY-HINT format characters
    
    Prevent that format characters like 'F' cause a buffer overflow.

commit b5229a4ef4c6a3ab6d23482211c7607c54044f12
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Thu Aug 11 19:53:30 2022 -0700

    libsnmp: Fix a recently introduced potential integer overflow
    
    Fixes: d65925a9f8f6 ("libsnmp: Ignore invalid DISPLAY-HINT clauses")
    Fixes: https://bugs.chromium.org/p/oss-fuzz/issues/detail?id=50063

commit 09c00e9ff2311f1a69a97a4e7b394ac91e6aa0fb
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Aug 7 20:26:29 2022 -0700

    libsnmp: Ignore invalid DISPLAY-HINT clauses
    
    This patch should
    fix https://bugs.chromium.org/p/oss-fuzz/issues/detail?id=48802.

commit ed31ab4c83eb3c745e61222be0f4d06689a821a5
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Thu Jun 1 14:36:12 2023 -0700

    libsnmp: Fix a buffer overflow in sprint_realloc_hinted_integer()
    
    See also https://bugs.chromium.org/p/oss-fuzz/issues/detail?id=59491.

commit fb63c4cbf9abbe4b3b3e8b9475bb6b9aca596c1d
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Wed May 31 17:02:59 2023 -0700

    agent/snmp_perl: Disable -Wcast-qual
    
    The Perl headers trigger many -Wcast-qual warnings. Hence disable -Wcast-qual
    around the Perl extension headers.

commit 3cec57d8c042619b83e97a45fff34475d314e4b1
Author: Niels Baggesen <nba@users.sourceforge.net>
Date:   Thu Jun 1 11:13:19 2023 +0200

    read_config.c: add missing newlines to DEBUGMSGTL calls

commit 20879e824851a7a188eac50fd34aac04113d7432
Author: Niels Baggesen <nba@users.sourceforge.net>
Date:   Thu Jun 1 11:12:34 2023 +0200

    snmplib: Handle two oldEngineID lines in snmpd.conf. Fixes #578

commit 055d3801e0b93c552d77645288b2422b2595e2f4
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Wed May 31 15:49:05 2023 -0700

    ci, Windows: Bump the OpenSSL version number

commit b208ebecc9381718b801c9d9ddfc5cc7546633f5
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Wed May 31 07:18:26 2023 -0700

    snmpd: Move a comment block
    
    The preprocessor constant MIB_CLIENTS_ARE_EVIL is used in source file
    old_api.c but not in snmp_vars.c. Hence move the comment block that
    explains the role of that preprocessor constant.

commit 2f95d30e632d2c2ab3add875f2eee1e186d8209f
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Wed May 31 07:07:30 2023 -0700

    libsnmp: Clean up netsnmp_old_api_helper()
    
    Combine the initialization and declaration of variable 'vp' such that it
    can be declared const. Remove 'vp &&' because it causes some static checkers
    to report a "dereference before checked" warning.
    
    Fixes: https://github.com/net-snmp/net-snmp/pull/487

commit dc103aa62a6bee2b5cef6085af69d96b65c7a5f9
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Fri May 26 19:21:55 2023 -0700

    agent/mibgroup/util_funcs: Align netsnmp_get_link_settings() with master branch

commit 7594e24375c26641c36a6272970579042c350de4
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Fri May 26 14:43:04 2023 -0700

    agent/mibgroup/util_funcs: Fix a compiler warning
    
    Fix the following clang compiler warning:
    
    mibgroup/util_funcs.c:1249:42: warning: field 'elinkset' with variable sized type 'struct ethtool_link_settings' not at the end of a struct or class is a GNU extension [-Wgnu-variable-sized-type-not-at-end]
                struct ethtool_link_settings elinkset;
    
    Additionally, increase mask_nwords from 4 to 8.

commit 7a1220567ec68805713eb2dd782424537f1f0de4
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Fri May 26 14:42:55 2023 -0700

    libsnmp: Fix a compiler warning

commit 5192261e49957438d6f18b4f3104cdac49fbd28f
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Tue Aug 30 20:39:32 2022 -0700

    apps/snmptrap: Initialize the variable 'ss'
    
    Fixes: 21b16eba6024 ("apps: Use netsnmp_cleanup_session()")

commit 7d5ad2312d849adbed63f23a781049024df8675b
Author: Phil O <github@linuxace.com>
Date:   Wed May 25 10:58:23 2022 -0700

    HOST-MIB: Add ignoremount config option
    
    Fixes: https://github.com/net-snmp/net-snmp/pull/424
    
    [bvanassche: edited patch description; moved a declaration of a global
    variable from a .c into a .h file and renamed match_mount_config() into
    ignore_mount_point().]

commit 8e02f6c2df8dc929a2f89b71be4de31003a79986
Author: Phil O <github@linuxace.com>
Date:   Wed May 25 11:21:40 2022 -0700

    HOST-MIB: Add virtiofs to other_fs

commit 298c8103db80b292791616af4fd497342a71867f
Author: Josef Řídký <jridky@redhat.com>
Date:   Wed May 24 10:49:41 2023 +0200

    libsnmp, UDP transport: Fix sendmsg() error code handling
    
    This change has been made because of Linux kernel commit "ipv4: Return
    -ENETUNREACH if we can't create route but saddr is valid"
    (https://git.kernel.org/pub/scm/linux/kernel/git/torvalds/linux.git/commit/?id=595e0651d029)
    
    Fixes: https://github.com/net-snmp/net-snmp/issues/564
    Fixes: https://github.com/net-snmp/net-snmp/pull/576
    
    [ bvanassche: edited commit message ]

commit 9df89dc4cf04d27c230736da7d66e3b43911864c
Author: Niels Baggesen <nba@users.sourceforge.net>
Date:   Mon May 22 21:33:28 2023 +0200

    interface_linux.c: defined dummy PCI_NONRET if needed (CentOS7)

commit 8c930d7242b8121cf9f8646d4519aefd8956b30e
Author: Niels Baggesen <nba@users.sourceforge.net>
Date:   Mon May 22 21:31:46 2023 +0200

    apps/Makefile.in: snmpps compiles without libcurses (always have)

commit 76fae1a91eb70ce8231e16e8323a9bf7d8ac62d3
Author: Niels Baggesen <nba@users.sourceforge.net>
Date:   Mon May 22 21:30:21 2023 +0200

    etherStatsTable_interface.c: fix a compare of unsigned < 0

commit 47ea381e97ff551fd530b6a3eee59451905a864e
Author: Niels Baggesen <nba@users.sourceforge.net>
Date:   Mon May 22 21:24:35 2023 +0200

    mibII/ipv6.c: remove unused variables

commit cee200127b43b2858454851390b69551c144bbd3
Author: Niels Baggesen <nba@users.sourceforge.net>
Date:   Mon May 22 21:23:26 2023 +0200

    RUNFULLTESTS: correct a reference to srcdir to builddir

commit 97df191ff8b16bdc53ba95d2a1c064d2a4666ae6
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Oct 8 19:26:01 2022 -0700

    OS/X: Fix the build
    
    Apparently the __fd_mask type has been removed on OS/X. Hence this patch.

commit 0d7022df5cffe44227ab228dcf1fbbc725348138
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Fri Sep 16 15:06:14 2022 -0700

    libsnmp: Fix undefined behavior in large_fd_set.c

commit 08d6f301ba025caad18f2ce60f9bb2700b61c087
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Fri May 12 09:59:57 2023 -0700

    testing/fulltests/support/simple_TESTCONF.sh: Support disabling limits
    
    If NET-SNMP is built with address sanitizer support, the tests fail as follows
    if memory is limited:
    ==225838==ERROR: AddressSanitizer failed to allocate 0xdfff0001000 (15392894357504) bytes at address 2008fff7000 (errno: 12)
    ==225838==ReserveShadowMemoryRange failed while trying to map 0xdfff0001000 bytes. Perhaps you're using ulimit -v
    
    Hence add support for disabling runtime limits.

commit 6fcef3ba7f9cfc9358553cee4e8121841e06278f
Author: Niels Baggesen <nba@users.sourceforge.net>
Date:   Fri May 12 12:55:32 2023 +0200

    snmpIPv4BaseDomain: fix a leak (shows up with agentx)

commit a3caa31fc076edae80e6b78667baac92db3493a7
Author: Niels Baggesen <nba@users.sourceforge.net>
Date:   Fri May 12 09:41:51 2023 +0200

    config_net_snmp_config_h: add missing defines for DragonFlyBSD

commit 042deb1731edc311ef5dbc7f01a8ec045285fbe6
Author: Niels Baggesen <nba@users.sourceforge.net>
Date:   Fri May 12 09:40:38 2023 +0200

    mibsY/rfclist: correct rfcs for DS1/DS3-mibs

commit b23b7fc60ad668c4265a694ebd001504bc206829
Author: Niels Baggesen <nba@users.sourceforge.net>
Date:   Fri May 12 09:39:40 2023 +0200

    traceRouteCtlTable: fix a possible simple return in a non-void function

commit b14b5749892b48081c481dab1bb8ce998be0acdd
Author: Niels Baggesen <nba@users.sourceforge.net>
Date:   Fri May 12 09:38:05 2023 +0200

    Rmon/alarmTable: implement shutdown handler

commit 2d710d2e3de9c81f60740eb7a965d7c8991474b5
Author: Niels Baggesen <nba@users.sourceforge.net>
Date:   Fri May 12 09:36:17 2023 +0200

    agent/extend: fix cleanup at shutdown

commit d6a1af15777981a20778260c25245f36bf7c25a6
Author: Niels Baggesen <nba@users.sourceforge.net>
Date:   Fri May 12 09:34:57 2023 +0200

    apps/snmpusm: fix a memory leak

commit 9e9da9d092eca13ef23570d3e78fc6bdfb456ae0
Author: Niels Baggesen <nba@users.sourceforge.net>
Date:   Wed May 10 10:06:31 2023 +0200

    Yet another #if HAVE_xxx example

commit 2c7bdeda7a54516f6bcb9b26a0bd5058bdb742ef
Author: Niels Baggesen <nba@users.sourceforge.net>
Date:   Wed May 10 10:02:41 2023 +0200

    Use configured [ef]grep to avoid warnings about deprecation

commit ca2334a0cc4e684edcbf1094b19b376c147ee94a
Author: Niels Baggesen <nba@users.sourceforge.net>
Date:   Wed May 10 09:58:08 2023 +0200

    snmpps: add calls to netsnmp_cleanup_session

commit c4f0619e9d1e26aaf1d8332386c296b109fc514f
Author: Niels Baggesen <nba@users.sourceforge.net>
Date:   Wed May 10 09:57:12 2023 +0200

    Fix leak in snmpTargetAddrTable

commit 0a244ec94ea46a789bb3b867e632417f8781370b
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Apr 22 18:20:54 2023 -0700

    testhandler: Fix memory leaks at exit time

commit e42be3a74eb83c270b91feac1e28e9f68f7e5c76
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Thu Sep 15 14:18:17 2022 -0700

    testhandler: Fix memory leaks

commit d84ccab2377aaaa402be1e58f92d2543b577d9c5
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Fri Sep 16 14:48:33 2022 -0700

    testhandler: Declare a local variable static

commit 0dc31dd059913f5d32c1fee3fb8f8a0987307eb2
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Apr 22 18:20:59 2023 -0700

    SNMP-TLS-TM-MIB: Fix leaks at exit time

commit 918a733bb8c4e03b042a5724cb194662d3924e7b
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Apr 23 14:03:32 2023 -0700

    SNMP-TLS-TM-MIB: Reorder function definitions

commit 537c7a6f6fc80b42240781ce45a06febe0567bba
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Apr 22 17:32:15 2023 -0700

    LM-SENSORS-MIB: Fix memory leaks at exit time

commit 18ed7614451b40db393da4e57dfbcb8b96fe5a01
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Fri Apr 21 16:49:56 2023 -0700

    LM-SENSORS-MIB: Reorder function definitions

commit 57d8dcb825c30f6f20941760863a1c8d671a7e8d
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Fri Apr 21 16:17:01 2023 -0700

    DISMAN-EXPRESSION-MIB: Fix memory leaks at exit time

commit dbb52d271d6bee9f162b9c6abe16ddbd064107f3
Author: Niels Baggesen <nba@users.sourceforge.net>
Date:   Mon May 1 21:40:57 2023 +0200

    Fix issue #554 "All commands crash when using -Op"

commit 4d3cd42e6acf55e640abef68daf567ddad3107ae
Author: Niels Baggesen <nba@users.sourceforge.net>
Date:   Mon May 1 21:38:18 2023 +0200

    Another few #if HAVE_xxx and similar fixes

commit 536a09f70b859676b420781f5c73448f7fe7e2b9
Author: Niels Baggesen <nba@users.sourceforge.net>
Date:   Mon May 1 21:36:53 2023 +0200

    Fixes for DragonflyBSD TCP and UDP tables

commit 575dc2129d5707e1f57fefd145dc0a3085018387
Author: Niels Baggesen <nba@users.sourceforge.net>
Date:   Mon May 1 21:35:15 2023 +0200

    Additional fix for build outside source directgory

commit 3eb9ba9f053ea9c8f23c468c77568e125641b745
Author: Niels Baggesen <nba@users.sourceforge.net>
Date:   Mon May 1 21:34:19 2023 +0200

    Remove or hide unused variables

commit 99763268d8e937360ecc618b771c236a8493ec15
Author: Wes Hardaker <opensource@hardakers.net>
Date:   Sat Apr 29 01:33:06 2023 -0700

    version update for 5.9.4.pre3

commit de0217a7698bf9e9fbeaa927f3b0761cbb3a269d
Author: Wes Hardaker <opensource@hardakers.net>
Date:   Sat Apr 29 01:26:11 2023 -0700

    Version number update: 5.9.4.pre3


----------------------------------------------------------------------

Changes: V5.9.4.pre2 -> V5.9.4.pre3

commit de0217a7698bf9e9fbeaa927f3b0761cbb3a269d
Author: Wes Hardaker <opensource@hardakers.net>
Date:   Sat Apr 29 01:26:11 2023 -0700

    Version number update: 5.9.4.pre3

commit 265127456b431b5547a873b8cf6e564938550a6b
Author: Wes Hardaker <opensource@hardakers.net>
Date:   Sat Apr 29 01:23:09 2023 -0700

    Revert "Set flags in MakefileSubs.pm at configure time"
    
    This reverts commit 7e7ce5a6567c47822410a4683be26d2c0fb8b6cc.

commit b29c63d12f7298c0e2c31d8e35fc5c2d87d05b7b
Author: Chris Adams <linux@cmadams.net>
Date:   Mon Mar 13 17:34:17 2023 -0500

    Set flags in MakefileSubs.pm at configure time
    
    Setting the flags at configure time instead of runtime allows use of the
    perl module without pulling in net-snmp-config (which in the Fedora/RHEL
    RPM setup also pulls in gcc and *-devel packages, not otherwise needed
    when just using the perl SNMP module).  The in-tree module is updated
    with the rest of the net-snmp code anyway, so setting this at configure
    time should stay consistent.
    
    Signed-off-by: Chris Adams <linux@cmadams.net>

commit 50c53277b500c0ee18edb7994e73033ff8020f80
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Tue May 5 10:30:32 2020 -0700

    libsnmp: Fix handling of the -a and -x app command line options
    
    Since snmp_free_session() frees securityAuthProto and securityPrivProto,
    allocate these two session members dynamically.
    
    Fixes: 670d4234b519 ("First pass at an SNMPv3 "combined-option" command-line flag (-3x)").

commit 21b16eba60245bc84149d338a9700e5915bda292
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Aug 28 18:11:49 2022 -0700

    apps: Use netsnmp_cleanup_session()
    
    Backport from master.
    
    Free the memory allocated by netsnmp_parse_args() before exiting. This reduces
    the number of memory leaks reported by tools like LeakSanitizer.
    
    Ensure that netsnmp_parse_args() only stores pointers to dynamically allocated
    memory in the session object.

commit 72ec58d82b7ddf64b84da2c072f34800c4350fef
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Aug 28 18:11:31 2022 -0700

    libsnmp: Introduce netsnmp_cleanup_session()
    
    Free all memory owned by a session instead of only a subset of the memory owned
    by a session.
    
    Conflicts:
            include/net-snmp/library/snmp_api.h

commit e8ea0cb1bcc9b96e37895951eb46f04719a10f96
Author: Niels Baggesen <nba@users.sourceforge.net>
Date:   Thu Apr 20 12:06:14 2023 +0200

    Fix for OpenBSD 7.3

commit 461afde75ac0eb8cafbb523c00762ed96a8e15ea
Author: Niels Baggesen <nba@users.sourceforge.net>
Date:   Thu Apr 20 12:02:58 2023 +0200

    Not all make's honor VPATH srcdir. FreeBSD is the culprit here.

commit add75e011eaebee9eca30dd1aac4b9ab282d1626
Author: Niels Baggesen <nba@users.sourceforge.net>
Date:   Thu Apr 20 11:54:59 2023 +0200

    Fix missing free detected by -fsanitize=address

commit cb88cd0809d6be22e7bfb41333c48a171ba91a8f
Author: Andy Fiddaman <omnios@citrus-it.co.uk>
Date:   Fri Jul 29 15:39:13 2022 +0000

    testing/fulltests/support/simple_eval_tools.sh: support non-GNU getopt
    
    Not all implementations of getopt() handle options appearing after
    operands. POSIX doesn't require that, it's a GNU extension.
    Running the testsuite from version 5.9.2+ on such a system results in
    even simple tests failing as the agent attempts to find to port "-f"

commit 0ab769060f6cc12b3e3bcd4ad914b784bfb5cfb0
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Apr 16 15:05:47 2023 -0700

    perl: Check the size of output buffers
    
    Use snprintf() instead of sprintf() for converting an OID into an ASCII
    string.

commit d3f1271a7e5c7b1087c69b0e9fa3a6b16b0dc8b5
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Apr 16 14:12:47 2023 -0700

    configure: Change AC_TRY_COMPILE() into AC_COMPILE_IFELSE()
    
    Make this change because the former macro is obsolete. This patch does
    not change the configure script.

commit a2cb167514ac0c7e1b04e8f151e0b015501362e0
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Apr 16 14:09:24 2023 -0700

    configure: Require that config_() macros are terminated with a semicolon

commit 85cedab5a26f00b8e4a2f42d2e8e37cde546e22d
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Apr 15 15:35:42 2023 -0700

    Terminate all config_*() macro invocations with a semicolon
    
    This patch has been generated by running the following commands:
    
    replace-in-files '^\([[:blank:]]*config_[^,*]*)\)[[:blank:]]*$' '\1;' $(git grep -l '^config_')
    replace-in-files '^\([[:blank:]]*config_version_require.*)\)[[:blank:]]*$' '\1;' $(git grep -l '^config_')

commit 4e593010ef224f3b91fb7c5966788530d9393547
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Apr 16 07:28:35 2023 -0700

    libsnmp, agent, MIBs: Fix multiple buffer overflows

commit 1d738930b09fa9ae651881ed38d94c61c3c88060
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Apr 16 07:28:35 2023 -0700

    libsnmp: Fix a buffer overflow in the MIB parsing code
    
    Fix the following address sanitizer complaint:
    
    ERROR: AddressSanitizer: stack-buffer-overflow on address 0x7f4e612001a0 at pc 0x7f4e63c0a654 bp 0x7ffc98f7bb80 sp 0x7ffc98f7bb78
    WRITE of size 1 at 0x7f4e612001a0 thread T0
        #0 0x7f4e63c0a653 in get_token snmplib/parse.c:4835:13
        #1 0x7f4e63c0a4a2 in get_token snmplib/parse.c:4813:20
        #2 0x7f4e63c0a4a2 in get_token snmplib/parse.c:4813:20
        #3 0x7f4e63c0a4a2 in get_token snmplib/parse.c:4813:20
        #4 0x7f4e63c0a4a2 in get_token snmplib/parse.c:4813:20
        #5 0x7f4e63c0a4a2 in get_token snmplib/parse.c:4813:20
        #6 0x7f4e63c0a4a2 in get_token snmplib/parse.c:4813:20
        #7 0x7f4e63c2dbd2 in parse_ranges snmplib/parse.c:2282:20
        #8 0x7f4e63c29ffa in parse_asntype snmplib/parse.c:2462:27
        #9 0x7f4e63c1789f in parse snmplib/parse.c:4598:19
        #10 0x7f4e63c0497b in read_module_internal snmplib/parse.c:3942:18
        #11 0x7f4e63c0407b in netsnmp_read_module snmplib/parse.c:4041:14
        #12 0x7f4e63c0d5e1 in read_mib snmplib/parse.c:5044:12
        #13 0x55ec21ab37b1 in main testing/fulltests/unit-tests/T027read_mib_clib.c:35:1
    
    Fixes: 34058af3990b ("*/*: replace horrible (char *)"string" with const specifiers in relevant  functions.")

commit f065858b75b7eb10a596a9e5ab0f638cf119209f
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Apr 16 07:24:14 2023 -0700

    libsnmp: Declare the get_token() input arguments const

commit f503e1722960a3b75a86b96c9eb999c8cf5b7b19
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Apr 16 07:45:02 2023 -0700

    libsnmp: Do not pass NULL pointers to memcmp()

commit 3644e682f1ae4e0dc7ab0b33600ef0aead48a86a
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Apr 15 16:26:09 2023 -0700

    libsnmp: Make sure that the memcmp() arguments are not NULL

commit 14150d3e4dbaccaeb347ca56200929735c6d7f51
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Apr 15 16:11:20 2023 -0700

    testing/fulltests/unit-tests/T018read_config_capp.c: Fix a function declaration
    
    This patch fixes a clang compiler warning.

commit fcb439310eb765c90f4a149116690a1e063a04ca
Author: Niels Baggesen <nba@users.sourceforge.net>
Date:   Wed Apr 12 12:40:09 2023 +0200

    Yet another round of #if HAVE_XXX fixes
    
    Some lines that did not follow my simplistic patterns for automatic patching.

commit 2df051f3176c77eab6633fca87e0869e545d9945
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Apr 8 14:43:29 2023 -0700

    Run autoreconf -ivf
    
    Autoconf version: 2.71
    Automake version: 1.16
    Libtool version:  2.4.6

commit e7a268a2ee453d2fa3a364a4bf605b0e6b2d3ae9
Author: Niels Baggesen <nba@users.sourceforge.net>
Date:   Thu Apr 6 13:39:58 2023 +0200

    Update rfclist/Makefile.mib for new IP-TRAFFIC-FLOW-SECURITY-MIB and forgotten SNMP-SSH-TM-MIB


----------------------------------------------------------------------

Changes: V5.9.3 -> V5.9.4.pre2

commit cc275e9a0eaf639dbee2af934419cdcc3fd2881e
Author: Wes Hardaker <opensource@hardakers.net>
Date:   Mon Apr 3 15:06:49 2023 -0700

    autoconf update

commit 428605d00fea8df9a7b8ca14d15ffbdc8b1d4c64
Author: Wes Hardaker <opensource@hardakers.net>
Date:   Mon Apr 3 14:54:04 2023 -0700

    version bump and autoconf bump

commit a739ce6740445d2d2991e2effa1f97c995f5ff0d
Author: Wes Hardaker <opensource@hardakers.net>
Date:   Mon Apr 3 14:53:31 2023 -0700

    version update for 5.9.4.pre2

commit fcd3b9c7e04398f2f3bfa686f8ff1141cbc1eaf9
Author: Wes Hardaker <opensource@hardakers.net>
Date:   Mon Apr 3 14:52:02 2023 -0700

    new-key

commit 9d1c6c02ef7db23e7e894436fcc5b25b758d88b9
Author: Wes Hardaker <opensource@hardakers.net>
Date:   Mon Apr 3 14:41:55 2023 -0700

    changes

commit 6c5bf52dac1ea53b302d523093572fea54cd5d16
Author: Wes Hardaker <opensource@hardakers.net>
Date:   Mon Apr 3 14:41:02 2023 -0700

    autoconf update

commit b4b5fa2f20d8d41f24e778aac0034678508ea71b
Author: Wes Hardaker <opensource@hardakers.net>
Date:   Mon Apr 3 14:40:30 2023 -0700

    changelog update

commit 763e50c1ee89181b1337c2fbdae229884d9facc3
Author: Wes Hardaker <opensource@hardakers.net>
Date:   Mon Apr 3 13:53:02 2023 -0700

    Version number update: 5.9.4.pre1

commit 5846d75426d79a4866411a8768e1effcc4aa808e
Author: Wes Hardaker <opensource@hardakers.net>
Date:   Mon Apr 3 13:49:52 2023 -0700

    revision bump

commit 5840d13ad70607bce15b4ed5cf744a66fd8147c0
Author: Wes Hardaker <opensource@hardakers.net>
Date:   Mon Apr 3 13:46:24 2023 -0700

    autoconf-update

commit 3e918def0de65d5a70239df76588ef2d540c9fb0
Author: Wes Hardaker <opensource@hardakers.net>
Date:   Mon Apr 3 13:45:46 2023 -0700

    bump autoconf version

commit 1efe6dfbd1169550e0c4b625324b6de3702676b6
Author: Wes Hardaker <opensource@hardakers.net>
Date:   Mon Apr 3 13:40:49 2023 -0700

    fix name from snmpbulkget -> snmpbulkwalk

commit c4ed481ffcc64883f135578291c0c34f08415865
Author: Niels Baggesen <nba@users.sourceforge.net>
Date:   Thu Mar 30 12:25:21 2023 +0200

    More "#if HAVE_xxx fixes.
    My original script did not consider blanks between # and if/elif

commit 36c2d1dbbb3503614ed5e339ad365411535c6d24
Author: Niels Baggesen <nba@users.sourceforge.net>
Date:   Thu Mar 9 15:15:14 2023 +0100

    Change "#if HAVE_XXX" into "#ifdef HAVE_XXX"
    
    This fixes a bunch of -Wundef warnings.
    
    [ bvanassche: changed patch subject / restored consistency of the MSVC config
      header files ]

commit 28d127bc71b77220acd94d3cd8ae65f0580263f2
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Wed Mar 8 16:28:04 2023 -0800

    libsnmp: Remove the ERR_GET_FUNC() macro
    
    ERR_GET_FUNC() has been removed from the OpenSSL 3.0 headers. See also
    https://github.com/net-snmp/net-snmp/issues/539.
    
    See also https://github.com/net-snmp/net-snmp/issues/539.

commit baaf82808833ea6eaf254590f9e5cfcc02ef1b39
Author: Niels Baggesen <nba@users.sourceforge.net>
Date:   Mon Feb 27 21:59:16 2023 +0100

    Fixes for OpenBSD 7

commit 906a1e8b92029564341f0768390a02203459561f
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Feb 25 16:47:19 2023 -0800

    configure: Add support for FreeBSD jails
    
    See also https://github.com/net-snmp/net-snmp/issues/280.

commit b0f82764f4ab0b8c6d93378a9b5c2927f2b09509
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Feb 25 16:34:39 2023 -0800

    Spelling: Change 'demon' into 'daemon'
    
    From https://en.wikipedia.org/wiki/Daemon_(computing):
    
    Many people equate the word "daemon" with the word "demon", implying some
    kind of satanic connection between UNIX and the underworld. This is an
    egregious misunderstanding. "Daemon" is actually a much older form of
    "demon"; daemons have no particular bias towards good or evil, but rather
    serve to help define a person's character or personality. The ancient
    Greeks' concept of a "personal daemon" was similar to the modern concept of
    a "guardian angel"-eudaemonia is the state of being helped or protected by a
    kindly spirit. As a rule, UNIX systems seem to be infested with both daemons
    and demons.

commit 24b587b2481acfb878ede6c08bfbd581a21ad1d3
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Thu Feb 23 13:25:52 2023 -0800

    ci, Windows: Bump the OpenSSL version number

commit 91673b10bac84230d8e4964abfab39d31a4e736f
Author: David Rothenberger <daveroth@acm.org>
Date:   Sat Mar 10 21:37:06 2018 +0000

    Cygwin: Use ':' for the path separator
    
    [ bvanassche: edited subject and regenerated the configure script ]

commit 2d1ab96c6b46843c593b54a15ff286fcfe9711a5
Author: Niels Baggesen <nba@users.sourceforge.net>
Date:   Thu Feb 23 11:37:55 2023 +0100

    Updates for NetBSD 10 (now in Beta)
    
    Some of these inspired by (taken from) gthe NetBSD pkgsrc patches.

commit f3c859515e916cdee899255df372a9045b63a82a
Author: Niels Baggesen <nba@users.sourceforge.net>
Date:   Tue Jan 31 12:47:09 2023 +0100

    mibs: Add missing REVISION clause to UCS-DNMP-mib

commit a97098802ae027eb798ab33c6e56b709a870a473
Author: Niels Baggesen <nba@users.sourceforge.net>
Date:   Tue Jan 31 12:09:16 2023 +0100

    mibs: IANAifType-MIB, IANA-ADDRESS-FAMILY-NUMBERS-MIB
    
    Update IANAifType-MIB, IANA-ADDRESS-FAMILY-NUMBERS-MIB to current
    IANA versions.

commit 7e9ec86c929033fc65dd531802ae987cdde04a2a
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Wed Dec 21 16:42:02 2022 -0800

    win32/dist/build-binary.pl: Improve this script
    
    Use the MSYS gzip executable if gzip is not in the path. Change the OpenSSL
    path from the OpenSSL 1 path into the OpenSSL 3 path.

commit 65709b0b201b6890446e50485a77f27696d285c4
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Wed Dec 21 17:08:52 2022 -0800

    ci/perl.bat: Fix a syntax error

commit 49816b48332567d54e1e4d8ce4ac4c42e6c71582
Author: Peter Korsgaard <peter@korsgaard.com>
Date:   Tue Dec 13 15:03:37 2022 +0100

    ipaddress_ioctl.c: unbreak builds with IPv6 but no rtnetlink
    
    netsnmp_access_other_info_get() is only available on setups with rtnetlink,
    so protect the caller with HAVE_LINUX_RTNETLINK_H as well to fix a linking
    issue:
    
    ipaddress_ioctl.c:(.text+0x3be): undefined reference to `netsnmp_access_other_info_get'
    
    Signed-off-by: Peter Korsgaard <peter@korsgaard.com>

commit 1d4d3c7045a1ba6eab28a0aee47b604d62481b68
Author: Peter Korsgaard <peter@korsgaard.com>
Date:   Tue Dec 13 12:41:04 2022 +0100

    ipaddress_linux.c: unbreak builds without HAVE_LINUX_RTNETLINK_H
    
    Commit 89a7860829fdc618ef (IP-MIB: Fix the --disable-ipv6 build) moved
    defines around to fix builds without IPv6 support, but accidently caused
    netsnmp_access_other_info_get() to be visible even if HAVE_LINUX_RTNETLINK_H
    isn't defined, leading to build issues:
    
    mibgroup/ip-mib/data_access/ipaddress_linux.c: In function ‘netsnmp_access_other_info_get’:
    mibgroup/ip-mib/data_access/ipaddress_linux.c:439:28: error: field ‘n’ has incomplete type
                struct nlmsghdr n;
                                ^
    mibgroup/ip-mib/data_access/ipaddress_linux.c:440:29: error: field ‘r’ has incomplete type
                struct ifaddrmsg r;
                                 ^
    mibgroup/ip-mib/data_access/ipaddress_linux.c:454:40: error: ‘NETLINK_ROUTE’ undeclared (first use in this function)
        sd = socket(PF_NETLINK, SOCK_DGRAM, NETLINK_ROUTE);
                                            ^~~~~~~~~~~~~
    mibgroup/ip-mib/data_access/ipaddress_linux.c:454:40: note: each undeclared identifier is reported only once for each function it appears in
    mibgroup/ip-mib/data_access/ipaddress_linux.c:461:22: warning: implicit declaration of function ‘NLMSG_LENGTH’; did you mean ‘CMSG_LEN’? [-Wimplicit-function-declaration]
        req.n.nlmsg_len = NLMSG_LENGTH(sizeof(struct ifaddrmsg));
                          ^~~~~~~~~~~~
                          CMSG_LEN
    mibgroup/ip-mib/data_access/ipaddress_linux.c:461:42: error: invalid application of ‘sizeof’ to incomplete type ‘struct ifaddrmsg’
        req.n.nlmsg_len = NLMSG_LENGTH(sizeof(struct ifaddrmsg));
                                              ^~~~~~
    
    Fix it by also enclosing it within the RTNETLINK and IPV6 guards, similar to
    netsnmp_access_ipaddress_extra_prefix_info().  Given that are already inside
    an IPV6 conditional just above and below, simply reuse that for simplicity.
    
    Signed-off-by: Peter Korsgaard <peter@korsgaard.com>

commit 15f9d7f7e5b90c9b419832ed8e6413feb6570d83
Author: Bill Fenner <fenner@gmail.com>
Date:   Fri Nov 25 10:23:32 2022 -0800

    Add test for NULL varbind set

commit 7f4ac4051cc7fec6a5944661923acb95cec359c7
Author: Bill Fenner <fenner@gmail.com>
Date:   Fri Nov 25 08:41:46 2022 -0800

    apps: snmpset: allow SET with NULL varbind for testing

commit 4589352dac3ae111c7621298cf231742209efd9b
Author: Bill Fenner <fenner@gmail.com>
Date:   Fri Nov 25 08:41:24 2022 -0800

    snmp_agent: disallow SET with NULL varbind

commit fd898757b47ba0eb0af204ae6f4283be82ab59b8
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Wed Nov 16 19:54:38 2022 -0800

    ci, Windows: Bump the OpenSSL version number

commit f362b354ce993d7394bf77db41bb27cfe8d1e307
Author: Sam James <sam@gentoo.org>
Date:   Thu Nov 17 00:20:04 2022 +0000

    agent: fix -Wincompatible-function-pointer-types
    
    Clang 16 makes -Wincompatible-function-pointer-types an error by default.
    
    Fixes the following error:
    ```
    mibgroup/if-mib/data_access/interface_linux.c:159:23: error: incompatible function pointer types assigning to 'void (*)(char *, ...) __attribute__((noreturn))' from 'void (char *, ...)' [-Wincompatible-function-pointer-types]
        pci_access->error = netsnmp_pci_error;
                          ^ ~~~~~~~~~~~~~~~~~
    1 error generated.
    ```
    
    Signed-off-by: Sam James <sam@gentoo.org>

commit fec0f9ee59d5d89c28d70bb35fad29a0013d048c
Author: Sam James <sam@gentoo.org>
Date:   Thu Nov 17 00:13:55 2022 +0000

    agent/mibgroup: fix -Wstrict-prototypes
    
    Clang 16 warns on this. Fix it in preparation for C23.
    
    Signed-off-by: Sam James <sam@gentoo.org>
    [ bvanassche: minor formatting changes ]

commit ddec5fa0ed1c76fde5eea9b974442faeec008526
Author: Sam James <sam@gentoo.org>
Date:   Thu Nov 17 00:10:09 2022 +0000

    configure.d: fix compatibility with Clang 16
    
    Clang 16 makes -Wimplicit-function-declaration and -Wimplicit-int an error by
    default. Unfortunately, this can lead to misconfiguration or miscompilation of
    software as configure tests may then return the wrong result.
    
    We also fix -Wstrict-prototypes while here as it's easy to do and it prepares
    us for C23.
    
    For more information, see LWN.net [0] or LLVM's Discourse [1], the Gentoo wiki
    [2], or the (new) c-std-porting mailing list [3].
    
    [0] https://lwn.net/Articles/913505/
    [1] https://discourse.llvm.org/t/configure-script-breakage-with-the-new-werror-implicit-function-declaration/65213
    [2] https://wiki.gentoo.org/wiki/Modern_C_porting
    [3] hosted at lists.linux.dev.
    
    Bug: https://bugs.gentoo.org/879715
    Signed-off-by: Sam James <sam@gentoo.org>
    [ bvanassche: removed two header file guards ]

commit d420ff6cd3a3bd8ae469fc2d6a0bafd523280794
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Fri Nov 4 06:32:46 2022 -0700

    CHANGES: libsnmp: Restore support for DNS names longer than 63 characters
    
    Fixes: 0b637fea62c7 ("libsnmp/transports: Introduce netsnmp_parse_ep_str()")
    Fixes: https://github.com/net-snmp/net-snmp/issues/476

commit 923cb442bbef360de227fbca565710518b5ee8e5
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Fri Nov 4 06:38:06 2022 -0700

    CHANGES: libsnmp: Make the snmpIPBaseDomain.h header file private
    
    Before making backwards-incompatible changes in snmpIPBaseDomain.h, make this
    header file private. This patch removes several symbols from the ABI.

commit dffe26c0bd9a4f62dc9cd7b267fa7dded867ceee
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Thu Oct 6 11:14:01 2022 -0700

    agent/mibgroup/ucd-snmp/pass_persist: Fix a regression in pass_persist SET handling
    
    Fixes: 9b9c0e287b4d ("MIBs: Use asprintf() instead of snprintf() to prevent truncation")
    Fixes: https://github.com/net-snmp/net-snmp/issues/461

commit f494348b8e352845db787ea4eef256c012caf99c
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Tue Sep 13 15:41:29 2022 -0700

    FreeBSD: Introduce a function for querying the reassembly timeout

commit 0b243e508c38c9d989e4df51adc526c390939087
Author: Gleb Smirnoff <glebius@FreeBSD.org>
Date:   Sat Aug 20 12:26:08 2022 -0700

    configure: Fix the TCPTV_NEEDS_HZ test
    
    In configure search for existing defines, and actually those defines
    that we are later going to use in code - TCPTV_MIN, TCPTV_REXMTMAX.
    TCPTV_SRTTDFLT is not existing in FreeBSD for a long time, hence this
    check always failed, while it should not, and we were compiling wrong
    code in mibII/tcp.c.  Update comment removing old FreeBSD version,
    leaving FreeBSD.
    
    Fixes #445
    
    [ bvanassche: regenerated the configure script / edited the patch description ]

commit f4e5175efbb95d2267cad7c15ab2edc58d73be66
Author: Gleb Smirnoff <glebius@FreeBSD.org>
Date:   Sat Aug 20 13:43:48 2022 -0700

    agent: fix ipReasmTimeout on FreeBSD 14
    
    FreeBSD 14 retired definition of PR_SLOWTIMO and to facilitate
    SNMP daemons provides a value to retrieve IP fragment TTL at
    runtime via sysctl.

commit e2507e6bce249fe98f659b3d4ed43022757961ca
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Tue Jul 26 06:51:57 2022 -0700

    Remove superfluous casts from free() calls
    
    This patch does not change any functionality.

commit f4d4e4ec19e3eaf03bf47c62561461cb16249207
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Tue Jul 26 06:55:28 2022 -0700

    CHANGES: libsnmp: Remove the SNMP_SWIPE_MEM() macro
    
    Remove this macro since it is not used in the Net-SNMP code base.

commit bc3ebfe12665d38b9b1496302a25089070fcf0e0
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Jul 24 18:14:51 2022 -0700

    ci: Also build the disable-set, mini and read-only modes
    
    Leave out the minimalist mode for now since the minimalist build is broken.

commit 51f315046a0bec13934930edde9c145b31bf7d53
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Jul 24 16:45:05 2022 -0700

    agent/Makefile.in: Unbreak the --enable-minimalist build
    
    Build the features rules in the mibgroup directory before building the
    features rules in the helpers directory.
    
    Fixes: 51128ad09507 ("agent/Makefile.in: Build the MIB module code once")
    Fixes: https://github.com/net-snmp/net-snmp/issues/438

commit 53ea215ce2f02e392a188aee2ad1e34c05348fa2
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Jul 24 15:56:19 2022 -0700

    Makefile.rules: Simplify the ftsubdirs code
    
    Other than adding two echo statements, this patch does not change any
    functionality.

commit 9714a9bdb717dac827920891569d894e3f3797c0
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Jul 24 15:36:52 2022 -0700

    Makefile.in: Shorten the include path
    
    Leave out the Net-SNMP top directory and also the agent/mibgroup directory
    from the include file path.

commit fe52cb48caa0a1b7cb1ac92cddd232b4fb2c5120
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Fri Jul 22 06:51:28 2022 -0700

    NET-SNMP-EXTEND-MIB: Fix a buffer overflow
    
    Fixes: https://github.com/net-snmp/net-snmp/issues/437

commit 2e8e6086440269337cd37fbd8ac3efbd32b052c9
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Tue Jul 5 09:21:26 2022 -0700

    snmptrapd: Rework support for old MySQL versions
    
    Older versions of MySQL had to be initialized by calling MY_INIT() while
    newer versions have to be initialized by calling mysql_init(). Only include
    the old header files if mysql_init() is not supported.
    
    Fixes: https://github.com/net-snmp/net-snmp/issues/433

commit 11f4cf41fb84db5fc4873851faaca34cb93b9680
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Wed Jul 6 19:03:44 2022 -0700

    ci, Windows: Bump the OpenSSL version number

commit 20564b54eba953403ca83f36ce07a76e3ddeb393
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Wed Jul 6 16:00:54 2022 -0700

    ci: Ignore package installation failures

commit 448bcbf0ccd1216b70ba7101cf24fa17fe3de25c
Author: Wes Hardaker <opensource@hardakers.net>
Date:   Tue Jul 5 08:27:17 2022 -0700

    increment 'libcurrent'

commit 1048dd76799e2b7890844013e0fd55f5fdb80aa6
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Mon Jul 4 17:45:27 2022 -0700

    testing/fulltests/snmpv3/T050etimetest_capp: Suppress a set-but-not-used variable warning

commit 0fb09cf24425e2f35a33cee744424d8e625feb66
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Mon Jul 4 17:34:05 2022 -0700

    .gitignore: Update

commit 964d028dce7125391548d4790dac92e2d6767bdc
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Mon Jul 4 17:30:03 2022 -0700

    ci: Move the code for rewriting /etc/hosts
    
    This patch fixes the following oss-fuzz warning:
    
    net-snmp/ci/install.sh: line 6: sudo: command not found

commit e87d0066e36c89bd80e419be298cd8f414d4980c
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Mon Jul 4 17:05:40 2022 -0700

    Python: Stop using the ... package
    
    This patch fixes the following warning:
    
    python/setup.py:1: DeprecationWarning: The distutils package is deprecated and slated for removal in Python 3.12. Use setuptools or check PEP 632 for potential alternatives
      from distutils.core import setup, Extension

commit f1fa5c8b5404d449a7241def319c3b4ac325926b
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Mon Jul 4 16:57:22 2022 -0700

    snmpps: Use #ifdef instead of #if to test HAVE_* macros
    
    This patch suppresses the following compiler warning:
    
    snmpps.c:70:5: warning: 'HAVE_NCURSES_CURSES_H' is not defined, evaluates to 0 [-Wundef]

commit b883086e82d984d411f029e8fef777614867a1ff
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Jul 2 16:25:22 2022 -0700

    ci, Windows: Bump the OpenSSL version number

----------------------------------------------------------------------

Changes: V5.9.3.rc1 -> V5.9.3

commit d6644ac380a3563b3bce8400d62c789604695447
Author: Wes Hardaker <opensource@hardakers.net>
Date:   Wed Jul 13 10:43:01 2022 -0700

    drop rc

commit 47d4972916e4cbbc5c8df65f1546c5e1b8632928
Author: Wes Hardaker <opensource@hardakers.net>
Date:   Wed Jul 13 10:42:39 2022 -0700

    Version number update: 5.9.3

----------------------------------------------------------------------

Changes: V5.9.2 -> V5.9.3.rc1

commit ca067c485f06e330a0db13c88ad7321124a0b22a
Author: Wes Hardaker <opensource@hardakers.net>
Date:   Wed Jul 6 07:39:29 2022 -0700

    Release Candidate for V5-9-3-branch

commit e672baf238ebb7e80b03d0191345f14afaf5a311
Author: Wes Hardaker <opensource@hardakers.net>
Date:   Wed Jul 6 07:39:27 2022 -0700

    Version number update: 5.9.3.rc1

commit 035216c0fae83dd8e37b0e5b504d4f8b7076b56f
Author: Wes Hardaker <opensource@hardakers.net>
Date:   Tue Jul 5 08:27:17 2022 -0700

    increment 'libcurrent'

----------------------------------------------------------------------

Changes: V5.9.2.rc2 -> V5.9.2

commit 1154e3cd9b280f39cc956d21327ff1abcefae4fd
Author: Wes Hardaker <opensource@hardakers.net>
Date:   Thu Jun 30 16:38:13 2022 -0700

    reopen 5.9 patches

commit 9705b5f1414b3092934eb3879483dc3e831f7b7b
Author: Wes Hardaker <opensource@hardakers.net>
Date:   Thu Jun 30 16:37:21 2022 -0700

    Version number update: 5.9.2

----------------------------------------------------------------------

Changes: V5.9.2.rc1 -> V5.9.2.rc2

commit 1b7564a375c4e8b2ca2282a2a2ec5c9b19d6a4dc
Author: Wes Hardaker <opensource@hardakers.net>
Date:   Wed Jun 22 15:01:30 2022 -0700

    Version number update: 5.9.2.rc2

commit ce66eb97c17aa9a48bc079be7b65895266fa6775
Author: Wes Hardaker <opensource@hardakers.net>
Date:   Wed Jun 22 15:00:17 2022 -0700

    updates to CHANGES/NEWS

commit a8ea1e4aadc542aebda46a09258aec76f71b19e9
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Jun 12 20:00:34 2022 -0700

    ci/perl.bat: Bump the Perl version

commit 4022d51d5036bd4b0fb80c92d58e375bc51b0b96
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Jun 12 09:32:29 2022 -0700

    ci, Windows: Bump the OpenSSL version number

commit ab410b3628b4aa8e8d51d72a03bcdba6fdfdcc7e
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Thu May 5 21:11:12 2022 -0700

    configure: Regenerate with the correct version of autotools
    
    Fixes: 9e188ca935f3 ("Version number update: 5.9.2.rc1")

----------------------------------------------------------------------

Changes: V5.9.2.rc2 -> V5.9.2

commit 1154e3cd9b280f39cc956d21327ff1abcefae4fd
Author: Wes Hardaker <opensource@hardakers.net>
Date:   Thu Jun 30 16:38:13 2022 -0700

    reopen 5.9 patches

commit 9705b5f1414b3092934eb3879483dc3e831f7b7b
Author: Wes Hardaker <opensource@hardakers.net>
Date:   Thu Jun 30 16:37:21 2022 -0700

    Version number update: 5.9.2

----------------------------------------------------------------------

Changes: V5.9.2.rc1 -> V5.9.2.rc2

commit 1b7564a375c4e8b2ca2282a2a2ec5c9b19d6a4dc
Author: Wes Hardaker <opensource@hardakers.net>
Date:   Wed Jun 22 15:01:30 2022 -0700

    Version number update: 5.9.2.rc2

commit ce66eb97c17aa9a48bc079be7b65895266fa6775
Author: Wes Hardaker <opensource@hardakers.net>
Date:   Wed Jun 22 15:00:17 2022 -0700

    updates to CHANGES/NEWS

commit a8ea1e4aadc542aebda46a09258aec76f71b19e9
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Jun 12 20:00:34 2022 -0700

    ci/perl.bat: Bump the Perl version

commit 4022d51d5036bd4b0fb80c92d58e375bc51b0b96
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Jun 12 09:32:29 2022 -0700

    ci, Windows: Bump the OpenSSL version number

commit ab410b3628b4aa8e8d51d72a03bcdba6fdfdcc7e
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Thu May 5 21:11:12 2022 -0700

    configure: Regenerate with the correct version of autotools
    
    Fixes: 9e188ca935f3 ("Version number update: 5.9.2.rc1")

----------------------------------------------------------------------

Changes: V5.9.2.pre1 -> V5.9.2.rc1

commit 88766d759bdf998d645fb09f050d4701dd39b2b2
Author: Wes Hardaker <opensource@hardakers.net>
Date:   Thu Apr 21 15:35:47 2022 -0700

    Release Candidate for V5-9-patches

commit 9e188ca935f3cc84110973decb7efb5be42989b9
Author: Wes Hardaker <opensource@hardakers.net>
Date:   Thu Apr 21 15:35:45 2022 -0700

    Version number update: 5.9.2.rc1

commit 37dd47517ece80209f1eb0bd82235a7bd50a00c3
Author: Stuart Henderson <stu@spacehopper.org>
Date:   Tue Apr 12 09:59:55 2022 +0100

    libsnmp: Don't try to install factory.h
    
    87d45755edd made factory.h a private header, but snmplib/Makefile.in
    continues to try to install it from include/net-snmp/library, resulting
    in an error from "make install".
    
    Fixes: https://github.com/net-snmp/net-snmp/pull/417

commit 9adb432e1a23d3114e1074a0d0b088024a402108
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Wed Apr 6 13:57:51 2022 -0700

    ci, Windows: Bump the OpenSSL version number

commit b33d6bbe72b26a5b2a8cced96178c6de1105181f
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Tue Apr 5 12:57:32 2022 -0700

    python: Return 'None' instead of an object for GET requests of non-existing OIDs
    
    Fixes: https://github.com/net-snmp/net-snmp/issues/414

commit d3d939f27286bab91e7316c4fa6b9e224621ec0c
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Tue Apr 5 12:49:42 2022 -0700

    python: Add a unit test for a non-existing OID

----------------------------------------------------------------------

Changes: V5.9.1 -> V5.9.2.pre1

commit 8c55dc5fd5165017965abef158a343719eefde60
Author: Wes Hardaker <opensource@hardakers.net>
Date:   Tue Apr 5 08:46:11 2022 -0700

    Version number update: 5.9.2.pre1

commit d9611b05980423f0cf0c72408681af8d3d44e969
Author: Wes Hardaker <opensource@hardakers.net>
Date:   Tue Apr 5 08:46:03 2022 -0700

    version update for 5.9.2.pre1

commit 7d4289129d4bd6e6fae5dc4470d2a5953fa3281f
Author: lijog <george.lijo@gmail.com>
Date:   Fri Feb 25 20:58:52 2022 -0800

    Solaris: Fix ifHighSpeed
    
    The ifHighSpeed value is not being fetched correctly for Solaris systems as
    seen in the following example. For a 10Gbps interface, we see
    
    > snmpwalk -v 2c -c public localhost ifdescr
    IF-MIB::ifDescr.2 = STRING: net0
    > snmpwalk -v 2c -c public localhost ifspeed
    IF-MIB::ifSpeed.2 = Gauge32: 1410065408
    > snmpwalk -v 2c -c public localhost ifHighSpeed
    IF-MIB::ifHighSpeed.1 = Gauge32: 127
    IF-MIB::ifHighSpeed.2 = Gauge32: 1410
    > dladm show-phys -Z
    LINK            ZONE      MEDIA         STATE      SPEED  DUPLEX    DEVICE
    net0            global    Ethernet      up         10000  full      ixgbe0
    > kstat -p|grep speed
    ....
    ixgbe:0:phys:ifspeed    10000000000   //10Gbps
    ..
    
    The expected output is  10000000000 expressed in Mbps, i.e 10000
    IF-MIB::ifSpeed.2 = Gauge32: 10000
    
    The issue occurs as we are using an integer(Gauge) type to fetch the ifspeed
    value and simply convert it into Mbps for the ifHighSpeed value, which will
    fail for speeds > INT_MAX-1.
    
    From the net-snmp documentation at
    http://www.net-snmp.org/docs/mibs/interfaces.html: "An estimate of the
    interface's current bandwidth in bits per second.  For interfaces which do
    not vary in bandwidth or for those where no accurate estimation can be made,
    this object should contain the nominal bandwidth. If the bandwidth of the
    interface is greater than the maximum value reportable by this object then
    this object should report its maximum value (4,294,967,295) and ifHighSpeed
    must be used to report the interace's speed.  For a sub-layer which has no
    concept of bandwidth, this object should be zero."
    
    The fix will use a uint64 type for storing the ifspeed value, and will
    display the ifspeed value as per the docs.
    
    Here's the output after applying the fix
    > snmpwalk -c public -v 2c localhost ifSpeed
    IF-MIB::ifSpeed.2 = Gauge32: 4294967295
    > snmpwalk -c public -v 2c localhost ifHighSpeed
    IF-MIB::ifHighSpeed.2 = Gauge32: 10000
    
    Fixes: https://github.com/net-snmp/net-snmp/pull/409
    [ bvanassche: reformatted commit message / combined four patches into one ]

commit d45fe61a133449b6bc47f2d2b51f7636b7b343e0
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Mon Jan 3 17:18:30 2022 -0800

    snmptrap: Improve documentation of the 'AGENT' argument
    
    Fixes: https://github.com/net-snmp/net-snmp/issues/395

commit 28e3bb4f9ff78f32ee968d6d76c8a3c04b761abe
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Tue Dec 28 14:11:57 2021 -0800

    libsnmp: snmpSTDDomain: Remove an exit() call
    
    Apparently calling exit() from a child process confuses oss-fuzz. Hence
    remove the exit() call from the child process. This patch does not change
    any functionality.

commit 0ccf55e7e9c19c8e23bd94b19901ed8692423293
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Tue Dec 28 14:03:18 2021 -0800

    libsnmp: Fix a memory leak in an error path of parse_objectid()
    
    Link newly allocated nodes earlier such that these are freed from the
    error path.
    
    Fixes: https://bugs.chromium.org/p/oss-fuzz/issues/detail?id=39320
    Fixes: 5201c852e0f6 ("Initial revision")

commit 8c3a094fbe9ebe38ed762488082d52c6d4e04ddb
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Dec 25 13:02:06 2021 -0800

    configure: Use pkg-config to detect the OpenSSL dependencies
    
    Which libraries must be linked in addition to the ssl library depends on the
    configuration of OpenSSL and on the platform. Hence use pkg-config to detect
    these libraries if pkg-config is available. Provide a fallback if pkg-config
    is not available. See also "compile fails with net-snmp-5.8 and openssl-1.1.1d"
    (https://github.com/net-snmp/net-snmp/issues/25).

commit 672e23a3f7a0f54961f9aa1e927f5064a0c1969e
Author: Giulio Benetti <giulio.benetti@micronovasrl.com>
Date:   Wed Sep 12 20:16:39 2018 +0200

    configure, static linking: Fix SSL checks
    
    During checking of DTLS_method, the stub program is linked only with -ssl
    libssl.a lacks some function from -lcrypto:
    RAND_*()
    ERR_*()
    BUF_MEM_*()
    etc.
    and -lz:
    - inflate()
    - deflate()
    
    Append -lcrypto and -lz to LIBS variable when checking DTLS_method.
    
    See also https://sourceforge.net/p/net-snmp/patches/1374/ .
    
    Signed-off-by: Giulio Benetti <giulio.benetti@micronovasrl.com>
    [bvanassche: Edited subject / rewrote this patch]

commit 72dee028836d233979e4563ce3c3d5e303e0e042
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Mon Dec 20 09:23:48 2021 -0800

    CHANGES: net-snmp-create-v3-user: Fix the snmpd.conf path
    
    @datadir@ is expanded in ${datarootdir} so datarootdir must be set before
    @datadir@ is used. See also
    https://github.com/net-snmp/net-snmp/pull/394 .
    
    Fixes: d784eb53f38a ("NEWS: misc: separate user management from net-snmp-config into new net-snmp-create-v3-user script")

commit f5cc42798c996796ec04e38d67f5589153353bd8
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Fri Dec 17 09:12:37 2021 -0800

    ci/openssl.bat: Bump the OpenSSL version

commit bd7394d5d266916d655b804e5b40bc0673030ccd
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Dec 12 13:08:25 2021 -0800

    CHANGES: Win32: winExtDLL: Load evntagnt.dll and lmmib2.dll by default
    
    Load those two DLLs except if these are excluded by e.g. -I-lmmib2.dll.
    Work around generic errors for all OIDs with prefix .1.3.6.1.4.1.77.

commit fc4591ff585f62b28af2d118b72d21a928381295
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Dec 12 13:42:45 2021 -0800

    Improve Doxygen documentation
    
    Remove $(srcdir) since apparently it is no longer supported. Fix most
    warnings about function headers reported by Doxygen 1.9.2.

commit 7f1b973e90ab6736400f72c23f71e4b5ef7726ae
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Dec 12 13:25:35 2021 -0800

    libsnmp: Leave out superfluous parentheses from OID comparison functions
    
    Additionally, improve the Doxygen documentation. This patch does not change
    any functionality.

commit 07dc7379a0ca6e8a8ded03430cc423ae44022920
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Dec 11 14:35:45 2021 -0800

    CHANGES: Win32: winExtDLL: Windows 10 improvements
    
    Load evntagnt.dll and lmmib2.dll on Windows 10. Skip OIDs for which it
    is known that GETNEXT fails with "generic error".

commit af3b5237962cb9b535c2ac8058d7817950776dad
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Dec 11 14:35:21 2021 -0800

    CHANGES: Win32: winExtDLL: Make long strings occupy a single line
    
    Make it easier to look up error messages in the source code by making long
    strings occupy a single source code line.

commit aaafd8c236033c06d3b59354a3236553f976771e
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Dec 11 15:59:52 2021 -0800

    CHANGES: Win32: winExtDLL: Fix multiple compiler warnings

commit 51818e49b244fc9eed0edb6afcdae27f3e476d6a
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Dec 11 14:26:03 2021 -0800

    README.win32: Remove references to Cygwin
    
    Since Net-SNMP users use MinGW instead of Cygwin, remove the instructions
    about how to build Net-SNMP for Cygwin. Additionally, mention that
    Net-SNMP must be built in 32-bit mode to use winExtDLL and also that
    snmp_mib must be excluded.

commit 8e433146c79bb09a3daff012e609094ad5a83712
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Fri Dec 10 20:37:36 2021 -0800

    CHANGES: Win32: winExtDLL: Restore MIB-II support
    
    Commit 59b4d40f3970 ("CHANGES: Windows: Make winExtDLL work on 64-bit
    Windows systems") caused snmpd to skip MIB-II on 64-bit systems. Revert
    that change such that the Windows MIB-II implementation can be used on
    Windows 10. See also:
    * https://github.com/net-snmp/net-snmp/issues/383
    * https://github.com/net-snmp/net-snmp/issues/388
    
    With this patch applied, I see the following output in a Windows VM:
    $ /c/usr/bin/snmpwalk -v2c -cpublic localhost .1.3.6.1.2.1.2
    IF-MIB::ifNumber.0 = INTEGER: 9
    IF-MIB::ifIndex.1 = INTEGER: 1
    IF-MIB::ifIndex.2 = INTEGER: 2
    IF-MIB::ifIndex.3 = INTEGER: 3
    IF-MIB::ifIndex.4 = INTEGER: 4
    IF-MIB::ifIndex.5 = INTEGER: 5
    IF-MIB::ifIndex.6 = INTEGER: 6
    IF-MIB::ifIndex.7 = INTEGER: 7
    IF-MIB::ifIndex.8 = INTEGER: 8
    IF-MIB::ifIndex.9 = INTEGER: 9
    IF-MIB::ifDescr.1 = STRING: Software Loopback Interface 1
    IF-MIB::ifDescr.2 = STRING: Microsoft 6to4 Adapter
    IF-MIB::ifDescr.3 = STRING: Microsoft Kernel Debug Network Adapter
    IF-MIB::ifDescr.4 = STRING: Microsoft IP-HTTPS Platform Adapter
    IF-MIB::ifDescr.5 = STRING: Intel(R) 82574L Gigabit Network Connection
    IF-MIB::ifDescr.6 = STRING: Microsoft Teredo Tunneling Adapter
    IF-MIB::ifDescr.7 = STRING: Intel(R) 82574L Gigabit Network Connection-WFP Native MAC Layer LightWeight Filter-0000
    IF-MIB::ifDescr.8 = STRING: Intel(R) 82574L Gigabit Network Connection-QoS Packet Scheduler-0000
    IF-MIB::ifDescr.9 = STRING: Intel(R) 82574L Gigabit Network Connection-WFP 802.3 MAC Layer LightWeight Filter-0000
    IF-MIB::ifType.1 = INTEGER: softwareLoopback(24)
    IF-MIB::ifType.2 = INTEGER: tunnel(131)
    IF-MIB::ifType.3 = INTEGER: ethernetCsmacd(6)
    IF-MIB::ifType.4 = INTEGER: tunnel(131)
    IF-MIB::ifType.5 = INTEGER: ethernetCsmacd(6)
    IF-MIB::ifType.6 = INTEGER: tunnel(131)
    IF-MIB::ifType.7 = INTEGER: ethernetCsmacd(6)
    IF-MIB::ifType.8 = INTEGER: ethernetCsmacd(6)
    IF-MIB::ifType.9 = INTEGER: ethernetCsmacd(6)
    IF-MIB::ifMtu.1 = INTEGER: 1500
    IF-MIB::ifMtu.2 = INTEGER: 0
    IF-MIB::ifMtu.3 = INTEGER: 0
    IF-MIB::ifMtu.4 = INTEGER: 0
    IF-MIB::ifMtu.5 = INTEGER: 1500
    IF-MIB::ifMtu.6 = INTEGER: 0
    IF-MIB::ifMtu.7 = INTEGER: 1500
    IF-MIB::ifMtu.8 = INTEGER: 1500
    IF-MIB::ifMtu.9 = INTEGER: 1500
    IF-MIB::ifSpeed.1 = Gauge32: 1073741824
    IF-MIB::ifSpeed.2 = Gauge32: 0
    IF-MIB::ifSpeed.3 = Gauge32: 0
    IF-MIB::ifSpeed.4 = Gauge32: 0
    IF-MIB::ifSpeed.5 = Gauge32: 1000000000
    IF-MIB::ifSpeed.6 = Gauge32: 0
    IF-MIB::ifSpeed.7 = Gauge32: 1000000000
    IF-MIB::ifSpeed.8 = Gauge32: 1000000000
    IF-MIB::ifSpeed.9 = Gauge32: 1000000000
    IF-MIB::ifPhysAddress.1 = STRING:
    IF-MIB::ifPhysAddress.2 = STRING:
    IF-MIB::ifPhysAddress.3 = STRING:
    IF-MIB::ifPhysAddress.4 = STRING:
    IF-MIB::ifPhysAddress.5 = STRING: 52:54:0:bb:6f:2f
    IF-MIB::ifPhysAddress.6 = STRING:
    IF-MIB::ifPhysAddress.7 = STRING: 52:54:0:bb:6f:2f
    IF-MIB::ifPhysAddress.8 = STRING: 52:54:0:bb:6f:2f
    IF-MIB::ifPhysAddress.9 = STRING: 52:54:0:bb:6f:2f
    IF-MIB::ifAdminStatus.1 = INTEGER: up(1)
    IF-MIB::ifAdminStatus.2 = INTEGER: down(2)
    IF-MIB::ifAdminStatus.3 = INTEGER: down(2)
    IF-MIB::ifAdminStatus.4 = INTEGER: down(2)
    IF-MIB::ifAdminStatus.5 = INTEGER: up(1)
    IF-MIB::ifAdminStatus.6 = INTEGER: down(2)
    IF-MIB::ifAdminStatus.7 = INTEGER: up(1)
    IF-MIB::ifAdminStatus.8 = INTEGER: up(1)
    IF-MIB::ifAdminStatus.9 = INTEGER: up(1)
    IF-MIB::ifOperStatus.1 = INTEGER: up(1)
    IF-MIB::ifOperStatus.2 = INTEGER: down(2)
    IF-MIB::ifOperStatus.3 = INTEGER: down(2)
    IF-MIB::ifOperStatus.4 = INTEGER: down(2)
    IF-MIB::ifOperStatus.5 = INTEGER: up(1)
    IF-MIB::ifOperStatus.6 = INTEGER: down(2)
    IF-MIB::ifOperStatus.7 = INTEGER: up(1)
    IF-MIB::ifOperStatus.8 = INTEGER: up(1)
    IF-MIB::ifOperStatus.9 = INTEGER: up(1)
    IF-MIB::ifLastChange.1 = Timeticks: (0) 0:00:00.00
    IF-MIB::ifLastChange.2 = Timeticks: (0) 0:00:00.00
    IF-MIB::ifLastChange.3 = Timeticks: (0) 0:00:00.00
    IF-MIB::ifLastChange.4 = Timeticks: (0) 0:00:00.00
    IF-MIB::ifLastChange.5 = Timeticks: (0) 0:00:00.00
    IF-MIB::ifLastChange.6 = Timeticks: (0) 0:00:00.00
    IF-MIB::ifLastChange.7 = Timeticks: (0) 0:00:00.00
    IF-MIB::ifLastChange.8 = Timeticks: (0) 0:00:00.00
    IF-MIB::ifLastChange.9 = Timeticks: (0) 0:00:00.00
    IF-MIB::ifInOctets.1 = Counter32: 0
    IF-MIB::ifInOctets.2 = Counter32: 0
    IF-MIB::ifInOctets.3 = Counter32: 0
    IF-MIB::ifInOctets.4 = Counter32: 0
    IF-MIB::ifInOctets.5 = Counter32: 3902284436
    IF-MIB::ifInOctets.6 = Counter32: 0
    IF-MIB::ifInOctets.7 = Counter32: 3902284436
    IF-MIB::ifInOctets.8 = Counter32: 3902284436
    IF-MIB::ifInOctets.9 = Counter32: 3902284436
    IF-MIB::ifInUcastPkts.1 = Counter32: 0
    IF-MIB::ifInUcastPkts.2 = Counter32: 0
    IF-MIB::ifInUcastPkts.3 = Counter32: 0
    IF-MIB::ifInUcastPkts.4 = Counter32: 0
    IF-MIB::ifInUcastPkts.5 = Counter32: 265150678
    IF-MIB::ifInUcastPkts.6 = Counter32: 0
    IF-MIB::ifInUcastPkts.7 = Counter32: 265150678
    IF-MIB::ifInUcastPkts.8 = Counter32: 265150678
    IF-MIB::ifInUcastPkts.9 = Counter32: 265150678
    IF-MIB::ifInNUcastPkts.1 = Counter32: 0
    IF-MIB::ifInNUcastPkts.2 = Counter32: 0
    IF-MIB::ifInNUcastPkts.3 = Counter32: 0
    IF-MIB::ifInNUcastPkts.4 = Counter32: 0
    IF-MIB::ifInNUcastPkts.5 = Counter32: 28
    IF-MIB::ifInNUcastPkts.6 = Counter32: 0
    IF-MIB::ifInNUcastPkts.7 = Counter32: 28
    IF-MIB::ifInNUcastPkts.8 = Counter32: 28
    IF-MIB::ifInNUcastPkts.9 = Counter32: 28
    IF-MIB::ifInDiscards.1 = Counter32: 0
    IF-MIB::ifInDiscards.2 = Counter32: 0
    IF-MIB::ifInDiscards.3 = Counter32: 0
    IF-MIB::ifInDiscards.4 = Counter32: 0
    IF-MIB::ifInDiscards.5 = Counter32: 0
    IF-MIB::ifInDiscards.6 = Counter32: 0
    IF-MIB::ifInDiscards.7 = Counter32: 0
    IF-MIB::ifInDiscards.8 = Counter32: 0
    IF-MIB::ifInDiscards.9 = Counter32: 0
    IF-MIB::ifInErrors.1 = Counter32: 0
    IF-MIB::ifInErrors.2 = Counter32: 0
    IF-MIB::ifInErrors.3 = Counter32: 0
    IF-MIB::ifInErrors.4 = Counter32: 0
    IF-MIB::ifInErrors.5 = Counter32: 0
    IF-MIB::ifInErrors.6 = Counter32: 0
    IF-MIB::ifInErrors.7 = Counter32: 0
    IF-MIB::ifInErrors.8 = Counter32: 0
    IF-MIB::ifInErrors.9 = Counter32: 0
    IF-MIB::ifInUnknownProtos.1 = Counter32: 0
    IF-MIB::ifInUnknownProtos.2 = Counter32: 0
    IF-MIB::ifInUnknownProtos.3 = Counter32: 0
    IF-MIB::ifInUnknownProtos.4 = Counter32: 0
    IF-MIB::ifInUnknownProtos.5 = Counter32: 0
    IF-MIB::ifInUnknownProtos.6 = Counter32: 0
    IF-MIB::ifInUnknownProtos.7 = Counter32: 0
    IF-MIB::ifInUnknownProtos.8 = Counter32: 0
    IF-MIB::ifInUnknownProtos.9 = Counter32: 0
    IF-MIB::ifOutOctets.1 = Counter32: 0
    IF-MIB::ifOutOctets.2 = Counter32: 0
    IF-MIB::ifOutOctets.3 = Counter32: 0
    IF-MIB::ifOutOctets.4 = Counter32: 0
    IF-MIB::ifOutOctets.5 = Counter32: 1952733666
    IF-MIB::ifOutOctets.6 = Counter32: 0
    IF-MIB::ifOutOctets.7 = Counter32: 1952733666
    IF-MIB::ifOutOctets.8 = Counter32: 1952733666
    IF-MIB::ifOutOctets.9 = Counter32: 1952733666
    IF-MIB::ifOutUcastPkts.1 = Counter32: 0
    IF-MIB::ifOutUcastPkts.2 = Counter32: 0
    IF-MIB::ifOutUcastPkts.3 = Counter32: 0
    IF-MIB::ifOutUcastPkts.4 = Counter32: 0
    IF-MIB::ifOutUcastPkts.5 = Counter32: 137686780
    IF-MIB::ifOutUcastPkts.6 = Counter32: 0
    IF-MIB::ifOutUcastPkts.7 = Counter32: 137686780
    IF-MIB::ifOutUcastPkts.8 = Counter32: 137686780
    IF-MIB::ifOutUcastPkts.9 = Counter32: 137686780
    IF-MIB::ifOutNUcastPkts.1 = Counter32: 0
    IF-MIB::ifOutNUcastPkts.2 = Counter32: 0
    IF-MIB::ifOutNUcastPkts.3 = Counter32: 0
    IF-MIB::ifOutNUcastPkts.4 = Counter32: 0
    IF-MIB::ifOutNUcastPkts.5 = Counter32: 115
    IF-MIB::ifOutNUcastPkts.6 = Counter32: 0
    IF-MIB::ifOutNUcastPkts.7 = Counter32: 115
    IF-MIB::ifOutNUcastPkts.8 = Counter32: 115
    IF-MIB::ifOutNUcastPkts.9 = Counter32: 115
    IF-MIB::ifOutDiscards.1 = Counter32: 0
    IF-MIB::ifOutDiscards.2 = Counter32: 0
    IF-MIB::ifOutDiscards.3 = Counter32: 0
    IF-MIB::ifOutDiscards.4 = Counter32: 0
    IF-MIB::ifOutDiscards.5 = Counter32: 0
    IF-MIB::ifOutDiscards.6 = Counter32: 0
    IF-MIB::ifOutDiscards.7 = Counter32: 0
    IF-MIB::ifOutDiscards.8 = Counter32: 0
    IF-MIB::ifOutDiscards.9 = Counter32: 0
    IF-MIB::ifOutErrors.1 = Counter32: 0
    IF-MIB::ifOutErrors.2 = Counter32: 0
    IF-MIB::ifOutErrors.3 = Counter32: 0
    IF-MIB::ifOutErrors.4 = Counter32: 0
    IF-MIB::ifOutErrors.5 = Counter32: 0
    IF-MIB::ifOutErrors.6 = Counter32: 0
    IF-MIB::ifOutErrors.7 = Counter32: 0
    IF-MIB::ifOutErrors.8 = Counter32: 0
    IF-MIB::ifOutErrors.9 = Counter32: 0
    IF-MIB::ifOutQLen.1 = Gauge32: 0
    IF-MIB::ifOutQLen.2 = Gauge32: 0
    IF-MIB::ifOutQLen.3 = Gauge32: 0
    IF-MIB::ifOutQLen.4 = Gauge32: 0
    IF-MIB::ifOutQLen.5 = Gauge32: 0
    IF-MIB::ifOutQLen.6 = Gauge32: 0
    IF-MIB::ifOutQLen.7 = Gauge32: 0
    IF-MIB::ifOutQLen.8 = Gauge32: 0
    IF-MIB::ifOutQLen.9 = Gauge32: 0
    IF-MIB::ifSpecific.1 = OID: SNMPv2-SMI::zeroDotZero
    IF-MIB::ifSpecific.2 = OID: SNMPv2-SMI::zeroDotZero
    IF-MIB::ifSpecific.3 = OID: SNMPv2-SMI::zeroDotZero
    IF-MIB::ifSpecific.4 = OID: SNMPv2-SMI::zeroDotZero
    IF-MIB::ifSpecific.5 = OID: SNMPv2-SMI::zeroDotZero
    IF-MIB::ifSpecific.6 = OID: SNMPv2-SMI::zeroDotZero
    IF-MIB::ifSpecific.7 = OID: SNMPv2-SMI::zeroDotZero
    IF-MIB::ifSpecific.8 = OID: SNMPv2-SMI::zeroDotZero
    IF-MIB::ifSpecific.9 = OID: SNMPv2-SMI::zeroDotZero

commit 4abad4b6eed22c8bc54be9f6ad77d5abe14bac75
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Fri Dec 10 20:58:56 2021 -0800

    README.win32: Document how to install the SNMP service on Windows 10

commit 83c0a8f38dc8789f8cc0cef76af344a2c2f6b50b
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Fri Dec 3 20:37:42 2021 -0800

    libsnmp: Prepare for using the recommended OpenSSL functions
    
    This patch does not change any functionality.

commit 447e80b7f1c8ad9899f30afb8c7c31b232c79fb2
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Fri Dec 3 20:36:58 2021 -0800

    configure: Check for more OpenSSL functions

commit fad66f9957fb2a19b711cf660b7f23d7410e47e6
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Thu Dec 2 15:03:13 2021 -0800

    Revert "libsnmp: Use the recommended OpenSSL functions"
    
    This reverts commit 0bb1243671fe9a1389d3c735100747982a1b3c3c.
    Revert this commit because it breaks the regression tests.

commit e87892b94ed90d17730730c2ead69b4e17a47ec2
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Tue Nov 30 22:13:42 2021 -0800

    configure: Restore support for compilers that do not support -Werror
    
    See also https://github.com/net-snmp/net-snmp/issues/376 .

commit 0bb1243671fe9a1389d3c735100747982a1b3c3c
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Nov 28 16:09:21 2021 -0800

    libsnmp: Use the recommended OpenSSL functions
    
    See also https://github.com/net-snmp/net-snmp/issues/294 .

commit 86231d18704a5560f217089a5c83a2bd9cfe2340
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Nov 28 21:09:08 2021 -0800

    configure: Fix --disable-perl-cc-checks
    
    Instead of only skipping the PERLCC assignment, also skip the compiler
    compatibility check.
    
    See also https://sourceforge.net/p/net-snmp/bugs/2885/ .

commit 5b9515d0c7281f52a327e0e8d1144725a706e794
Author: minfrin <minfrin@users.noreply.github.com>
Date:   Tue Jan 5 23:17:14 2021 +0000

    Add support for digests detected from ECC certificates
    
    Previously, the digest could be detected on RSA certificates only. This
    patch adds detection for ECC certificates.
    
    [ bvanassche: changed _htmap2 into a two-dimensional array and renamed _htmap2
      back to _htmap ]

commit f720ee7aed1ec26501db384d32bc8a29bb0f43d9
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Tue Nov 9 21:15:37 2021 -0800

    configure: #include <sys/time.h> before testing select()
    
    This should improve the detection of the type of the fifth argument of
    select() on Solaris.

commit 1a560274d0f440d5c604c36b2c32b36e2a3d9a28
Author: David Korczynski <david@adalogics.com>
Date:   Sat Nov 6 00:18:56 2021 +0000

    libsnmp: Fix stack-based buffer underflow
    
    Ensure `strlen(defbuf)` is above zero before the code
    `defbuf[strlen(defbuf) - 1] = 0;`
    Fixes: https://bugs.chromium.org/p/oss-fuzz/issues/detail?id=40699
    
    Signed-off-by: David Korczynski <david@adalogics.com>

commit d26d9e4570e3c2a441c1fd700df5e8134c3ecd17
Author: Wes Hardaker <opensource@hardakers.net>
Date:   Tue Nov 9 07:52:32 2021 -0800

    patch from Charles Polisher to fix the if syntax

commit 17a1691b66b96ed7b5b863621966871bc66047e3
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Wed Oct 27 21:04:21 2021 -0700

    libsnmp: Unbreak the build if OpenSSL support is disabled
    
    Fixes: 9d7b9669a577 ("snmpd: Fix memory leaks in USM and DH algorithms")

commit a4932f7987efc213ccb152d5d307111c49b63f17
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Wed Oct 27 19:51:06 2021 -0700

    ci: Also run the build-and-test action on pull requests

commit 4fcb0b77c12936d63f462c936e31b02fed8efa59
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Oct 17 13:14:32 2021 -0700

    RMON-MIB: Fix two compiler warnings

commit fb361fd42247802c738885e026ceb22992cdf9cb
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Oct 17 13:12:43 2021 -0700

    libsnmp: Use tolower() directly
    
    From the ANSI C standard (1998): "If the argument is a character for which
    isupper is true and there are one or more corresponding characters, as
    specified by the current locale, for which islower is true, the tolower
    function returns one of the corresponding characters (always the same one
    for any giv en locale); otherwise, the argument is returned unchanged."
    
    Hence use tolower() directly.

commit d0891c58f94520d302246534fcd97e41ec3f950f
Author: David Korczynski <david@adalogics.com>
Date:   Thu Oct 14 11:37:13 2021 +0100

    snmpd: Fix memory allocation
    
    Ensure memory allocation of more than 1 byte in case asp->vbcount is 0
    Further clarification of this is found here:
    https://bugs.chromium.org/p/oss-fuzz/issues/detail?id=39901#c1
    
    This also fixes
    https://bugs.chromium.org/p/oss-fuzz/issues/detail?id=39930
    
    Signed-off-by: David Korczynski <david@adalogics.com>

commit e49f81d24299f5196ac06b74ff54595f4fb7ed55
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Wed Oct 13 20:05:48 2021 -0700

    libsnmp: Fix a compiler warning
    
    Fix the following compiler warning:
    
    transports/snmpTLSBaseDomain.c: In function ‘_openssl_log_error’:
    transports/snmpTLSBaseDomain.c:1194:9: warning: ‘%s’ directive argument is null [-Wformat-overflow=]
     1194 |         snmp_log(LOG_ERR, "%s (file %s, func %s, line %d)\n",
          |         ^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
     1195 |                  ERR_error_string(numerical_reason, NULL), file, func, line);
          |                  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    
    Fixes: b4ec52560170 ("libsnmp: Port to OpenSSL 1.1.1e")

commit e8c5d07a501d1473db5c9ef90d695e2782f88708
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Wed Oct 13 19:57:08 2021 -0700

    libsnmp: Only include <openssl/dh.h> if it is available
    
    See also commit 9d7b9669a577 ("snmpd: Fix memory leaks in USM and DH
    algorithms").

commit 9d7b9669a57757ba1b01d67cc0658b04002698be
Author: EZenderink <eldin.zenderink@bench.com>
Date:   Mon Sep 27 14:14:55 2021 +0200

    snmpd: Fix memory leaks in USM and DH algorithms
    
    [ bvanassche: made small additional changes and edited the patch description ]

commit 16be05e0cad51bd5b0e905066ea2092e574377fd
Author: lukas-wimmer <66684408+lukas-wimmer@users.noreply.github.com>
Date:   Mon Oct 4 13:14:23 2021 +0200

    libsnmp: Fix an openssl error ring segmentation fault
    
    Fixes: e498db9f886c ("CHANGES: moved transport code into a separate subdirectory in snmplib")
    
    [ bvanassche: combined two patches into one / edited patch description ]

commit 167f3116cd552e71c4a746f3c63ddb710ec05332
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Oct 3 17:35:03 2021 -0700

    SNMP-NOTIFICATION-MIB: Fix a crash during shutdown
    
    This patch fixes the following Valgrind complaint:
    
    Invalid read of size 8
       at 0x4CBE442: CONTAINER_CLEAR (container.c:505)
       by 0x49FCE63: _container_free (snmpNotifyFilterTable_interface.c:1882)
       by 0x49FCE63: _snmpNotifyFilterTable_container_shutdown (snmpNotifyFilterTable_interface.c:1939)
       by 0x49FCE63: _snmpNotifyFilterTable_shutdown_interface (snmpNotifyFilterTable_interface.c:410)
       by 0x49D2E4D: shutdown_table_snmpNotifyFilterTable (snmpNotifyFilterTable.c:125)
       by 0x49D2E87: shutdown_snmpNotifyFilterTable (snmpNotifyFilterTable.c:72)
       by 0x4A33291: _shutdown_mib_modules (mib_module_shutdown.h:52)
       by 0x4C8931F: snmp_call_callbacks (callback.c:360)
       by 0x4C58CA5: snmp_shutdown (snmp_api.c:977)
       by 0x405203: main (snmpd.c:1087)
     Address 0x64c6730 is 208 bytes inside a block of size 224 free'd
       at 0x484317B: free (in /usr/libexec/valgrind/vgpreload_memcheck-amd64-linux.so)
       by 0x4CBFC80: netsnmp_binary_array_release (container_binary_array.c:205)
       by 0x4CBFD87: _ba_free (container_binary_array.c:690)
       by 0x4CBE316: CONTAINER_FREE (container.c:484)
       by 0x49D2125: shutdown_snmpNotifyFilterTable_data_storage (snmpNotifyFilterTable_data_storage.c:89)
       by 0x4A33287: _shutdown_mib_modules (mib_module_shutdown.h:51)
       by 0x4C8931F: snmp_call_callbacks (callback.c:360)
       by 0x4C58CA5: snmp_shutdown (snmp_api.c:977)
       by 0x405203: main (snmpd.c:1087)
     Block was alloc'd at
       at 0x48455EF: calloc (in /usr/libexec/valgrind/vgpreload_memcheck-amd64-linux.so)
       by 0x4CBEACD: netsnmp_container_get_binary_array (container_binary_array.c:797)
       by 0x4CBDC12: netsnmp_container_find (container.c:302)
       by 0x49D2071: snmpNotifyFilter_storage_container_create (snmpNotifyFilterTable_data_storage.c:58)
       by 0x49D20F3: init_snmpNotifyFilterTable_data_storage (snmpNotifyFilterTable_data_storage.c:75)
       by 0x4A3457B: init_mib_modules (mib_module_inits.h:141)
       by 0x404F89: main (snmpd.c:904)

commit 1035c405bfd69dac7d09533d3d43608af732c655
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Oct 3 12:15:52 2021 -0700

    mibs: Declare netsnmp_fsys_info pointers that are not modified const
    
    This patch does not change any functionality.

commit 6db7d2ca701c54d08e7c959011af254e5f193883
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Oct 3 12:15:47 2021 -0700

    fsys: Remove two superfluous assignments
    
    Null-terminating of the output argument of strlcpy() is not necessary since
    strlcpy() guarantees null-termination.

commit 2740eaee234104d6abae132f933ef381976862fe
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Sep 19 15:46:33 2021 -0700

    perl: Leave out -Wimplicit-fallthrough
    
    Leave out this compiler flag since it is not supported by older versions of
    gcc.

commit 19e75743173cb8d49d49fd685b8e0249e83cc820
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Wed Sep 8 20:39:42 2021 -0700

    libsnmp: Fix the build against OpenSSL 3.0
    
    Fixes: https://github.com/net-snmp/net-snmp/issues/343

commit 1672d705202e0f758133707b3a291319bebfdc66
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Tue Sep 7 20:07:42 2021 -0700

    SNMP-NOTIFICATION-MIB: Fix filter lookup
    
    The notification filter information is stored in one container but during
    filtering, a different container is being used to look for matching filters.
    Change agent/mibgroup/snmp-notification-mib/snmpNotifyFilterTable/snmpNotifyFilterTable_data_storage.h
    and agent/mibgroup/snmp-notification-mib/snmpNotifyFilterTable/snmpNotifyFilterTable_data_access.c
    to expose the data_storage method that creates the container (used when
    actual filtering) so that this method can be used when creating the
    container used to store the notification filters.
    
    Fixes: https://github.com/net-snmp/net-snmp/issues/342

commit 64a88cc2fdd3e6f4cb7a66d4c2846da97112494e
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Tue Sep 7 20:29:51 2021 -0700

    libsnmp: Provide a default value for netsnmp_container.ncompare
    
    Fixes: https://github.com/net-snmp/net-snmp/issues/342

commit 94ca941e06bef157bf0e13251f8ca1471daa9393
Author: Kaarle Ritvanen <kaarle.ritvanen@datakunkku.fi>
Date:   Fri Aug 27 14:21:45 2021 +0300

    snmpd: always exit after displaying usage
    
    Currently, viewing the help text with -h results in snmpd being started
    in the background, whereas this does not happen with --help. Similarly,
    when an error is detected in command line syntax, the help text is
    displayed but sometimes snmpd gets started anyway, depending on the
    execution path.
    
    This patch makes snmpd consistently terminate whenever the usage
    function gets called. It also removes the goto statements no longer
    needed.

commit 7330e3e3e08d9baff23332e764f9a53561939fff
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Thu Sep 2 21:06:54 2021 -0700

    libsnmp: Log "Truncating integer value >32 bits" once
    
    Log this message once instead of every time sysUpTime and/or
    hrSystemUptime are accessed after snmpd is running for more than 497 days.
    
    Fixes: https://github.com/net-snmp/net-snmp/issues/144

commit d7be3dd3329182c178975b3f005c17bb363baca2
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Tue Aug 31 17:05:19 2021 -0700

    ci/openssl.bat: Bump the OpenSSL version

commit 3d9111050a9b5f72797700d84dc0c1cfb4bd3388
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Tue Aug 31 16:08:36 2021 -0700

    ci/net-snmp-configure: Make this script again compatible with Darwin

commit a64fbaaa0e08d29e140014f6f51f338558d503c8
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Tue Aug 31 15:46:24 2021 -0700

    libsnmp: Use asprintf() instead of open-coding it

commit 6090fbed3feea13c635348d67d6be6583b209bc6
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Tue Aug 31 15:45:25 2021 -0700

    libsnmp: Clear freed pointers

commit 6506da8d78e9f53be7fda393deeb4eb0e321e4e1
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Mon Aug 30 15:56:26 2021 -0700

    libsnmp: Return early from alloc_node() if memory allocation fails

commit ae0cea08e45427ce4e607538e1abf79a304bbca9
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Mon Aug 30 15:49:58 2021 -0700

    libsnmp: Simplify free_node()
    
    Remove the if-tests since free() accepts a NULL pointer. Remove a (char *)
    cast since free() accepts an argument of type void *.

commit 19ac11e17903aeb8afb64a15ca1a3584c97c54c3
Author: Niels Baggesen <nba@users.sourceforge.net>
Date:   Mon Aug 30 22:18:06 2021 +0200

    Fix a spurious warning when running tests

commit fdd0ab46b1fb84e4bcc188eca8e2cc5c6075e858
Author: Niels Baggesen <nba@users.sourceforge.net>
Date:   Mon Aug 30 22:07:54 2021 +0200

    Fix build for NetBSD by adding kernel_netbsd

commit 36168dc6a338c6fce2c02e76947b748fb74cc5ef
Author: Niels Baggesen <nba@users.sourceforge.net>
Date:   Mon Aug 30 22:06:38 2021 +0200

    apps/Makefile.in: add mysql libs to snmåptrapd link

commit b7bd3636123497b908bf78d64aba229831ccfab2
Author: Niels Baggesen <nba@users.sourceforge.net>
Date:   Mon Aug 30 22:01:41 2021 +0200

    mibs: updated IANAifType-MIB, IANA-ADDRESS-FAMILY-NUMBERS-MIB

commit c3ac5ac59bd8f40aec6d383208a7cd0d52a868f6
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Aug 29 17:33:44 2021 -0700

    apps/snmppcap: Do not cast away constness

commit 00901cf770855826f187db76f27258e646c6fd2d
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Aug 29 12:23:11 2021 -0700

    ci/net-snmp-configure: Refine when to enable embedded Perl
    
    Only enable embedded Perl if Net-SNMP and the Perl interpreter are built with
    the same compiler type. If different compilers are used and if embedded Perl
    is enabled, the configure script reports the following:
    
    configure: error: This build is using a GNU C compiler (clang) while Perl
    has been compiled with a non-GNU (or non-working) compiler
    (x86_64-linux-gnu-gcc). This likely won't work for building with Perl
    support. Either specify a different compiler (--with-cc=PATH), disable this
    check (--disable-perl-cc-checks) or build without Perl
    (--without-perl-modules).

commit b9308221b1d0c1f77c8b2511e196376dc2870211
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Aug 29 09:25:06 2021 -0700

    libsnmp: Fix more undefined behavior in asn_build_int()
    
    According to the C standard, triggering an overflow by shifting a signed
    integer left results in undefined behavior. Fix this by inserting a cast.
    
    Fixes: https://bugs.chromium.org/p/oss-fuzz/issues/detail?id=37808

commit 416705ce8abf2d33f693d057d77aa5bc1b0fb364
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Aug 28 17:17:35 2021 -0700

    ci: Disable the Python tests because these fail sporadically

commit c21ad2b5b3b48d68b6973c1d768042e5417e92e0
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Aug 28 16:14:29 2021 -0700

    ci/net-snmp-configure: Improve this script
    
    Introduce functions for retrieving the version of a software package.
    Reenable the DISMAN expression MIB. Use the recommended approach to pass
    $CFLAGS, $CPPFLAGS and $LDFLAGS to the configure script.

commit 9fca293b2de46d3a734cd3d6e68611de6ac207a5
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Fri Aug 27 10:33:46 2021 -0700

    snmpd, IP-MIB, UCD-MIB: Remove superfluous string termination code
    
    Since snprintf(buf, sizeof(buf), ...) guarantees that the string written
    into `buf` is '\0' terminated if sizeof(buf) >= 1, remove the following
    statement if it occurs just past such a snprintf() statement:
    
        buf[sizeof(buf) - 1] = '\0';
    
    See also
    https://pubs.opengroup.org/onlinepubs/009695399/functions/fprintf.html.

commit 277d75633d8008cde468d026694289ca32f2cb6d
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Thu Aug 26 10:17:11 2021 -0700

    libsnmp: Fix undefined behavior in asn_build_int()
    
    According to the C standard, triggering an overflow by shifting a signed
    integer results in undefined behavior. Fix this by inserting a cast.
    
    Fixes: https://bugs.chromium.org/p/oss-fuzz/issues/detail?id=37579

commit d700c957f991912a63b9637720b716f6cf8696fd
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Thu Aug 26 10:14:31 2021 -0700

    libsnmp: Fix a comment in asn_build_int()

commit 85bff70932178ccd08b55112cadcb0e1bedb909d
Author: EZenderink <55834436+EZenderink@users.noreply.github.com>
Date:   Wed Aug 18 17:27:01 2021 +0200

    IF-MIB: Fix deprecated retrans_time syscall warning (and base_reachable_time)
    
    Remove the check which retrans_time and base_reachable_time interface is
    available from `netsnmp_arch_interface_init`, which uses the "default"
    network interface to determine which is available, but this network
    interface is not always available (e.g. network namespaces).
    
    Determine at runtime which procfs file to read.
    
    [ bvanassche: Reformatted commit message and edited patch ]

commit 9a0cd7c00947d5e1c6ceb54558d454f87c3b8341
Author: Bill Fenner <fenner@gmail.com>
Date:   Tue Aug 24 07:55:00 2021 -0700

    CHANGES: snmpd: recover SET status from delegated request
    
    Reported by: Yu Zhang of VARAS@IIE, Nanyu Zhong of VARAS@IIE
    Fixes by: Arista Networks
    
    When a SET request includes a mix of delegated and
    non-delegated requests (e.g., objects handled by master
    agent and agentx sub-agent), the status can get lost while
    waiting for the reply from the sub-agent.  Recover the status
    into the session from the requests even if it has already
    been processed.

commit 67ebb43e9038b2dae6e74ae8838b36fcc10fc937
Author: Bill Fenner <fenner@gmail.com>
Date:   Wed Jun 30 14:00:28 2021 -0700

    CHANGES: snmpd: fix bounds checking in NET-SNMP-AGENT-MIB, NET-SNMP-VACM-MIB, SNMP-VIEW-BASED-ACM-MIB, SNMP-USER-BASED-SM-MIB
    
    Reported by: Yu Zhang of VARAS@IIE, Nanyu Zhong of VARAS@IIE
    Fixes by: Arista Networks

commit 557fdffef0a9a8e1085bb84e613d7176180fff0b
Author: Bill Fenner <fenner@gmail.com>
Date:   Wed Jun 30 13:57:55 2021 -0700

    snmppcap: add the ability to process packets like the agent

commit 57ce1fb360db21e43b6ade25540a4080d68d5469
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Aug 22 20:23:13 2021 -0700

    HOST-MIB: Remove four global variables
    
    Global variables make code harder to maintain than necessary. Hence remove
    four global variables from the HOST-MIB implementation.

commit d48428f47834c01e611b45df912941ad70d4f086
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Aug 22 20:22:51 2021 -0700

    HOST-MIB: Reindent two functions
    
    Reindent two functions before modifying these.

commit 6889d8af5830c1b4b017b9d43bbaf88e3b4cbf46
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Aug 22 14:36:26 2021 -0700

    include/net-snmp/agent/hardware/fsys.h: Remove nonexistant functions
    
    Since neither netsnmp_fsys_get_byIdx() nor netsnmp_fsys_get_next_byIdx() are
    defined inside the Net-SNMP codebase, remove their declarations.

commit 24c519bf899b92049e19d84293929d0253cfb9e8
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Fri Aug 20 15:36:45 2021 -0700

    HOST-MIB: Do not store NULL pointers in _fsys_container
    
    If malloc() fails, return immediately instead of storing a NULL pointer in
    _fsys_container.

commit 5dd3b37a9d2fa02851cb989b51cf76272ab0bc1d
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Tue Aug 17 17:23:21 2021 -0700

    net-snmp-configure: Respect the $CFLAGS environment variable

commit 89a7860829fdc618efa223f9fc0549a9a122fcb3
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Thu Aug 19 16:30:26 2021 -0700

    IP-MIB: Fix the --disable-ipv6 build
    
    Fixes: https://github.com/net-snmp/net-snmp/issues/202

commit 50e36447179140fefddb957bbf9fc6aca7a81d39
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Thu Aug 19 20:04:00 2021 -0700

    IF-MIB: Add more comments

commit d2822f221afbec9101b7926b88a95b235490f9d7
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Tue Aug 17 09:05:46 2021 -0700

    ci/build.sh: Show the $CC compiler path if $CC has been set

commit 44db9e673687aa9455b969aea218f218ba4e688b
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Mon Aug 16 21:55:21 2021 -0700

    ci/net-snmp-run-tests: Do not rerun configure

commit faf345430c4fa23b7aa937b8848eaae9339914f2
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Mon Aug 16 20:19:34 2021 -0700

    ci/install.sh: Install pkg-config

commit abbb0db992dd6a7278d93e144fcd599e9b706396
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Mon Aug 16 19:25:11 2021 -0700

    configure: Add LIBNLROUTE3_CFLAGS to the compiler flags

commit 34fe22233a99774673fd0c1738ad8f0ca48fd349
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Mon Aug 16 18:42:50 2021 -0700

    ci/install.sh: Also install 'make'

commit b7fd1d6fd872ca8379e8f63c51682043708b47fc
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Mon Aug 16 18:40:30 2021 -0700

    ci: Move 'sudo' out of ci/install.sh
    
    This makes it possible to use the install script inside Docker containers
    that do not support 'sudo'.

commit f0b896767ac2b2452162d4c4e03824fa6fd2d597
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Mon Aug 16 09:11:09 2021 -0700

    ci: Rename before.sh into setup.sh
    
    The new name better reflects the purpose of this script.

commit 5bf51b1798c9c707c18db25d9e95c30b2852835b
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Mon Aug 16 09:15:34 2021 -0700

    ci: Add v5.9 branch to github workflow triggers

commit 01d10ab33b39988dbe659fe7903eaf132d39f1ef
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Mon Aug 16 09:13:34 2021 -0700

    ci: Copy github workflow from master branch

commit 3a6a246260243f320a53ab57bba31086467e39e9
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Mon Aug 16 08:57:33 2021 -0700

    ci/before.sh: Add libnl-route-3-dev

commit d80419d7f9bcc9c982b166fa2a9ed53daaaf48b6
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Aug 1 21:28:45 2021 -0700

    IF-MIB: Split netsnmp_access_interface_ioctl_flags_get()
    
    This patch does not change any functionality.

commit a688adf2d8ef6622e1d57011566b06431b90152e
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Aug 1 20:23:58 2021 -0700

    IF-MIB: Introduce netsnmp_convert_arphrd_type()
    
    This patch does not change any functionality.

commit be78525370b26218a385d220f17e66ca3d8724b2
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Aug 1 13:38:24 2021 -0700

    IF-MIB: Introduce netsnmp_derive_interface_id()
    
    This patch does not change any functionality.

commit 8609bd42cdcbdea0bc52f8619f1338a7ed8537a5
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Aug 1 13:32:09 2021 -0700

    IF-MIB: Introduce the function netsnmp_guess_interface_type()
    
    This patch does not change any functionality.

commit 7aff0c50f6cdeeee626b8cc80f619ab53ee4cdd0
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Aug 1 13:34:38 2021 -0700

    IF-MIB: Remove dead code
    
    The preprocessor macro APPLIED_PATCH_836390 is not defined. Hence remove
    the code guarded by that macro.

commit 971cae99db5ba9bf926f70c98dd139fbf7ec9dbd
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Aug 15 12:19:48 2021 -0700

    ci: Also install the libkrb5-dev and libncurses-dev packages

commit 8872b39470509896a05c38bf35cf4ffafbaeacb0
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Aug 14 20:26:45 2021 -0700

    ci/before.sh: Improve this script
    
    Add option -qq to apt-get to make it less noisy. Install libpcre3-dev.
    Do not yet install libkrb5-dev because support for libkrb5 in the configure
    script is broken.

commit 3a2d729f6c6b36794379621a9e1f6964489444ce
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Aug 14 20:11:05 2021 -0700

    configure: Run autoconf

commit 08d6868cc9d0785e861bc0670af3f9ec90fd64f4
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Aug 14 11:14:13 2021 -0700

    testing: Add a read_mib() unit test

commit c26ee3631ad964c3bfaf232efeb6f10bb89eead6
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Aug 14 11:37:32 2021 -0700

    testing: Improve unit test T026read_config_clib.c
    
    Improve the messages that are reported while running this unit test. Remove
    the file created by this test.

commit b3353512d8e4c7dc26a0e37bb08c7089df2ee40f
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Mon Aug 9 16:28:58 2021 -0700

    testing: Add a read_config() unit test

commit 7e6b198840404294014fb0553dae25a5705bab1e
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Mon Aug 9 17:08:09 2021 -0700

    libsnmp: Add more netsnmp_assert() statements

commit 413b17eecd6af8e8247501805b5a366b709828bf
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Mon Aug 9 14:07:20 2021 -0700

    libsnmp: Fix the getoid() error path
    
    Fixes: d0277ca1ccd6 ("libsnmp: Fix a memory leak in a MIB parser error path")

commit 2cd0e7d72a76ba27a18315b9ae67e6ed6d2c464a
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Mon Aug 9 13:38:36 2021 -0700

    IF-MIB: Add a trailing newline to an error message
    
    Fixes: 8bb544fbd2d6 ("Linux: IF-MIB: Fix a memory leak")

commit 5ecd04c215f0cbe416434cb5ee0e36ec81a3a63f
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Aug 7 11:23:30 2021 -0700

    libsnmp: Fix a read-past-end-of-buffer
    
    Prevent that the code 'cp2 = cp + 1; *cp2' reads past the end of the input
    buffer if the input buffer consists of one double quote. This patch should
    fix https://bugs.chromium.org/p/oss-fuzz/issues/detail?id=36874.

commit 359729bf94950df6e8a541570151683b0d5475ab
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Aug 7 10:58:15 2021 -0700

    libsnmp, cert_util: Fix a memory leak in an error path
    
    This leak was detected by Coverity. See also CID 372223.

commit 42fe5ee281beba9793017018aa200a5183a8671e
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Aug 7 10:55:40 2021 -0700

    IP-MIB: Fix a use-after-free in an error path
    
    See also Coverity report 372225.

commit d0277ca1ccd6ec8d786355a433717a9dbf41112e
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Aug 7 08:32:03 2021 -0700

    libsnmp: Fix a memory leak in a MIB parser error path
    
    This patch should fix
    https://bugs.chromium.org/p/oss-fuzz/issues/detail?id=36879.

commit 20683e974b0cbacb4c2dbdc5d84d2b831f61b5db
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Aug 7 08:25:51 2021 -0700

    libsnmp: Remove a superfluous declaration

commit 776ca4f9c9f599172dc83e488f5b603692319957
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Fri Aug 6 20:16:32 2021 -0700

    libsnmp: Include <sys/types.h> from <net-snmp/library/asn1.h>
    
    This patch fixes a build issue on Alpine Linux.

commit cf3a6c18b8fb0d558ce57bf19d13634ab7b31ea8
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Fri Aug 6 19:38:23 2021 -0700

    libsnmp/sd-daemon.c: Fix the Alpine Linux build

commit 6fd24f2c42fbde05960759db03f2bca99071dcb2
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Fri Aug 6 19:38:18 2021 -0700

    DISMAN-MIB: Fix a compiler warning

commit 2e9779aff0d18d891ffe5d77d8335798f80e29ca
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Thu Aug 5 21:09:04 2021 -0700

    DISMAN-MIB: Fix the build on Alpine Linux

commit 92ded667923c1efdb1c529d2cbed7f2a26485e8f
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Thu Aug 5 21:10:53 2021 -0700

    DISMAN-MIB: Fix the build on Alpine Linux
    
    Include <linux/param.h> for the definition of HZ.

commit f561a1f7149c677309beea720019f3e4e20a5ecf
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Thu Aug 5 21:09:33 2021 -0700

    DISMAN-MIB: Include <poll.h> instead of <sys/poll.h>

commit ddc807b3407d1f2f86b6796f8698be4ea2a4c8e2
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Thu Aug 5 21:07:47 2021 -0700

    DISMAN-MIB: Include <signal.h> instead of <sys/signal.h>
    
    According to POSIX <signal.h> should be included.

commit 32f7cff5e30da41eed709544eab6deeb020e3540
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Thu Aug 5 19:20:24 2021 -0700

    libsnmp: Remove two casts from node_to_oid()
    
    This patch does not change any functionality.

commit b3e032934ffd748b9d51716590c25aa6dcf90b33
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Thu Aug 5 18:47:16 2021 -0700

    HOST-RESOURCES-MIB: Add a trailing newline in a log message

commit eadccb50810a1898288d29c768544fbd93b68c66
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Thu Aug 5 19:11:46 2021 -0700

    IF-MIB: Fix memory leaks in error paths
    
    Do not leak 'addr_container' if returning early.

commit d4b58c60367a262d829eb33e7888d28cd4337481
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Thu Aug 5 18:56:50 2021 -0700

    IF-MIB: Fix a recently introduced use-after-free
    
    Do not free the netsnmp_interface_entry corresponding to the previous line
    from /proc/dev/net if an interface disappeared. Additionally, reduce the
    scope of the 'entry' variable.
    
    Fixes: 600c54135b10 ("IF-MIB, IP-FORWARD-MIB: Improve robustness")

commit 74a51bc9e36cbfe96ffbf00ba20bbeea33a76cac
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Thu Aug 5 18:58:44 2021 -0700

    IF-MIB: Fix source code indentation

commit ba1d664f1712f5f90a6c74c1f62604787e5c0ea4
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Thu Aug 5 18:44:02 2021 -0700

    libsnmp: Disable the binary array consistency checks
    
    Disable the consistency checks added by the previous commit since the test
    these were intended for has completed. See also
    https://github.com/net-snmp/net-snmp/issues/107 .

commit 1660027cf1d2b3068f05d3575fc5604766e1ade0
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Wed Aug 4 20:03:43 2021 -0700

    libsnmp: Verify container properties at runtime

commit 1e2fd7a932503a43905df973630f013a6e5977e6
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Wed Aug 4 19:50:15 2021 -0700

    libsnmp: Improve the code for inserting in a binary array
    
    Only search for duplicates if duplicates are allowed. Fix a bug in the
    code for detecting duplicates: also skip duplicates if the first element
    matches (i == 0).

commit 359bde7a04b84054029e21cbc9e6d84d42635659
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Tue Aug 3 21:40:22 2021 -0700

    testing: Improve the T012binary_array_oid unit test

commit f85e82772565c76a71b683508d0cf49937d93fad
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Tue Aug 3 20:17:23 2021 -0700

    IF-MIB: Remove a superfluous cast

commit c125de54d1de991560bbbc19b0834c78f6390201
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Tue Aug 3 20:12:46 2021 -0700

    IF-MIB: Add an assert() statement

commit 5fce79b8cafb5b9c56ce6ac9dd8b788a25c9b608
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Tue Aug 3 21:22:11 2021 -0700

    libsnmp: Fix the duplicate check in netsnmp_binary_array_insert()

commit f1a8f8545a9d9a370487c196db230d5bc8f1adae
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Tue Aug 3 21:20:33 2021 -0700

    libsnmp: Fix a bounds check in netsnmp_binary_array_insert_before()

commit f205b3b285841328e81bb2cc62128b013b118162
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Tue Aug 3 20:50:47 2021 -0700

    libsnmp: Simplify the binary array linear search code

commit e289bbe323543a912fafcb6d77cee761a4df88a8
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Tue Aug 3 20:41:32 2021 -0700

    libsnmp: Use qsort() instead of open-coding it

commit 09975fff4c73ef288e772f883b4cb592287169ea
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Tue Aug 3 20:31:29 2021 -0700

    libsnmp: Document and simplify netsnmp_binary_array_options_set()

commit e46b9a126be956cdf372546fa0477694c1ae538a
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Tue Aug 3 19:39:44 2021 -0700

    libsnmp: Fix the linked list _get() function
    
    If looking for an exact match in a sorted list, return NULL instead of the
    next element if there is no exact match. Additionally, inverse the polarity
    of the third argument of this function.
    
    Note: I'm not aware of any code inside the Net-SNMP project that is affected
    by this change.

commit 5067b47e6cf0e9f041774bca2cbd3218d9bbd47d
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Mon Aug 2 20:28:58 2021 -0700

    ci: Enable the MacOS build
    
    Leave the tests disabled since these do not yet pass.

commit a137fe6bd3eba4ecf477e1ee25cd5b78c2330a63
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Mon Aug 2 20:06:52 2021 -0700

    ci: Disable Ubuntu2004

commit 600c54135b1015d56070f702d878772dd9f0d51e
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Mon Aug 2 19:04:31 2021 -0700

    IF-MIB, IP-FORWARD-MIB: Improve robustness
    
    It can happen that a network interface disappears after scanning has started
    and before netsnmp_arch_interface_index_find() or another query function is
    called. If that happens, ignore the network interface silently.

commit 52d4e67b4162dbd5d5d18ab5f3e550074d3e67b8
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Mon Aug 2 19:14:20 2021 -0700

    IF-MIB: Do not log ioctl() failures
    
    The most common cause for the "ioctl %d returned -1" error message is that
    the network interface disappeared. Since this is quite common on systems
    that run e.g. Docker, do not log an error message in case an ioctl() failed
    for a network interface.

commit a9a140d2a550c3090845069955d45b75b4ad2a15
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Mon Aug 2 19:35:51 2021 -0700

    IF-MIB: Fix spelling in a debug message

commit 8970ada022dbbcd2724cda315048eb15b0dda4aa
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Aug 1 20:35:55 2021 -0700

    configure: Run autoreconf
    
    Fixes: 6da5defc5369 ("configure: Only add -lpcre if --with_pcre != no")

commit 585ac1c81e3ea4816c7bd7e8ed52060fcb3b4e90
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Jul 31 20:43:02 2021 -0700

    IF-MIB: Make _add_new_interface() easier to read
    
    This patch does not change any functionality.

commit cc234ac171cbd5e926c460e5e7c3d1f5ccb1d94d
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Jul 31 19:18:46 2021 -0700

    IF-MIB: Simplify ifTable_index_to_oid()
    
    Instead of storing the interface index in an SNMP variable and converting
    that variable into an OID, convert the interface index directly into an
    OID. This patch does not change any functionality.

commit 31a59fd008220ddd417ba18a5653a1b11ffbddcf
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Jul 31 19:08:42 2021 -0700

    IF-MIB: Inline ifTable_indexes_set_tbl_idx()
    
    Inline this function since it is short and since it only has one caller.

commit 8bb544fbd2d6986a9b73d3fab49235a4baa96c23
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Jul 31 16:21:16 2021 -0700

    Linux: IF-MIB: Fix a memory leak
    
    The Linux kernel regenerates proc files in their entirety every time a 4 KiB
    boundary is crossed. This can result in reading the same network interface
    twice if network information changes while it is being read. Fix a memory
    leak that can be triggered if /proc/net/dev changes while being read.

commit 8da919e4ad66dec376f54a6d2f7dd7a7fe68b8f0
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Jul 31 16:01:11 2021 -0700

    Linux: IF-MIB: Pass the network interface index to netsnmp_access_interface_entry_create()
    
    Instead of letting netsnmp_access_interface_entry_create() call
    netsnmp_arch_interface_index_find() a second time, pass the network interface
    index to that function.

commit 55c68cacb7e84403f3c46c7ff4bd399ab9e87149
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Jul 31 10:25:47 2021 -0700

    CHANGES: IF-MIB: Update ifTable entries even if the interface name has changed
    
    At least on Linux a network interface index may be reused for a network
    interface with a different name. Hence this patch that enables replacing
    network interface information even if the network interface name has changed.

commit 2c963cd43b7ddb86dd6d1407e60fdbaf984d22f4
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Jul 31 14:29:31 2021 -0700

    IF-MIB: Inline two functions
    
    Since the ifTable_rowreq_ctx_init() and ifTable_rowreq_ctx_cleanup()
    implementations are short and since both functions only have one caller,
    inline these functions.

commit eecec3182ff3ded6603ca3c08685badde5675fdd
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Jul 31 13:59:12 2021 -0700

    IF-MIB: Add an assert statement

commit 07819e00660b3382c5464db49a85d5fbd188da23
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Jul 31 12:09:06 2021 -0700

    IF-MIB: Improve type safety

commit 8ce7e6adad5a51294d139f5b8fb4a8aabe0329f8
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Jul 31 13:59:21 2021 -0700

    IF-MIB: Make the ifTable_row_find_by_mib_index() code shorter
    
    This patch does not change any functionality.

commit 2ad4be5703e73e53e715de26e96bea1cb9a259ae
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Jul 31 10:31:06 2021 -0700

    IF-MIB: Simplify netsnmp_access_interface_entry_free()
    
    Passing NULL to free() is allowed. Hence change if (x) free (x) into free(x).

commit f1781a422aedf8a94af120d6a1262e2637192f1e
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Jul 31 10:27:57 2021 -0700

    IF-MIB: Simplify the netsnmp_access_interface_entry_copy() implementation
    
    This patch does not change any functionality.

commit 0a0a9bd3c3abd991a6e980c97e2a984f4af0b025
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Jul 31 10:24:19 2021 -0700

    IF-MIB: Remove a superfluous cast

commit 7d33deab54da5ff54585f7d870fa0bd82606babb
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Jul 31 13:12:33 2021 -0700

    libsnmp: Declare more counter64 input arguments 'const'

commit 9cf1f56fbda6410c290a932a0757e172598c6aa9
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Jul 24 19:40:54 2021 -0700

    IF-MIB: Remove four function pointer casts
    
    This patch does not change any functionality.

commit 280bf2b6eb870a1076105525e3a74f931431506f
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Jul 24 19:59:52 2021 -0700

    IF-MIB: Make _ifTable_initialize_interface() easier to read
    
    This patch does not change any functionality.

commit 402bf358b8d8b8090525045960a0dd814a3b9c03
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Jul 25 17:20:37 2021 -0700

    IF-MIB: Improve _check_interface_entry_for_updates() documentation
    
    Additionally, improve coding style conformance of
    _check_interface_entry_for_updates().

commit a34a5f277bbcc6b994583df383ffc573ae5188f7
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Jul 25 13:35:18 2021 -0700

    IF-MIB: Improve ifTable_container_load() documentation

commit 9d8bc4790f231a0a172de41299c9d142a8aeadbb
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Jul 24 20:24:44 2021 -0700

    IF-MIB: Remove the cd_container typedef
    
    Make it explicit that cd_container is a struct by removing the typedef for
    that data structure.

commit 95264228088eeda47e0ede41945854404f11d78a
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Jul 24 21:14:50 2021 -0700

    IF-MIB: Insert a blank line in the source code

commit fa240e457deddfb966e7df278b8a6e0789be0fef
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Jul 25 19:32:31 2021 -0700

    libsnmp, container_list_ssll: Simplify netsnmp_container_ssll_init()
    
    This patch does not change any functionality.

commit 94f5ba19434b9ed05786b4e8f2e485dbdfc220b1
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Jul 25 19:35:12 2021 -0700

    libsnmp: Change the type of the factory 'produce' function
    
    This patch does not change any functionality.

commit 87d45755edd101bb8943ce1f6f28ca1436caa425
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Jul 24 21:31:55 2021 -0700

    libsnmp: Make factory.h a private header file
    
    This makes it possible to remove unused declarations from the factory.h
    header file.

commit c6f144370f82d0f3e4f4360a30538b4ea97e1719
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Jul 25 13:12:54 2021 -0700

    libsnmp: Document the purpose of netsnmp_container_find()

commit 18bfcecc7cc79096c0a7e931bfbb51644c9e4aed
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Jul 25 13:03:56 2021 -0700

    libsnmp: Remove a cast
    
    This patch does not change any functionality.

commit a6e88f17f30a283479bf2ff6db9cc5aac5d7bd34
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Jul 25 13:35:45 2021 -0700

    treewide: Change 'invovles' into 'involves'

commit 500d7638be37f3dfe3fbd525cd0ab12e6bf68208
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Jul 24 21:37:07 2021 -0700

    treewide: Change 'allcoated' into 'allocated'

commit 9f8d1b3bea2aa11ba4d0b53b18f6f42d8d978b96
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Thu Apr 15 11:59:10 2021 -0700

    UCD-SNMP-MIB: Remove the old disk implementation
    
    The old disk implementation has been superseded since 2011. Hence remove it.

commit 6da5defc53697d4c342cf6193c92a55ee43d8abf
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Wed Jul 14 14:29:01 2021 -0700

    configure: Only add -lpcre if --with_pcre != no
    
    Fixes: bbd53ed4a429 ("network pcre detection")

commit e5ca544df5c98e92ca88b20ea59b2aff5d72b696
Author: Natanael Copa <ncopa@alpinelinux.org>
Date:   Mon Jul 12 20:56:01 2021 +0200

    MIBs: Use #ifdef instead of #if to test HAVE_* macros
    
    [ bvanassche: edited patch description ]

commit f7acd99f64d08db935a81a605383655dade07966
Author: Natanael Copa <ncopa@alpinelinux.org>
Date:   Mon Jul 12 20:49:03 2021 +0200

    NET-SNMP-EXTEND-MIB: Fix set but not used compiler warning
    
    Fix the following error with -Werror:
    
      mibgroup/agent/extend.c:1590:25: error: variable 'exten' set but not used [-Werror=unused-but-set-variable]
       1590 |     netsnmp_old_extend *exten = NULL;
            |                         ^~~~~
    
    [ bvanassche: modified patch description and modified patch ]

commit 4b3711a9a058b1ed355e4469029dd022fd7d0681
Author: Natanael Copa <ncopa@alpinelinux.org>
Date:   Mon Jul 12 20:29:45 2021 +0200

    snmpd: Include <limits.h> for PATH_MAX
    
    Additionally, use #ifdef instead of #if to test whether a macro has been
    defined.
    
    [ bvanassche: edited patch description ]

commit 51128ad095074488992982fa23ae641f7c7be4ae
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Jul 11 14:40:56 2021 -0700

    agent/Makefile.in: Build the MIB module code once
    
    Fixes: 91033077790c ("remake make's Makefile's to make better making")
    Signed-off-by: Srivalli231@github.com
    [bvanassche: added patch description]

commit 9620e5926aba5ff4fc1d3c2e150778c772b7d3da
Author: Sean Wei <me@sean.taipei>
Date:   Fri Jul 9 17:03:05 2021 +0800

    mib2c-update: Fix some shellcheck warnings

commit 35586b9fcabf3349cbff945e7f999a1f3cda4fce
Author: Sean Wei <me@sean.taipei>
Date:   Fri Jul 9 16:44:29 2021 +0800

    mib2c-update: Fix misbehavior when the path includes space

commit 1e3f5bde3e13d1378579f26e14671ac6e8bcc87f
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Mon Jul 5 11:44:18 2021 -0700

    IP-MIB: Improve ipAddressTable SIGHUP support
    
    _init_ipAddressTable() is called after the configuration has been read.
    Upon SIGHUP the configuration is reread and hence _init_ipAddressTable()
    is called again. Prevent that the following message is reported upon SIGHUP:
    
    duplicate registration: MIB modules ipAddressTable and ipAddressTable
    
    See also https://github.com/net-snmp/net-snmp/issues/312 .

commit 829445d1478bc86f627d019e4debf6df00dc9786
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Mon Jul 5 20:11:43 2021 -0700

    IF-MIB: Fix a source code comment
    
    Fixes: e772b8017d7e ("fix issue #99: read stored ifXTable config at startup")

commit b54879bc0853cff90a8ab90bbe4ddbcd32dc3ef1
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Mon Jul 5 17:28:30 2021 -0700

    testing: Capture core dump messages and the snmpd/snmptrapd exit code

commit e9f415db8e64787b316ec7527abf6e7a69ef2710
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Mon Jul 5 11:28:08 2021 -0700

    snmpd: Introduce snmpd_reconfig()
    
    This patch does not change any functionality.

commit b80d4d7d4c78d39db500f84dff3e811aa9974031
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Mon Jul 5 14:15:47 2021 -0700

    SNMPv2-MIB: Shorten the agent/mibgroup/mibII/setSerialNo.c code
    
    This patch does not change any functionality.

commit 080695397b7c9c9c0d016d30d476e9cc889ab439
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Mon Jul 5 14:22:43 2021 -0700

    libsnmp: Make the container comparison functions easier to read
    
    This patch does not change any functionality.

commit 26e9971ed8b5003d512b6700561290ac64f2d579
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Mon Jun 28 21:08:45 2021 -0700

    ci: Install more Ubuntu packages and temporarily disable OS/X builds

commit bdd5531bc4c349b8fcd1dffd4ea76e86378dccc2
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Jun 27 20:57:11 2021 -0700

    libsnmp: Make the endianness detection code compatible with Solaris' cc

commit 6bd559626e22d563ff7db80b0ec4d2e70a76c89c
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Jun 27 09:55:37 2021 -0700

    ci: Switch from Travis to AppVeyor
    
    Since June 15th, 2021, the building on travis-ci.org is ceased. Hence switch
    to AppVeyor.

commit afc185457f958f94e9076ea7ea39eaf2075f3850
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Jun 27 15:02:58 2021 -0700

    snmpd: Do not leak the trap destination community string
    
    This patch fixes the following Valgrind complaint:
    
    14 bytes in 2 blocks are definitely lost in loss record 20 of 322
       at 0x402F5ED: malloc (vg_replace_malloc.c:299)
       by 0x4548965: strdup (in /lib/libc-2.27.so)
       by 0x424D370: netsnmp_parse_args (in /lib/libnetsnmp.so.35.0.1)
       by 0x4064519: snmpd_parse_config_trapsess (in /lib/libnetsnmpagent.so.35.0.1)
       by 0x425287E: run_config_handler (in /lib/libnetsnmp.so.35.0.1)
       by 0x42539DB: read_config (in /lib/libnetsnmp.so.35.0.1)
       by 0x4253A5F: read_config_with_type_when (in /lib/libnetsnmp.so.35.0.1)
       by 0x4253D67: read_configs_optional (in /lib/libnetsnmp.so.35.0.1)
       by 0x4254642: read_configs (in /lib/libnetsnmp.so.35.0.1)
       by 0x4245849: init_snmp (in /lib/libnetsnmp.so.35.0.1)
       by 0x804A887: ??? (in /bin/snmpd)
       by 0x44E6E50: (below main) (in /lib/libc-2.27.so)
    
    See also https://github.com/net-snmp/net-snmp/issues/300 .
    
    Fixes: 09f2cbaed980 ("libsnmp, netsnmp_parse_args(): Fix memory leaks in error paths")

commit 0d58651b47337a910d4e1567a8ac2729a2b012fe
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Jun 27 19:12:38 2021 -0700

    UCD-SNMP proxy: Fix a memory leak

commit 1ead68076cebf1aa438b575faf6ca06cbc6cbd58
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Jun 27 19:08:53 2021 -0700

    UCD-SNMP proxy: Consolidate error paths in proxy_parse_config()

commit f84d62d3b38251fa5e01c2cc95e12e139474e3c4
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Jun 27 09:44:53 2021 -0700

    Darwin: MIB-II: Include mibII/kernel_sysctl for kernel versions >= 10
    
    This patch breaks support for Darwin kernel versions < 10. If it ever would
    be necessary to restore support for Darwin kernel versions < 10 that can be
    done by modifying the agent/mibgroup/mibII/kernel_sysctl.c source file.
    
    Fixes: f01c45c53cdc ("Darwin: Unify system header files")
    Fixes: https://github.com/net-snmp/net-snmp/issues/226

commit dbb49acfa2afb2539741d68403b8f9a49df93042
Author: Ryan Schmidt <git@ryandesign.com>
Date:   Sat Sep 15 00:58:05 2018 -0500

    Allow perl compiler name to contain periods
    
    Fixes: https://sourceforge.net/p/net-snmp/patches/1375/

commit a7aa206599fff95078b4e51e5b6d052d6e3e12db
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Tue Jun 22 19:58:27 2021 -0700

    libsnmp: Remove a cast
    
    This cast was introduced by commit df863a5348aa ("Fix Bug #2427: Cannot
    resolve IPv6 only hostnames, by accepting a list of transport domains.")

commit 39390a0233e7ce5fdf94f67e832df3183b96a511
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Tue Jun 22 13:48:52 2021 -0700

    TCP-MIB: Fix several memory leaks
    
    See also https://github.com/net-snmp/net-snmp/issues/300 .

commit 685d31a2baf564d992aedf9b210962e04c9ed78a
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Fri Jun 18 14:52:03 2021 -0700

    Use #ifdef instead of #if to test HAVE_* macros

commit f3f78e208fdf37be6f47595d5f99e592cc393390
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Fri Jun 18 10:51:46 2021 -0700

    libsnmp: Improve the netsnmp_getaddrinfo() debug output
    
    Display the hints passed to netsnmp_getaddrinfo() and show both IPv4 and
    IPv6 addresses in the debug output.

commit 5eea934e4a3fc77fbaf49566a8ef39d91a45f30e
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Fri Jun 18 10:10:13 2021 -0700

    win32/build.pl: Improve the menu script further
    
    Change the default OpenSSL directory into the new default directory of the
    OpenSSL installer. Remove the remaining references to the platform SDK.

commit 2c6bf7556d78e7ed9c499bf2e9aed1223a93cb44
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Thu Jun 17 09:42:53 2021 -0700

    Windows, MSVC: Use getaddrinfo()
    
    This patch changes the minimum requirement for snmpd.exe built with MSVC
    to Windows XP / Windows Server 2003. See also
    https://docs.microsoft.com/en-us/windows/win32/api/ws2tcpip/nf-ws2tcpip-getaddrinfo .
    
    See also https://github.com/net-snmp/net-snmp/issues/304 .

commit 321ff9d75d3fe2c73665466f04d3c3b22fc517ed
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Thu Jun 17 09:41:56 2021 -0700

    Revert "Windows, MSVC: Use getaddrinfo() if it is available"
    
    Reverts commit 6024a9e8613f because it is not sufficient to add IPv6 support
    on Windows.

commit 1942fe5b0f404335c7987702436d6a5d4a481acd
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Wed Jun 16 11:22:59 2021 -0700

    Python: Use % NETSNMP_PRIo u instead of %lu

commit 239d715336dbbc5640652895ee4e02882361e7ca
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Wed Jun 16 11:12:48 2021 -0700

    Use #ifdef instead of #if to test HAVE_* macros

commit 3fb026f068c3010b29c0be44998fae3d93feccbc
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Thu Jun 17 09:24:13 2021 -0700

    win32/build.pl: Fix menu system
    
    Fixes: bbbf866c1c26 ("Windows: Always use the 'Platform SDK'")

commit 428b834b34736d3182ad310eb1fb558de402ce66
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Wed Jun 16 12:12:33 2021 -0700

    ci: Remove Cygwin from continuous integration testing
    
    No Cygwin bug reports have been received in the past two years. Hence stop
    supporting Cygwin. Windows users can use MinGW or MSVC instead.

commit bbbf866c1c261615e71e52ad4cdfcac2504c92fb
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Tue Jun 15 20:06:47 2021 -0700

    Windows: Always use the 'Platform SDK'
    
    The 'Platform SDK' is an optional download for Visual Studio 6, released in
    1998. Since that version of Visual Studio is no longer supported, remove the
    corresponding menu option.

commit 6024a9e8613facc0c8b62fc1abe2477910ff38dc
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Tue Jun 15 16:31:52 2021 -0700

    Windows, MSVC: Use getaddrinfo() if it is available

commit dbc89942439259d8990cdcccf227b97779ce5eb4
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Mon Jun 14 14:54:58 2021 -0700

    Windows: Support running build.bat from inside a Cygwin shell

commit b31f31e248f065edc83f23768f081fb152318233
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Jun 12 14:15:11 2021 -0700

    IP-FORWARD-MIB: Initialize mask.sin_port
    
    This was detected by Coverity.

commit 8118c519b94c61865239a3f657f46ae622d943bc
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Jun 12 14:05:58 2021 -0700

    libsnmp: Fix a typo in the read_objid() documentation
    
    Additionally, remove a duplicate comment.

commit b9d1d1345a799b4b08a313b18456e68330199888
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Tue Jun 15 16:44:06 2021 -0700

    Use #ifdef instead of #if to test HAVE_* macros

commit e4d86779da4a6b8b2c7529297cb2e7a968ba19be
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Tue Jun 15 17:25:31 2021 -0700

    Windows, MinGW: Fix the build of agent/mibgroup/hardware/fsys/hw_fsys.c

commit f5116764b3db20599cef68dfa7a2841221e6f253
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Tue Jun 15 17:18:47 2021 -0700

    MIB-II: Do not test whether an unsigned variable is positive

commit 8aa8b94a9871c698815c4e38986b0dfbfebdef0c
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Tue Jun 15 17:14:53 2021 -0700

    snmpd: Reduce the scope of the variable 'ret'
    
    This patch suppresses the following compiler warning on Windows:
    
    snmpd.c:1172:38: warning: unused variable 'ret' [-Wunused-variable]
     1172 |     int             count, block, i, ret;
          |                                      ^~~

commit f1a32a5606e1c0794fbe770424e3f2859b608d91
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Jun 12 13:13:05 2021 -0700

    Use #ifdef instead of #if to test HAVE_* macros

commit ce75820dbca71487dbaa4038aac42443622be52b
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Jun 12 13:23:42 2021 -0700

    snmpd: Do not use HAVE_STDDEF_H
    
    The stddef.h header file is an ANSI C header file and HAVE_STDDEF_H is not
    define. Hence, remove #if HAVE_STDDEF_H / #endif.

commit 3feb2a75d20aac77712246d93b8afc6c21a46cd2
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Jun 12 13:41:54 2021 -0700

    configure: Run autoreconf
    
    Fixes: fe43b05dac6f ("configure: Add -Wundef to the developer compiler flags")

commit 5570ef925080551b665889d00325b1398983df7e
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Jun 12 07:49:15 2021 -0700

    libsnmp: Remove an obsolete comment
    
    Remove a comment that is obsolete since commit e2f9573849bd ("CHANGES:
    snmplib: remove inline versions of container funcs").

commit 8b980841780102b1f925308d0b4f7f8b847c0666
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Fri Jun 11 14:45:11 2021 -0700

    snmptrapd: Reduce the scope of the 'uid' and 'gid' variables

commit 9cb51252312ee0d3fcf65f8458fd1a2cb95f1e81
Author: Christopher Wong <christwo@axis.com>
Date:   Mon Jun 7 23:17:53 2021 +0200

    Make snmptrapd accept a group name in addition to a numerical group ID
    
    snmptrapd only supports numerical gids. This behavior is different than
    snmpd which accepts group names and numerical gits. Make snmptrapd
    behavior consistent with that of snmpd.
    
    [ bvanassche: edited patch description ]

commit 2c217277b6bec8a1b0c5172aaddd31e7c024e8aa
Author: Thomas Viehweger <ThomasVie@users.noreply.github.com>
Date:   Fri Jun 11 21:46:29 2021 +0200

    Fix inconsistent use of #if vs. #ifdef HAVE_PCRE_H
    
    HAVE_PCRE_H is undefined if <pcre.h> could or should not be used.
    Fix compiler warnings / errors if compiled with the compiler flags
    -Wundef or -Werror=undef.

commit c99b1a1c527085cefd6a7fa7a6c99fb7f43fcfb2
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Wed Jun 9 14:58:01 2021 -0700

    Python: Improve the unit tests

commit 8c1dad23301692799749d75a3c039b8ae7c07f8e
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Wed Jun 9 14:19:46 2021 -0700

    Python: Fix snmpwalk with UseNumeric=1
    
    Fixes: c744be5ffed6 ("Python: Introduce build_python_varbind()")
    Fixes: https://github.com/net-snmp/net-snmp/issues/303

commit 0ad796b13e5b4f09940cc125f041fac2364917c0
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Wed Jun 9 14:27:42 2021 -0700

    testing/RUNFULLTESTS: Fix an undefined value complaint
    
    Fixes: b6a9aa8938d9 ("testing/RUNFULLTESTS: Respect $LD_LIBRARY_PATH")

commit aa7a51ce94ef3f4cf1d9e26c2c81b89bf4a59d02
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Jun 5 19:55:03 2021 -0700

    Makefiles: Move @LD_NO_UNDEFINED@
    
    Move @LD_NO_UNDEFINED@ from $(LIB_LD_CMD) invocations into the $(LIB_LD_CMD)
    definition. This patch adds @LD_NO_UNDEFINED@ when linking libnetsnmptrapd.

commit b6a9aa8938d999b70df9fd895702483eea9ee4f4
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Thu Jun 3 21:00:56 2021 -0700

    testing/RUNFULLTESTS: Respect $LD_LIBRARY_PATH

commit 5522ccce502c2e30be952ea539c2fe4757ccf1ae
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Mon May 31 15:56:31 2021 -0700

    UCD-SNMP-MIB: Reorder functions

commit 19a6e90f0239903f1eba18056018523d89864802
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Mon May 31 15:39:16 2021 -0700

    UCD-SNMP-MIB: Simplify _expand_disk_array()

commit 7aa03757ddf46c52290d385d2128e7cfa471af68
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Mon May 31 15:34:50 2021 -0700

    UCD-SNMP-MIB: Declare local variables 'static'

commit ee51abd5523eafd773103714df9db735f46cde49
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Mon May 31 15:30:23 2021 -0700

    UCD-SNMP-MIB: Reindent agent/mibgroup/ucd-snmp/disk_hw.c

commit fe43b05dac6fc94ec7e54ce027330e3ecea803f5
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Mon May 31 14:51:27 2021 -0700

    configure: Add -Wundef to the developer compiler flags

commit 91afcd8a557e1dea57a44ce7f01dfec932994cca
Author: Thomas Viehweger <ThomasVie@users.noreply.github.com>
Date:   Thu May 27 23:08:26 2021 +0200

    Fix inconsistent use of #if vs. #ifdef NETSNMP_CAN_USE_SYSCTL
    
    NETSNMP_CAN_USE_SYSCTL could be undefined. Fix compiler warnings / errors
    if compiled with the compiler flags -Wundef or -Werror=undef.
    
    [ bvanassche: edited commit message ]

----------------------------------------------------------------------

Changes: V5.9.1.rc1 -> V5.9.1

commit 2eed7fe490bb6735a6c94b0cf03d9ff5d7884087
Author: Wes Hardaker <opensource@hardakers.net>
Date:   Tue May 25 14:49:51 2021 -0700

    remove the RC flag

commit d9d7b9b63b7b5c7be1b6de675b94f3f0ef7596ae
Author: Wes Hardaker <opensource@hardakers.net>
Date:   Tue May 25 14:49:10 2021 -0700

    Version number update: 5.9.1

----------------------------------------------------------------------

Changes: V5.9.1.pre1 -> V5.9.1.rc1

commit 05617ca6fd1d8355663de48280ade58d49050d33
Author: Wes Hardaker <opensource@hardakers.net>
Date:   Wed Apr 28 14:15:15 2021 -0700

    Release Candidate for V5-9-patches

commit c371b1d7aa174871367b2a5de23431cf7348f1a4
Author: Wes Hardaker <opensource@hardakers.net>
Date:   Wed Apr 28 14:15:13 2021 -0700

    Version number update: 5.9.1.rc1

commit 5ceb3ebc2fe138d35a498f402254335baffecee5
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Thu Apr 15 10:30:04 2021 -0700

    ci/build.sh: Disable parallel compilation for minimalist mode

commit f69daae8a958daa8b50e8767da216ef9570b2e6c
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Thu Apr 15 10:45:39 2021 -0700

    Run 'make distdepend'

commit 9f1d8188bae2990b42f8aef1c4f65dd18c1c1924
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Thu Apr 15 09:29:30 2021 -0700

    Makefile.rules: Retain only -D and -I options when regenerating dependencies
    
    The 'makedepend' command accepts the cc -D and -I options but not the other
    options that may occur in $(CPPFLAGS) (-f, -g, -O, -pipe, ...).

commit 9ea3d8b93c9bb7da7fea13ee6c92356a6b82a5fb
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Wed Apr 14 20:03:15 2021 -0700

    Makefile.in: Make sure that 'sedscript' is built before subdirectories
    
    This is a follow-up for commit 855e1c28dad5 ("Makefile.in, agent/Makefile.in:
    Fix parallel compilation").

commit 4fba346d04c26154098b917ad8769515e3766061
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Wed Apr 14 17:50:59 2021 -0700

    Windows: Unbreak the build
    
    Fixes: d6fac610cdea ("Fix the crash of snmpd when snmptrapd terminates the TCP connection.")

commit 93ea661906fb25657a63cfd757ef7a04c4dd0b33
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Wed Apr 14 16:12:43 2021 -0700

    snmpd, FreeBSD 13: Make sure that filesystem statistics are up to date
    
    Make snmpd report the current statistics instead of statistics cached at
    mount time by the operating system.
    
    Fixes: https://github.com/net-snmp/net-snmp/issues/282

commit bd5bc2df5d39a5c730a86f1c452b69f35841fdba
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Wed Apr 14 09:51:18 2021 -0700

    ci/build.sh: Enable parallel compilation

commit 855e1c28dad53d6263c6c0c302438d2dc3128cc5
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Wed Apr 14 09:35:24 2021 -0700

    Makefile.in, agent/Makefile.in: Fix parallel compilation
    
    See also https://github.com/net-snmp/net-snmp/issues/283 .

commit ec9068cd270677860e5832bee791a40ec33e08b2
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Tue Apr 13 08:59:13 2021 -0700

    ci/openssl.bat: Bump the OpenSSL version

commit 021d10edbf0c4b7754b994ad0e0ffb090f6dac32
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Tue Apr 13 08:59:13 2021 -0700

    ci/openssl.bat: Bump the OpenSSL version

commit 6a77db5c7dc4e31afb6bca93c5394f224c55a179
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Mon Apr 12 21:41:15 2021 -0700

    UCD-SNMP-MIB: Let configure detect whether or not getmntinfo() is available


----------------------------------------------------------------------

Changes: V5.9 -> V5.9.1.pre1

commit f9312b44b71ddd247a98c6aff3e986d027e7eaa4
Author: Wes Hardaker <opensource@hardakers.net>
Date:   Mon Apr 5 16:31:47 2021 -0700

    version update for 5.9.1.pre1

commit 3080795082e347504a3cd290f840b6b024d729df
Author: Wes Hardaker <opensource@hardakers.net>
Date:   Mon Apr 5 16:30:09 2021 -0700

    fix comment to C

commit 0b886fc4d842f0f434606c4d35e610341cb650f7
Author: Wes Hardaker <opensource@hardakers.net>
Date:   Mon Apr 5 15:38:35 2021 -0700

    Version number update: 5.9.1.pre1

commit b5429f6d8556f05100eadec681680df215a2d9e8
Author: Wes Hardaker <opensource@hardakers.net>
Date:   Mon Apr 5 15:38:24 2021 -0700

    version update for 5.9.1.pre1

commit f36a9c4a747863d0c258a7a816381c9f15781f3c
Author: Tobias Deiminger <tobias.deiminger@rohde-schwarz.com>
Date:   Wed Oct 7 08:36:40 2020 +0200

    Fix regex for "-l" discovery in setup.py
    
    This prevents setup.py from discovering wrong library link options (-l, -L)
    in the middle of a word, like "inux-gnu" from "-L/usr/lib/x86_64-linux-gnu".
    
    For net-snmp-config output as follows (real world example from Ubuntu 18.04):
    "-Wl,-Bsymbolic-functions -Wl,-z,relro -Wl,-z,now -L/usr/lib/x86_64-linux-gnu -lnetsnmp -lcrypto -lm"
    the former regex "-l(\S+)" would match to
    ['inux-gnu', 'netsnmp', 'crypto', 'm']
    which obviously results in a ld error "cannot find -linux-gnu".
    
    Now we capture a string only, if "-l" is at the beginning of a string,
    or if "-l" is preceeded by any number of whitespace characters.

commit c2db3407dd4dd1a288042b06967a35712004e093
Author: Ferenc Wágner <wferi@debian.org>
Date:   Mon Mar 15 18:00:48 2021 +0100

    Enable systemd socket activation for UDP sockets
    
    Like it was possible for UNIX and TCP sockets beforehand.

commit a9cf25db7e3e969dbcd9bda9a16457db6fc7210f
Author: Josef Řídký <jridky@redhat.com>
Date:   Mon Mar 15 09:23:41 2021 +0100

    net-snmp-cert: Use sha512 as default option for generating certificates.
    
    Fixes: https://github.com/net-snmp/net-snmp/issues/231
    
    [ bvanassche: edited commit message ]

commit eb1b11bb7f3ac3281dc6e92d94e8fa749cac44e0
Author: Josef Řídký <jridky@redhat.com>
Date:   Fri Mar 12 10:15:30 2021 +0100

    Prevent parsing IP address twice (#199)
    
    This fixes issue, that is caused by parsing IP address twice.
    First as IPv4 and as IPv6 at second, even thow the address was
    properly parsed as a valid IPv4 address.

commit dce7b17e7ce7b12954a8c799265d3001922bb0a1
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Wed Mar 3 20:24:05 2021 -0800

    ci/build.bat: Fix the Cygwin build

commit dc58ed9990a1736b9b500a5e16e7517f93d194f4
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Wed Mar 3 19:10:25 2021 -0800

    net-snmp-create-v3-user: Print the version number once
    
    Print the version number once instead of keeping to print the version number
    forever in an endless loop.
    
    Fixes: https://sourceforge.net/p/net-snmp/bugs/2778/

commit afa2034ca57b7986e91272b56274cebff5d8d69f
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Feb 27 21:25:44 2021 -0800

    ci/openssl.bat: Bump the OpenSSL version

commit 8c301c1e06004aa4095f956bff5f399104e71127
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Feb 27 19:46:13 2021 -0800

    IF-MIB: Do not scan for PCI devices if no PCI bus is available
    
    Fixes: https://github.com/net-snmp/net-snmp/issues/271

commit 385d555606ee31a23d5ed711a7ffba45f4197d50
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Mon Feb 15 08:44:13 2021 -0800

    Perl: Only use $prefix on Unix systems
    
    This patch reworks commit f64e0111ad10 ("Perl: Set the $prefix variable on
    Windows").

commit f64e0111ad10b948aeadd386063a69ba5fc7fc7b
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Feb 13 20:04:29 2021 -0800

    Perl: Set the $prefix variable on Windows
    
    Fixes: https://github.com/net-snmp/net-snmp/issues/261

commit 428a486d92ca631d83f5bfc42c319f630b152bea
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Feb 13 19:19:19 2021 -0800

    Python: Use netsnmp_memdup() instead of open-coding it

commit 6ad61e6628ecf1bde987c78de37674c4886a16b9
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Feb 13 19:35:57 2021 -0800

    Python: Do not report "error: set: adding variable/value to PDU" when clearing an OCTETSTR
    
    Fixes: https://github.com/net-snmp/net-snmp/issues/265

commit ddd338fab038bf0ea25426d43518f4f24ac20853
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Feb 13 19:19:01 2021 -0800

    python/netsnmp/tests/test.py: Add a test for setting an OCTETSTR

commit f03582450d1eabae6df66b1fde5699a8e2a97b81
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Feb 13 11:02:37 2021 -0800

    snmplib: Add more comments in netsnmp_random()

commit b754da08461bd062632924fb773cb6f7c8c348d7
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Feb 13 09:24:12 2021 -0800

    Enable the compiler flag -Wtype-limits

commit b71b52f03398f2c42f100dd960009b824e6c306b
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Feb 13 09:22:54 2021 -0800

    Fix the -Wtype-limits compiler warnings

commit a29685e5a35ff4a88b396e7952e59b53b9c24ebd
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Feb 13 08:29:48 2021 -0800

    configure: Only display the message "Checking for developer gcc flags" in developer mode

commit 0dcebaf3d4b142638cd86de725ef23372495005f
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Fri Feb 12 20:55:42 2021 -0800

    python/netsnmp/tests/test.py: Also perform a full MIB walk

commit 8d8d8439d5d211ec1782d609e0ad67180c975d7b
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Fri Feb 12 19:49:18 2021 -0800

    HOST-RESOURCES-MIB: Add JFFS2 support
    
    Fixes: https://github.com/net-snmp/net-snmp/issues/268

commit d468c8ad86c86ceb1807ccd51408594526940137
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Fri Feb 12 19:35:44 2021 -0800

    HOST-RESOURCES-MIB: Simplify the code for recognizing "other" filesystems

commit 02bc1baf0d4f6031085e107a9cddc05dfbd74db2
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Jan 10 16:58:09 2021 -0800

    snmpd: Exclude the /dev/kmem code if configured with --without-kmem-usage
    
    This is a follow-up for 9e933893751f ("snmpd: Exclude the /dev/kmem code if
    configured with --without-kmem-usage").
    
    Fixes: https://github.com/net-snmp/net-snmp/issues/251

commit 4d92f40112dd768d89a9f0a20cf743b18d951e45
Author: Filip Jensen <vivamudhoney@yahoo.es>
Date:   Tue Jan 5 16:57:43 2021 +0100

    Fix compilation when feature NETSNMP_FEATURE_REMOVE_LOGGING_STDIO is used

commit e3601420c8fce713924038901f824e57e6855e72
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Mon Jan 4 13:01:47 2021 -0800

    Revert "Read intermediate certificates from PEM files"
    
    This reverts commit 916110b15f28f8ae04598ad637ac26e4585ff385 and thereby
    removes support for intermediate certificates from the v5.9 branch.

commit 2b93ee55d1b9b32c86c3f725c59b8fd17912ae18
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Mon Jan 4 13:01:42 2021 -0800

    Revert "libsnmp: Fix a NULL pointer dereference in an error path"
    
    This reverts commit 99a72177c7c69c5ca1a5ecb68f5f2db7d971e97a.

commit baef04f9c6fe0eb3ac74dd4d26a19264eeaf7fa1
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Mon Jan 4 10:00:33 2021 -0800

    testing/fulltests/unit-tests/T105trap_parse_clib: Add this test
    
    Add a reproducer for the bug fixed by the previous patch.

commit 92f0fe9e0dc3cf7ab6e8cc94d7962df83d0ddbec
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Mon Jan 4 12:21:59 2021 -0800

    libsnmp: Fix asn_parse_nlength()
    
    Handle length zero correctly.
    
    Fixes: https://github.com/net-snmp/net-snmp/issues/253
    Fixes: a9850f4445cf ("asn parse: add NULL checks, check length lengths")

commit 1bf7c9c81d988e7945a34bea666ca3428c1ac127
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Mon Jan 4 12:17:58 2021 -0800

    libsnmp: Simplify _asn_short_err()
    
    Since snprintf() always '\0'-terminates the string it produces explicit
    '\0'-termination is not necessary.

commit 34c3b4ee104a1239c7bff7f6c80ca8b05b3bf17a
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Mon Jan 4 12:13:26 2021 -0800

    libsnmp: Add SNMPv1 trap support in snmp_pdu_type()
    
    This change only affects error messages and debug messages.
    
    Fixes: 00ef569e00d1 ("Fix 5.5.x branch structure (part 2)")

commit 9e933893751fb5b1b68c6efb844ef5d4b3a905e0
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Jan 3 13:42:59 2021 -0800

    snmpd: Exclude the /dev/kmem code if configured with --without-kmem-usage
    
    See also https://github.com/net-snmp/net-snmp/issues/251 .

commit 99a72177c7c69c5ca1a5ecb68f5f2db7d971e97a
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Wed Dec 30 13:03:30 2020 -0800

    libsnmp: Fix a NULL pointer dereference in an error path
    
    This issue was detected by Coverity.
    
    Fixes: 916110b15f28 ("Read intermediate certificates from PEM files")

commit 916110b15f28f8ae04598ad637ac26e4585ff385
Author: minfrin <minfrin@users.noreply.github.com>
Date:   Wed Dec 30 17:48:39 2020 +0000

    Read intermediate certificates from PEM files
    
    This patch lifts the restriction that a PEM file can only contain
    one certificate. This brings net-snmp in line with the behaviour
    of other applications that use PEM files.
    
    Multiple certificates are read from each file, and the offset of
    each certificate is added to the index for efficient retrieval.
    
    The first certificate in the chain is eligible to be either an
    identity certificate or a remote certificate. Intermediate
    certificates are ignored for this purpose, maintaining existing
    behaviour with respect to peerCert and remoteCert.
    
    Trusted CA certificates are still required to be listed one per
    file, this restriction will be lifted in a separate patch.
    
    [ bvanassche: modified this patch such that the size of struct
      netsnmp_cert_common_s does not change ]

commit e96087f1aa70583fe3142a2919fc3a69e62c53bb
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Wed Dec 30 10:52:30 2020 -0800

    TLSTM-MIB: Remove an unused member variable

commit 951fd2d9b07e29455ff0251b0f44ed76d935ff00
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Tue Dec 29 15:22:42 2020 -0800

    snmpd: Restore SNMPD_CALLBACK_SEND_TRAP[12] behavior
    
    Instead of only invoking the SNMPD_CALLBACK_SEND_TRAP[12] callbacks if one
    or more sessions with the corresponding SNMP version exist, invoke these
    callbacks unconditionally.
    
    Fixes: f770e0f74932 ("skip send_trap callbacks if no sessions for version")
    Fixes: https://github.com/net-snmp/net-snmp/issues/247

commit 22f0630371231787f59522f4a3c4d1bb04594c66
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Dec 26 16:19:37 2020 -0800

    ci: Overwrite /etc/hosts
    
    Overwrite /etc/hosts instead of using the /etc/hosts file provided by the
    CI service. This should fix sporadic OS/X test failures.

commit b3dd620161703a6ade14b5afe0e8f6fd63685a81
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Dec 26 16:07:34 2020 -0800

    libsnmp, UDP: Only display VRF debug messages if relevant
    
    Only display a VRF debug message if a VRF interface has been specified.
    
    Fixes: 02de400544de ("libsnmp: Set Linux VRF iface on Trap sink IP addresses")

commit ac06c5844105473e211decdf825af75dc7cd8b7c
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Fri Dec 25 17:19:35 2020 -0800

    Perl: Rework the authentication / privacy algorithm lookup code
    
    Use the tables defined in snmplib/scapi.c instead of duplicating these tables.

commit 6ea6935621a05c845e6829b18c833cdb9c7baa55
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Fri Dec 25 17:19:45 2020 -0800

    libsnmp: Constify the authentication and privacy data structures
    
    Prevent that scapi users modify data structures that should not be modified.
    This patch modifies the Net-SNMP API but not the ABI.

commit 92012951687cb18c8e58fede015e4bc0a9222e73
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Dec 26 09:25:33 2020 -0800

    libsnmp: Export sc_find_auth_alg_byoid() and sc_find_auth_alg_bytype()
    
    Fix two typos in include/net-snmp/library/scapi.h.
    
    Fixes: 329a9d3c9d63 ("revamp auth/priv protocol constants handling")

commit 4da46332f324eb5f18513d0e7e1368e529b29aef
Author: minfrin <minfrin@users.noreply.github.com>
Date:   Tue Dec 22 12:03:22 2020 +0000

    Add support for intermediate certificates
    
    After constructing a certificate chain, pass the chain to openssl so the chain
    is taken into account while negoiating SSL. Required to support certificates
    generated by a PKI, or by a CA like Let's Encrypt.
    
    Fixes: https://github.com/net-snmp/net-snmp/issues/241
    Fixes: https://github.com/net-snmp/net-snmp/issues/242
    
    [ bvanassche: slightly edited commit message ]

commit 969226ea501b92e1a2ed427bc1a46f18ef2890b7
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Fri Dec 18 10:25:20 2020 -0800

    libsnmp, _cert_get_extension(): Consolidate error paths
    
    This patch does not change any functionality.

commit bb30f8ee0075750fd3648a6bf3fab543f46152ed
Author: minfrin <minfrin@users.noreply.github.com>
Date:   Thu Dec 17 12:25:24 2020 +0000

    libsnmp, SSL: Increase extension buffer size to prevent a crash
    
    Make sure enough space is allocated for extensions longer than 512 bytes. Fix
    the error message when the extension is too long to clearly differentiate the
    error from the out of memory case. Fix a crash when the extension is too long.
    
    [ bvanassche: edited patch description / fixed an off-by-one error / undid a
      code formatting change ]

commit 4c5d2ceae4d4a8b77db48fc8fff77e14943ff4d3
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Wed Dec 16 19:36:55 2020 -0800

    libsnmp: Handle certificate loading errors gracefully
    
    Instead of crashing (SIGSEGV), skip certificates if loading fails.
    
    Reported-by: https://github.com/minfrin
    Fixes: https://github.com/net-snmp/net-snmp/issues/233

commit 9d001c34196df47526260441af35a509a325e41f
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Wed Dec 16 19:32:58 2020 -0800

    libsnmp: Fix spelling in an error message
    
    Reported-by: https://github.com/minfrin

commit bcc654e704f4794a9b10b8abf6e01f509402a6d3
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Dec 13 12:06:45 2020 -0800

    Darwin, ARM: Fix the 64-bit build
    
    See also the following two commits:
    * 632b143b0005 ("memory_darwin: Suppress a compiler warning")
    * 8ae78da391d5 ("Use vm_region_64 on 64-bit arch; cache memory for longer")

commit f82634a1ca4a24601cd966abe4062c35e376c9ab
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Dec 13 09:58:28 2020 -0800

    perl: Rework the authentication and privacy code
    
    Switch to a table-based approach. This patch does not change any functionality.

commit cf125fee113ef9e361af51b916166990b5abeda2
Author: garnier-quentin <garnier.quentin@gmail.com>
Date:   Tue Dec 8 16:10:46 2020 +0100

    perl: Add support for strong SHA authentication
    
    [ bvanassche: edited commit message, combined three patches into one and left
      out whitespace-only changes ]

commit a7c8c26c48c954a19bca5fdc6ba285396610d7aa
Author: Mitchell Blank Jr <mitch@bodyfour.com>
Date:   Sun Dec 13 03:23:02 2020 +0000

    Fix compiler warnings generated by configure scripts
    
    Specifically, this is meant to reduce risk of issues with Xcode 12
    which has made -Werror,-Wimplicit-function-declaration a default.
    
    Normally this doesn't bite "real" code since such a warning would be
    visible for a long time with most compilers.  However, inside of
    configure scripts these sorts of warnings just end up in config.log
    and usually get ignored.  Now that they produce errors it means that
    configure tests that *should* pass suddenly fail, causing very
    strange failures later on.
    
    This can be as simple as calling "exit(0);" inside of a test C
    program without doing "#include <stdlib.h>" first!
    
    I also fixed an implicit-int-return warning since that is another
    C behavior that was deprecated long ago and future compilers might
    consider that an error.
    
    [ bvanassche: reran autoconf ]

commit cc3e0505f58d2c5d03be7a0b4c70afd01f7deb3c
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Dec 12 18:41:45 2020 -0800

    Windows: Yet another Visual Studio 2005 build fix
    
    Microsoft Visual Studio 2013 and before do not support __func__. Hence
    use __FUNCTION__ instead of __func__ when building with Visual Studio.
    
    Reported-by: Christophe Cassignol
    Fixes: 6066c6e21991 ("libsnmp, snmpv3_packet_build(): Avoid triggering a buffer overflow")
    Fixes: 20725d58ca76 ("DTLSUDP transport: Check length of from address")

commit 7137ee0b94ff5eab0682e5a63d5e9d6eb2b6fea9
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Dec 12 18:20:46 2020 -0800

    ci/openssl.bat: Bump the OpenSSL version

commit 3617459d1d204f3e595c794a2642bd9536c86245
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Dec 12 14:38:28 2020 -0800

    Windows: Fix Visual Studio 2005 build
    
    Reported-by: Christophe Cassignol
    Fixes: 193062739789 ("Net-SNMP headers: Move in_addr_t definition into <net-snmp/net-snmp-config.h>")

commit 64bbd86fc13517c5021096acfbb23577bbd0f8a8
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Mon Nov 30 19:41:27 2020 -0800

    Python: Handle hex strings correctly
    
    See also https://github.com/net-snmp/net-snmp/issues/216 .

commit c744be5ffed64f992a843e858a3cd2c1fe80f12f
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Tue Dec 1 20:19:17 2020 -0800

    Python: Introduce build_python_varbind()
    
    This patch does not change any functionality.

commit d519f4cf41c6b94661259409942fcdea46cf384d
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Tue Dec 1 19:27:55 2020 -0800

    Python: Merge netsnmp_get() and netsnmp_getnext() into a single function
    
    This patch does not change any functionality.

commit 281e6fc9454a785d9a4487d35146724dadcfbf62
Author: Johnnyxy <Johnnyxy@github.com>
Date:   Thu Nov 19 17:43:13 2020 -0800

    Win32, MSVC: Use <stdint.h> if it is available
    
    See also https://github.com/net-snmp/net-snmp/issues/213 .

commit a54c03aa0564e3aeb53712228522c2ba9b0f971f
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Wed Nov 18 21:05:13 2020 -0800

    net-snmp-create-v3-user: Fix multiple shellcheck warnings

commit 09a0c9005fb72102bf4f4499b28282f823e3e526
Author: Josef Ridky <jridky@redhat.com>
Date:   Wed Nov 18 20:54:34 2020 -0800

    net-snmp-create-v3-user: Handle empty passphrases correctly
    
    See also https://github.com/net-snmp/net-snmp/issues/86.
    
    Fixes: e5ad10de8e17 ("Quote provided encryption key in createUser line")
    Reported-by: Chris Cheney

commit ebe677ea1be61df6589a28a5b6306fe55f5784b2
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Wed Nov 18 19:36:17 2020 -0800

    CHANGES: snmpd: Fix OID handling in header_simple_table()
    
    Process GETNEXT for OIDs like 1.3.6.1.4.1.2021.9.1.1.4294967295 correctly.
    Additionally, handle *length == 0 correctly.
    
    See also https://github.com/net-snmp/net-snmp/issues/210 .

commit a8cb3591a924aeda1fd777f555da31ad8a627722
Author: Josef Ridky <jridky@redhat.com>
Date:   Mon Nov 9 19:42:32 2020 -0800

    IP-MIB: Improve handling of IPv6 support having been disabled intentionally
    
    See also https://github.com/net-snmp/net-snmp/issues/190
    [ bvanassche: modified variable names and source code comment ]

commit 325b0df837197fd8f9af23eee838daae3ff80753
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Fri Nov 6 20:45:07 2020 -0800

    snmpd: Use sigprocmask() instead of sighold() and sigrelse()
    
    The latter two functions are obsolete, hence use sigprocmask() instead.

commit 5a18e300bd085c6ba5967d7b00cc3f57fe83f665
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Thu Oct 8 20:12:44 2020 -0700

    HOST-RESOURCES-MIB: Add support for f2fs
    
    See also https://github.com/net-snmp/net-snmp/issues/111 .

commit b1569c31514bf76fceb93f80c8b844101ee55e3a
Author: Pavel Trushkin <pavel@dcmsys.com>
Date:   Wed Sep 2 12:58:03 2020 +0300

    fix the similar leak in SNMP::NODE::FETCH

commit 581698a162b47b08f8571c7e1b8991df0764e5d3
Author: Pavel Trushkin <pavel@dcmsys.com>
Date:   Wed Sep 2 12:47:07 2020 +0300

    fix resource leaks in the SNMP::Session destructor and SNMP::NODE::FETCH

commit 5adc5bbcec46eacf654ed92ed2431d0965076fa9
Author: Guillem Jover <gjover@sipwise.com>
Date:   Fri Apr 22 15:45:07 2016 +0200

    Perl, agent: Make the perl agent code more tolerant of perl types
    
    The code is currently very strict, and does not accept several internal
    perl representations for integer scalars.
    
    First we should use SvPOK instead of SvPOKp to accept anything that
    looks like a string. And then we should also accept floating point
    numbers because they might store integer or unsigned values.

commit d59ae433af8b6d9051d149ca2a745fc845e7c82d
Author: Guillem Jover <gjover@sipwise.com>
Date:   Fri Apr 22 15:45:07 2016 +0200

    Perl, agent: Print the perl scalar flags on type mismatch in setValue
    
    This makes it easier to debug why a type mismatch happened, as we can
    see how the type is represented internally by perl.

commit 4d686f50d165f6b2b8fc79c9ae8f0a5702644fd8
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Sep 27 19:24:19 2020 -0700

    ci/openssl.bat: Bump the OpenSSL version

commit b65fc0f848142543314329ca286fb90fc5f87773
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Sep 27 14:06:46 2020 -0700

    configure: Update config.guess to the latest version
    
    Update config.guess to commit 4aa554d72b2a ("config.guess: Don't use
    'ldd --version' to determine the presence of musl libc") from
    https://git.savannah.gnu.org/gitweb/?p=config.git to fix compatibility
    with the aarch64 architecture. See also
    https://github.com/net-snmp/net-snmp/issues/188.

commit 62f024175a73c9b669f9bd8c7e75a65017622f3a
Author: urs-k <71150165+urs-k@users.noreply.github.com>
Date:   Wed Sep 16 08:54:57 2020 +0200

    snmpd: Fix a memory leak in ipAddressPrefixTable_data_access.c
    
    See also https://github.com/net-snmp/net-snmp/pull/183.
    
    [ bvanassche: adjusted commit message and reindented code ]

commit b30e5b6c682e7095d61401461d9305dbfe99e914
Author: Magnus Fromreide <magfr@lysator.liu.se>
Date:   Fri Aug 14 00:39:34 2020 +0200

    Do not require privacy in T0222

commit d1578077f41f232831b9b68fea2cc75f39569fe2
Author: Magnus Fromreide <magfr@lysator.liu.se>
Date:   Mon Sep 7 08:25:42 2020 +0200

    Correct the name of the V5-9-patches branch

commit 8fabe044e316f9ecda53148d9afeaf5e5854bb1a
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Sep 6 14:21:52 2020 -0700

    agent/mibgroup/util_funcs: Use posix_spawn() if fork() is not available
    
    This patch restores pass_persist support for operating systems that do
    not support fork(), e.g. uClinux. The pass_persist support added by this
    patch is much more useful than the implementation removed by commit
    e55d56212b72 ("snmpd: Remove the uClinux code from get_exec_pipes()").
    The new implementation uses anonymous pipes while the old implementation
    used named pipes with hardcoded paths (/flash/cp_%d and /flash/pc_%d).

commit 537ae2f0b64f067d354db34a742a28260aa21aa1
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Sep 6 14:29:53 2020 -0700

    agent/mibgroup/util_funcs: Use dup2() instead of dup()
    
    This patch makes the code easier to read but does not change any
    functionality.

commit e34f0793b641998eb4f9bedb4f7929bb0e3051b8
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Sep 6 15:13:58 2020 -0700

    libsnmp: Allocate the module import list on the heap
    
    Since that list occupies 8 KiB, allocate it on the heap instead of on the
    stack.

commit ed4c8e85cb44e84ada5b8d2ff58e903de7ede737
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Sep 6 15:12:48 2020 -0700

    libsnmp: Rework parse_imports()
    
    Do not cast pointers passed to free(). Reduce the number of return
    statements in this function to one. Surround multiline statements with
    braces.

commit 52d4a465dcd92db004c34c1ad6a86fe36726e61b
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Fri Sep 4 13:44:51 2020 -0700

    Darwin: Fix 'make install'
    
    Only attempt to install header files that exist under
    include/net-snmp/system/
    
    See also https://github.com/net-snmp/net-snmp/issues/181 .
    
    Fixes: f01c45c53cdc ("Darwin: Unify system header files")

commit 687b8c894f0de93b12f16ab9d5d9635adea39a6f
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Fri Sep 4 15:11:22 2020 -0600

    OpenBSD: Fix a build error and a compiler warning

commit ee7c66cf856dcda14f6d1d1503b80c0535509bc3
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Fri Sep 4 13:32:54 2020 -0700

    OpenBSD: Do not use the linker flag -no-undefined
    
    This patch fixes a linker error on OpenBSD.
    
    See also https://github.com/net-snmp/net-snmp/issues/178 .

commit 893b9baa6ae81a877e76842c29a637eeb2cbd0e2
Author: Guido Jäkel <g.jaekel@dnb.de>
Date:   Thu Sep 3 17:03:33 2020 +0200

    libsnmp: Increase MAX_IMPORTS
    
    Today, I stepped into an well-known old issue
    (https://sourceforge.net/p/net-snmp/mailman/message/16927159/) using MIBs
    for a CISCO device.
    
    [bvanassche: edited commit message]

commit 6093d4aee5cc81b8121458864d7e25fa7f46a7ba
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Mon Aug 31 20:46:21 2020 -0700

    libsnmp: Handle malloc() failure correctly in snmp_parse_oid()
    
    See also https://github.com/net-snmp/net-snmp/issues/177 .

commit 205c69a652d742d4914a4332ecc8915b52217719
Author: mark123499 <32741576+mark123499@users.noreply.github.com>
Date:   Thu Aug 27 15:19:11 2020 +0900

    snmpd: avoid container double free in error cases
    
    Fixes: ad653fb4618d ("new data access files")
    [ bvanassche: Added "Fixes" tag ]

commit 5b8bf5d4130761c3374f9ad618e8a76bb75eb634
Author: Yuwei Ba <i@xiaoba.me>
Date:   Fri Aug 21 15:06:10 2020 +0800

    snmpd: support MemAvailable on Linux
    
    See also https://github.com/net-snmp/net-snmp/pull/167 .
    
    [bvanassche: modified the behavior of this patch]

commit 410ddeff0b65937afd4bca6c7bfccc078fb5467d
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Fri Aug 28 20:28:04 2020 -0700

    snmpd: Reindent agent/mibgroup/hardware/memory/hw_mem.c
    
    Source code formatting in this file is weird. Reformat this source
    file with the help of the command mentioned in the CodingStyle file.

commit f73dbd3998755fe141ba724445b0cb74df1939f4
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Wed Aug 26 13:00:27 2020 -0700

    libsnmp: Use snprintf() instead of sprintf() in print_tree_node()
    
    This patch suppresses certain static analyzer complaints. See also
    https://github.com/net-snmp/net-snmp/issues/173 .

commit b14ff16eee753b29ef7659b34a67af89acee22f7
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Tue Aug 14 09:30:06 2018 -0700

    snmplib, IPv6: Fix MSVC build
    
    Fixes: 4916ce007362 ("Fix Solaris compiler warnings")
    Reported-by: Gisle Vanem <gvanem@yahoo.no>

commit c13b4349fad05caaa97e69924c020cb02139a367
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Wed Aug 26 07:58:03 2020 -0700

    Solaris: Fix a compiler warning

commit 7f5b50d5c51572f59d4b8c799cc6a676b0f1340f
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Jun 24 10:46:44 2018 -0700

    Fix Solaris compiler warnings
    
    This patch does not change any functionality.

commit adf7fda1f6b7123494875e8cd19b7445427b28ad
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Mon Aug 24 19:40:48 2020 -0700

    snmpd, snmptrapd: Fix a bug in an error path of parse_cmd()
    
    Fixes: 11e119c802e5 ("snmpd, util_funcs: Introduce the parse_cmd() function")

commit ec28fff5c0dede00767b50cebe8959369e6d7035
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Mon Aug 24 15:07:02 2020 -0700

    libsnmp: Fix handling of the minus character in mib configuration directives
    
    Change one occurrence of 'confmibdir' into 'confmibs'. It seems like the
    original code is the result of a copy/paste error. See also
    https://github.com/net-snmp/net-snmp/issues/170.
    
    Fixes: 4253c5431631 ("make mibs, mibdirs and mibfiles handling consistent")

commit f43a7213badf0b4014bb744021199fb2a127efff
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Mon Aug 24 06:58:04 2020 -0700

    snmpd, snmptrapd: Let configure check whether getdtablesize() is available
    
    This patch fixes the Net-SNMP build for termux.
    
    See also https://github.com/net-snmp/net-snmp/issues/155.

commit 6bf543981b59f0048c640203b620c49db4c97d09
Merge: 29a707be5 7266ff58d
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Aug 22 15:15:53 2020 -0700

    Merge branch 'V5-8-patches' into V5-9-patches
    
    * V5-8-patches:
      Windows: Unbreak the MSVC build of agent/mibgroup/agent/extend.c

commit 29a707be54d1df5b90ac1a5bc72ae919b015e63d
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Aug 22 15:09:55 2020 -0700

    dist/svnup: Remove this script because is no longer needed

commit b04033209dc4ab9bdb4dffaf09b553438ac41797
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Aug 22 10:46:01 2020 -0700

    dist/net-snmp.spec: Improve the Net-SNMP RPM spec file
    
    Use the local Net-SNMP source code archive instead of downloading it from
    SourceForge. Only prefix the version number with %{epoch}: on RHEL / Fedora
    systems. Package the pkg-config files (.pc). Fix multiple rpmbuild warnings.

commit 582b77e038ec63592a0a3e8b6bed069481e5776f
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Aug 22 10:34:41 2020 -0700

    Makefile.in: Add 'rpm' make target

commit efd048bc43bd99b756a984a16e735395cac22e4a
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Aug 22 10:16:06 2020 -0700

    agent/mibgroup/versiontag: Switch from CVS to git
    
    Instead of instructing the user to copy the Net-SNMP source files into a
    subdirectory, create the tar archive from the source files administered
    by git.

commit d5f6910373df6a8d501c402d29e038574d1e0975
Author: Craig Small <csmall@debian.org>
Date:   Sat Aug 22 08:57:28 2020 -0700

    Makefile.rules: Install the pkgconfig files as data files
    
    See also https://github.com/net-snmp/net-snmp/issues/168 .
    
    Fixes: 6e1329bde834 ("NEWS: Add pkg-config support for building applications and sub-agents")
    
    [bvanassche: Added patch description]

commit 7266ff58d0a289ecff74492c39d60ed42da2e437
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Aug 15 19:22:01 2020 -0700

    Windows: Unbreak the MSVC build of agent/mibgroup/agent/extend.c
    
    Fixes: 2703c379582f ("EXTEND MIB: Fix two recently introduced compiler warnings")

commit 5561bd1a35396fc36697a246bbb0ad391d5fc3e5
Merge: 8827eaf2b dc09b72c3
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Fri Aug 21 07:37:33 2020 -0700

    Merge branch 'V5-8-patches' into V5-9-patches
    
    * V5-8-patches:
      UCD-SNMP proxy: Fix OID substitution
      UCD-SNMP proxy: Document struct simple_proxy members
      UCD-SNMP proxy: Remove an unused member from struct simple_proxy

commit dc09b72c32129e68c85d540e3dee64d4e9450910
Merge: 5287a8e10 b6f37de20
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Fri Aug 21 07:32:59 2020 -0700

    Merge branch 'V5-7-patches' into V5-8-patches
    
    * V5-7-patches:
      UCD-SNMP proxy: Fix OID substitution
      UCD-SNMP proxy: Document struct simple_proxy members
      UCD-SNMP proxy: Remove an unused member from struct simple_proxy

commit b6f37de20c46258aa081137cae2e670adce98254
Author: Josef Ridky <jridky@redhat.com>
Date:   Fri Aug 21 07:27:16 2020 -0700

    UCD-SNMP proxy: Fix OID substitution
    
    See also https://github.com/net-snmp/net-snmp/issues/165.
    
    This patch reverts commit 4eb12f0efedd ("we actually want to use the base
    OID as the starting point, not the reg OID").
    
    [bvanassche: Added commit message]

commit 11ee42c1f03fc0c779dacd2e852e44ba457f9457
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Fri Aug 21 07:18:40 2020 -0700

    UCD-SNMP proxy: Document struct simple_proxy members

commit e11dc1d9d3566cb1acbeb6bed9481ac3434b7b33
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Fri Aug 21 07:19:22 2020 -0700

    UCD-SNMP proxy: Remove an unused member from struct simple_proxy
    
    This change does not affect the Net-SNMP ABI since the proxy.h header
    file is a private header file.

commit 8827eaf2b93901987cb846b3255a99634833ab91
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Aug 16 17:04:25 2020 -0700

    agent/mibgroup/ucd-snmp/pass_persist: Let configure check for waitpid()

commit f0b4b2c73059e3f9357d9a76472c45a80ed037a9
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Aug 16 16:58:16 2020 -0700

    agent/mibgroup/ucd-snmp/pass_persist: Simplify write_persist_pipe()
    
    Do not ignore SIGPIPE since snmpd and snmptrapd already do this.

commit 9b33b399633e1fcea7e88d8b1a3aa774f03220c8
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Aug 16 16:46:59 2020 -0700

    agent/mibgroup/ucd-snmp/pass_persist: Simplify init_persist_pipes()
    
    No functionality is changed.

commit c8eb12eaad9f5d18702545a0eb51a9e64266efb3
Author: Magnus Fromreide <magfr@lysator.liu.se>
Date:   Sun Aug 16 16:44:37 2020 -0700

    agent/mibgroup/ucd-snmp/pass_persist: Reduce the size of struct persist_pipe_type
    
    Remove the fOut and fdIn members because these are not used.
    
    [bvanassche: Added a patch description]

commit ffb91a5d41719cad5b687f70fed0b80cde5c535f
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Aug 16 20:27:32 2020 -0700

    agent/mibgroup/util_funcs: Split get_exec_pipes() in multiple functions
    
    No functionality has been changed.

commit 80fed0e33eb2130d962d81375aee3f1bea2ec51c
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Aug 16 20:09:13 2020 -0700

    agent/mibgroup/util_funcs: Add a debug statement

commit 08864f1d3d0ba33a77e004285154223a8fd7a915
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Aug 16 20:18:12 2020 -0700

    agent/mibgroup/util_funcs: Fix two recently introduced compiler warnings
    
    Fixes: 11e119c802e5 ("snmpd, util_funcs: Introduce the parse_cmd() function")
    Fixes: 9b1288216457 ("snmpd, util_funcs: Declare the first argument of get_exec_pipes() const")

commit 1b37bd3b9577d123ca1f7c60cc83a0836d7bd669
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Aug 16 08:33:19 2020 -0700

    apps/snmpnetstat: Reindent source files
    
    Indentation of the source files in the apps/snmpnetstat directory
    does not follow the Net-SNMP coding style. Hence reindent these files
    using the command mentioned in the CodingStyle file.

commit 1ee70571e0cae37f155f59d4382bc7109138cf09
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Aug 15 17:29:25 2020 -0700

    apps/snmpnetstat: Stop using obsolete signal functions
    
    This was reported by Rosen Penev. See also
    https://github.com/net-snmp/net-snmp/pull/162.

commit 9bee0e4bba190e9af3acf3f054f5a222bee3d7c3
Author: Bill Fenner <fenner@gmail.com>
Date:   Tue Nov 6 08:28:02 2018 -0800

    routex.c now uses the sockaddr_size feature

commit d7fa60b251059d3954c745477917fcefe7c7453c
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Sep 23 14:34:49 2018 -0700

    MinGW32, apps/snmpnetstat: Fix compiler warnings about format specifier mismatches

commit 99fedfe1238a7cc1bae4d44f49314a58a3649f73
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Jun 23 18:19:41 2018 -0700

    apps: Use getnameinfo() instead of netsnmp_gethostbyaddr() where appropriate

commit ef99ca519c780508f4c358200dc05c2227023215
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Jun 23 19:23:25 2018 -0700

    apps/snmpnetstat: Modify the argument types of inet6print() and inet6name()
    
    This patch does not change any functionality.

commit dc08763e4616c31fd91bd7b2e38dceb716ab7fa0
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Jun 23 19:05:33 2018 -0700

    apps/snmpnetstat: Optimize the 127.0.0.1 comparison in inetname()
    
    This patch does not change any functionality.

commit 475f0db2f2ff5dd66f02438ba9dd7b279738c1b1
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Jun 23 18:50:44 2018 -0700

    apps/snmpnetstat: Constify several function arguments

commit 8f9acef689867b5a25d6cf0d15e02d863f53759c
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Jun 23 18:51:25 2018 -0700

    apps/snmpnetstat: Use inet_ntoa() instead of open-coding it

commit 152de25d75f5419be296dcf5f98b1ae3ffaf9608
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Aug 15 19:22:01 2020 -0700

    Windows: Unbreak the MSVC build of agent/mibgroup/agent/extend.c
    
    Fixes: 2703c379582f ("EXTEND MIB: Fix two recently introduced compiler warnings")

commit 11e119c802e54b108b6783e0834849c3926aaf6c
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Aug 9 18:24:20 2020 -0700

    snmpd, util_funcs: Introduce the parse_cmd() function
    
    This patch does not change any functionality.

commit 9b1288216457083eaa58b258d2c4726de31abd25
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Aug 9 18:12:12 2020 -0700

    snmpd, util_funcs: Declare the first argument of get_exec_pipes() const
    
    This patch does not change any functionality.

commit e55d56212b7260bf2b6f71d3ddd86ab7b27363ff
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Fri Aug 14 16:04:38 2020 -0700

    snmpd: Remove the uClinux code from get_exec_pipes()
    
    get_exec_pipes() is only used to open persistent pipes. So it is essential
    to use fork(). Using vfork() in the implementation of get_exec_pipes() is
    wrong because vfork() blocks the caller until the child process has
    finished. Since the uClinux implementation of get_exec_pipes() uses
    vfork(), remove the uClinux code from get_exec_pipes().

commit 26c1d4f2e58ce967c12a085784c86f9dd6ced862
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Aug 8 10:54:57 2020 -0700

    snmpd: Call fclose() after fdopen() but not close()
    
    From https://pubs.opengroup.org/onlinepubs/9699919799/functions/fclose.html:
    "The fclose() function shall perform the equivalent of a close() on the file
    descriptor that is associated with the stream pointed to by stream."
    
    Hence call fclose() but not close() if fdopen() succeeded.
    
    See also https://github.com/net-snmp/net-snmp/issues/157 .
    
    Fixes: fd9a42d142d8 ("- (pass-persist.c pass-persist.h): moved to pass_persist.[ch].")
    Fixes: a36188e50dcc ("Patch #760417 from Bob Rowlands/Sun for fixing Bug #751920")

commit 51c40b7ad54dd77f0313e09c56a4b1ef761e6ab5
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Aug 2 17:32:25 2020 -0700

    TLSTM-MIB: Fix a Coverity use-after-free complaint

commit 99e31c39e5cfe649617fcc8f6bb9dec31b7de82f
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Aug 2 16:55:19 2020 -0700

    Handle MIB registration failures instead of ignoring these
    
    This patch suppresses multiple Coverity 'use after free' complaints.

commit 02aee733f8d094749bd1fa4cf23fd53e6eff3f14
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Aug 1 17:18:38 2020 -0700

    libsnmp: Pass 0xff as second argument to memset() instead of '\xff'
    
    This patch suppresses the following Coverity warning:
    
    Memset fill truncated (NO_EFFECT)
    bad_memset: Argument 4294967295 in memset loses precision in
    memset(mask.__in6_u.__u6_addr8, 4294967295, j).

commit cd95f3065030e291122e4325f5ea69d3b2e9c619
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Aug 1 17:15:37 2020 -0700

    IF-MIB: Fix source code indentation
    
    This was detected by Coverity.

commit 19d75e01fc72b6e03992207d68bd6649950c70b8
Author: Wes Hardaker <opensource@hardakers.net>
Date:   Fri Aug 14 15:13:51 2020 -0700

    change active branches to 5.9 and master

commit 0e6790c62ed89cc00bd0203a1bcd2b837fe3526e
Author: Wes Hardaker <opensource@hardakers.net>
Date:   Fri Aug 14 15:12:03 2020 -0700

    added a file to force-push a branch


----------------------------------------------------------------------

Changes: V5.9.rc2 -> V5.9

commit f68a967f6f3aa999f906cd986ffb83f36d37e98b
Author: Wes Hardaker <opensource@hardakers.net>
Date:   Fri Aug 14 14:31:32 2020 -0700

    v5-4 is no longer in release either

commit a93761876be67802598338bc92473d7df529b00e
Author: Wes Hardaker <opensource@hardakers.net>
Date:   Fri Aug 14 14:31:16 2020 -0700

    remove release from dist/release

commit b7f01b1134c7a8ed578f8ab9ebecafc85ab2a757
Author: Wes Hardaker <opensource@hardakers.net>
Date:   Fri Aug 14 14:30:46 2020 -0700

    Version number update: 5.9

commit b65b426f1a056b39286b57f8ad855c77e6dffe2e
Author: Wes Hardaker <opensource@hardakers.net>
Date:   Thu Aug 6 14:07:23 2020 -0700

    changelog

----------------------------------------------------------------------

Changes: V5.8.1.rc1 -> V5.9.rc2

commit d8dc063e6c41b870b84430e92ab0f5183f014e22
Author: Wes Hardaker <opensource@hardakers.net>
Date:   Tue Aug 4 17:21:16 2020 -0700

    autoconf

commit 7ba8a81fe24a60744ef7570f06c40de6cd4e4729
Author: Wes Hardaker <opensource@hardakers.net>
Date:   Tue Aug 4 17:20:53 2020 -0700

    Fix variable check to include an x prefix for safety

commit bbd53ed4a42929d0c93645e069b466daa4f0fbce
Author: Wes Hardaker <opensource@hardakers.net>
Date:   Tue Aug 4 17:20:43 2020 -0700

    network pcre detection

commit 8f371058e274f8a3cf1b293648b8eebc1086a2c9
Author: Wes Hardaker <opensource@hardakers.net>
Date:   Tue Aug 4 17:20:07 2020 -0700

    fix libwrap reference not including previous value

commit bbd6adc7794d450910aded191c94836a12614da1
Author: Wes Hardaker <opensource@hardakers.net>
Date:   Fri Jul 31 07:47:40 2020 -0700

    Version number update: 5.9.rc2

commit 2703c379582f17076e625606e9fbd63feb6533f4
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Fri Jul 24 08:35:44 2020 -0700

    EXTEND MIB: Fix two recently introduced compiler warnings
    
    See also commit 77f6c60f57db ("make the extend mib read-only by default").

----------------------------------------------------------------------

Changes: V5.8.1.pre2 -> V5.8.1.rc1

commit 0ee30b8ad6646c6bdd96ee67c82641ed50ce6519
Author: Wes Hardaker <opensource@hardakers.net>
Date:   Thu Jul 23 17:05:50 2020 -0700

    Release Candidate for V5-8-patches

commit f2ce116c5ff3e6dddb4186905bb277c38025b047
Author: Wes Hardaker <opensource@hardakers.net>
Date:   Thu Jul 23 17:05:47 2020 -0700

    Version number update: 5.8.1.rc1

commit 77f6c60f57dba0aaea5d8ef1dd94bcd0c8e6d205
Author: Wes Hardaker <opensource@hardakers.net>
Date:   Thu Jul 23 16:17:27 2020 -0700

    make the extend mib read-only by default

commit 4097a311e952d3b5c12610102bb4cc2fe72b56e5
Author: Wes Hardaker <opensource@hardakers.net>
Date:   Thu Jul 23 15:46:12 2020 -0700

    Revert "snmpd: Disable NET-SNMP-EXTEND-MIB support by default"
    
    This reverts commit c2b96ee744392243782094432f657ded4e985a07.

commit b13410f5b35fd281b9e93113aaa47f9f5c418974
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Wed Jul 22 09:26:29 2020 -0700

    snmpd, snmptrapd: Disallow to change the user / group after it has been set
    
    This patch causes the -u and -g arguments to take precedence over the
    agentuser and agentgroup keywords.

commit 53922d2d8873c460d526b8bba9a285c5b98c9e1f
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Wed Jul 22 09:22:30 2020 -0700

    snmpd, snmptrapd: Introduce the netsnmp_set_agent_{user,group}_id() functions
    
    This patch does not change any functionality.

commit ba7740a2188184ce2beb36dd1e81b88ced390294
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Tue Jul 21 07:36:43 2020 -0700

    snmpd, snmptrapd: Reduce code duplication
    
    Consolidate and rename the two copies of the functions that parse user
    and group IDs.

commit 42e97a741dbc71ce4ab2671fc057b8488638d3b8
Author: Wes Hardaker <opensource@hardakers.net>
Date:   Thu Jul 16 08:01:44 2020 -0700

    Use more appropriate accept/block terminology

commit e772b8017d7e235437a45622bf8aa05f3ef3d084
Author: Robert Story <rstory@freesnmp.com>
Date:   Mon Jul 13 12:45:22 2020 -0400

    fix issue #99: read stored ifXTable config at startup

commit c2b96ee744392243782094432f657ded4e985a07
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Jul 11 09:42:55 2020 -0700

    snmpd: Disable NET-SNMP-EXTEND-MIB support by default
    
    Since it is possible to abuse this MIB for privilege escalation attacks,
    disable it by default. Notes:
    - It is still possible to enable this MIB via the --with-mib-modules
      configure option.
    - Another MIB that provides similar functionality, namely
      ucd-snmp/extensible, is disabled by default.
    - The security risk of ucd-snmp/pass and ucd-snmp/pass_persist is lower
      since these modules only introduce a security risk if the invoked
      scripts are exploitable.

commit 6fd7499ccaafdf244a74306972562b2091cb91b1
Author: fisabelle <fisabelle@broadsoft.com>
Date:   Thu Jul 9 15:49:35 2020 -0400

    Issue#147: Net-SNMP not responding when proxy requests times out

commit 5a464044f95339f979f6b2fdfa756a08d519b78e
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Jul 5 14:09:56 2020 -0700

    Stop using config_arch_require()
    
    Stop using config_arch_require() since the effect of this macro is confusing.
    As an example, #define freebsd4 freebsd4 occurs in a header file that is
    included indirectly when building on FreeBSD 12. However, the following test
    in config_modules_agent does not recognize the expansion of freebsd4 into
    freebsd4:
    
        # target_os may have been changed to a #define of 1...
        if test "x$archtest" = "x1" -o "x$target_os" = "x$archtest" -o "x$PARTIALTARGETOS" = "x$archtest"; then

commit dec4eaa0626ef2447d41ea1af125809bfb86fbe8
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Jul 5 12:53:25 2020 -0700

    FreeBSD: Fix the sysctl() configure test
    
    This patch fixes the following compiler warnings:
    
    conftest.c:406:1: warning: type specifier missing, defaults to 'int' [-Wimplicit-int]
    main() {
    ^
    conftest.c:415:41: warning: incompatible pointer to integer conversion passing 'void *' to parameter of type 'size_t' (aka 'unsigned long') [-Wint-conversion]
      sysctl(mib, 2, &boottime, &len, NULL, NULL);
                                            ^~~~
    /usr/include/sys/_null.h:34:14: note: expanded from macro 'NULL'
                    ^~~~~~~~~~~
    /usr/include/sys/sysctl.h:1062:70: note: passing argument to parameter here
    int     sysctl(const int *, u_int, void *, size_t *, const void *, size_t);
                                                                             ^
    conftest.c:417:5: warning: implicitly declaring library function 'exit' with type 'void (int) __attribute__((noreturn))' [-Wimplicit-function-declaration]
        exit(0);
        ^
    conftest.c:417:5: note: include the header <stdlib.h> or explicitly provide a declaration for 'exit'
    3 warnings generated.

commit 72afad88ad58653687383b81b73299b5fdd6e8c4
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Jul 4 14:30:58 2020 -0700

    ci/net-snmp-configure: Improve FreeBSD support
    
    Make freebsd_pkg_version() accept multiple package names. Rename
    the opensshver variable into libssh2ver.

commit 18edbbfa20689f5b4d38390b9be7006d98f67195
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Fri Jul 3 18:44:44 2020 -0700

    ci: .travis.yml: Comment out Xcode 10.x

commit ec9667c508cec45fc1e8e87fbd3f3687161926a1
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Fri Jul 3 14:49:17 2020 -0700

    ci/net-snmp-configure: Disable Python modules for Darwin 10 or older
    
    Building Python modules fails with older versions of Xcode, hence do not
    build Python modules for older versions of Xcode.

commit b3532cd6111eed67eaf83c540b05a175bc8f1fc1
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Fri Jul 3 14:17:40 2020 -0700

    ci/net-snmp-configure: Only include snmp-usm-dh-objects-mib if openssl/dh.h is available

commit 9945a3c8928d9358c7d8c5b4e8ec7b6250835f13
Author: Wes Hardaker <opensource@hardakers.net>
Date:   Fri Jul 3 15:46:48 2020 -0700

    minor wording fixes

commit c76c17abc03e5519ab75f2b7e951df40ae7a1ddd
Author: Wes Hardaker <opensource@hardakers.net>
Date:   Fri Jul 3 15:45:51 2020 -0700

    removed the way out of date thank you list, and referred to the git log

commit 1b54c6b895ba8311644427a958e43229853a853d
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Fri Jul 3 10:05:44 2020 -0700

    ci: Reduce the number of combinations built by Travis

commit f01c45c53cdc931faf68fb33389928a29f1297f9
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Tue Jun 30 16:53:05 2020 -0700

    Darwin: Unify system header files
    
    See also https://sourceforge.net/p/net-snmp/bugs/2504/ .

commit 9e892736ff0b04c5af5775d09155e392c76f7aae
Author: Niels Baggesen <nba@users.sourceforge.net>
Date:   Thu Jul 2 22:18:50 2020 +0200

    parse: remove a forgotten debug message

commit 51113450e8e653cf8261a8d09dc204a45c10b61a
Author: Niels Baggesen <nba@users.sourceforge.net>
Date:   Thu Jul 2 22:16:21 2020 +0200

    snmpwalk/snmpbulkwalk: flush stdout buffers before bailing out on stderr

commit 2e927ad46cce5eeaeb346d638e46d409e8220a79
Author: Niels Baggesen <nba@users.sourceforge.net>
Date:   Thu Jul 2 22:08:22 2020 +0200

    IANA updates for IANAifTypeMIB and IANA-ADDRESS-FAMILY-NUMBERS-MIB

commit 30238618812171bed934fe8fac629ad6ae22c75e
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Thu Jul 2 11:18:00 2020 -0700

    testing: Skip tests T055 and T056 on OS/X
    
    These tests fail when building with Xcode 12, so skip these tests.

commit 043b61801987d70cb5aa01280950afde1d5b061e
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Wed Jul 1 11:05:41 2020 -0700

    Darwin: Only include mibII/{ipAddr,var_route} if struct in_ifaddr is available
    
    This patch fixes the following build error for Xcode 12 and later:
    
    libtool: compile:  gcc -I../../include -I. -I../../agent -I../../agent/mibgroup -I../../snmplib -I/usr/local/opt/openssl@1.1/include -D_GNU_SOURCE -D_ALL_SOURCE -D_THREAD_SAFE -D__EXTENSIONS__ -DNETSNMP_ENABLE_IPV6 -fno-strict-aliasing -DNETSNMP_REMOVE_U64 -Udarwin19 -Ddarwin19=darwin19 -Wall -Wextra -Wstrict-prototypes -Wwrite-strings -Wcast-qual -Wno-missing-field-initializers -Wno-sign-compare -Wno-unused-parameter -Wno-type-limits -Wno-deprecated-declarations -c mibII/ipAddr.c  -fno-common -DPIC -o mibII/.libs/ipAddr.o
    1480mibII/ipAddr.c:206:29: error: variable has incomplete type 'struct in_ifaddr'
    1481    static struct in_ifaddr in_ifaddr, lowin_ifaddr;
    1482                            ^

commit af3e76ce47f84bc37f8a20718d4e63aa8491d0f4
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Wed Jul 1 19:31:41 2020 -0700

    ucd-snmp/extensible.h: Add config_require(ucd-snmp/pass)
    
    Since this module calls pass_compare(), add a dependency on ucd-snmp/pass.
    This patch fixes the following runtime error on Darwin:
    
    dyld: Symbol not found: _pass_compare
      Referenced from: /Users/travis/build/bvanassche/net-snmp/agent/.libs/libnetsnmpmibs.40.dylib
      Expected in: flat namespace
     in /Users/travis/build/bvanassche/net-snmp/agent/.libs/libnetsnmpmibs.40.dylib

commit ebf93f489b42bbeeebd7b3e3bb8726cb8175fa2e
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Wed Jul 1 19:29:38 2020 -0700

    UCD-SNMP: Remove two superfluous casts

commit 9d123ce7407d8f46136bdbcab31205f95f997422
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Wed Jul 1 10:24:22 2020 -0700

    ci/net-snmp-configure: Only build Python modules if Python3 is available

commit c06e6ce53f85746a414cd79b1a9c4e66cdc31bf8
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Tue Jun 30 19:15:49 2020 -0700

    Darwin: Detect <crt_externs.h>, _NSGetArgv() and _NSGetExecutablePath()

commit 300ae4c59c4e60eaf679af69f3e17150c8cbf5ce
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Tue Jun 30 16:58:52 2020 -0700

    ci: Test more Darwin versions

commit 31a2c8065db102c876937ff64ee90c60b516d945
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Mon Jun 29 12:35:02 2020 -0700

    libsnmp: Change several constants from unsigned char into unsigned int
    
    The C language requires that the operands of a bitwise or expression
    are promoted before the bitwise OR happens. From the C standard:
    "The following may be used in an expression wherever an int or unsigned int
    may be used:
    - An object or expression with an integer type (other than int or unsigned
      int) whose integer conversion rank is less than or equal to the rank of
      int and unsigned int.
    - A bit-field of type _Bool , int, signed int, or unsigned int.
    
    If an int can represent all values of the original type (as restricted by
    the width, for a bit-field), the value is converted to an int; otherwise,
    it is converted to an unsigned int. These are called the integer promotions.
    All other types are unchanged by the integer promotions."
    
    In other words, the result of a bitwise OR of two unsigned char operands
    has type 'int' instead of unsigned int. Hence change the type of constants
    in header files from unsigned char into unsigned int.
    
    See also https://github.com/net-snmp/net-snmp/issues/142.

commit 3df7a6ac1e0c652839446ebb53ff6f8cc14f7084
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Mon Jun 29 12:41:31 2020 -0700

    agent/mibgroup/agentx/master_admin.c: Fix indentation
    
    This patch fixes the following clang compiler warning:
    
    mibgroup/agentx/master_admin.c:449:2: warning: misleading indentation; statement is not part of the previous 'if' [-Wmisleading-indentation]
            if (pdu->contextName != NULL)
            ^
    mibgroup/agentx/master_admin.c:434:5: note: previous statement is here
        if (!var || snmp_oid_compare(var->name, var->name_length,
        ^

commit 9963ec1be6c595205773b4177b5931ca550b1f79
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Jun 28 19:44:39 2020 -0700

    Introduce usm_build_user()
    
    This patch does not change any functionality.

commit 2abda404ae805b1c369b0e68a2e489b3996f0ba0
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Jun 28 15:23:52 2020 -0700

    testing/fulltests/default/T0222snmpv3bulkget_simple: Remove the IF-MIB::ifEntry test

commit 24a8b092cce342d62a477394c60f572e49a90197
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Jun 28 14:36:10 2020 -0700

    Add test T0222snmpv3bulkget_simple
    
    See also https://github.com/net-snmp/net-snmp/issues/141.

commit a0932b73ea0851308ca3e797caa600192cc3508a
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Jun 27 19:49:03 2020 -0700

    CHANGES: Bump libsnmp version from 35.0.1 to 40.0.0
    
    Several functions and one data structure have been removed from header
    file include/net-snmp/library/snmpusm.h. Hence bump the libsnmp version
    number. For the previous libsnmp version bump, see also 1b3ef39cb7a3
    ("version update for 5.8.1.pre1").

commit 576788a0a9400da517ddb8ceb33a742f552a1408
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Thu Jun 25 20:57:05 2020 -0700

    libsnmp: Remove usm_clone_usmStateReference() from the public interface
    
    Since this function is only used inside the USM implementation, remove
    its declaration from the public interface.

commit 46f755fe4e6c2a919eebae0c55495f5f1207d06c
Author: Ramin Moussavi <lordrasmus@gmail.com>
Date:   Tue Jun 9 13:42:50 2020 +0200

    pingCtlTable: Move two more global variable definitions from .h to .c

commit 611149a879ef581454ffdd8637633197607750ff
Author: Jonas Bülow <jonas.bulow@gmail.com>
Date:   Mon Jun 1 10:09:53 2020 +0200

    libsnmp: Remove an obsolete keyword from a header file
    
    This allows compilation using C++17 where the register keyword is obsoleted.
    
    Also, the register keyword is in general never necessary.
    
    [ bvanassche: edited commit message ]

commit 327079a4ae20e2d4766fe549a6e4e57fbe947bcd
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Tue May 26 06:38:53 2020 -0700

    HOST-MIB, hr_filesys: Also monitor tmpfs
    
    See also https://sourceforge.net/p/net-snmp/feature-requests/165/,
    https://bugs.debian.org/685877 and
    https://gitlab.alpinelinux.org/alpine/aports/issues/932.
    
    Fixes: 2dfdd7cb73ec ("Better file system types") # v5.7
    Reported-by: Craig Small <csmall@dropbear.xyz>

commit 22e1371bb1fd4a502fc1065fb5aa6b6df8a6d0d2
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Tue May 26 07:19:07 2020 -0700

    HOST-MIB, hr_filesys: Convert recursion into iteration

commit 9238c0df6044f399f33e51c3bea89ee321b2882d
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Tue May 26 07:34:51 2020 -0700

    HOST-MIB, fsys: Remove definitions that have been commented out

commit a3ef7905e83320f834ef335d121948d6e7d58ff8
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Fri May 15 07:13:37 2020 -0700

    MIB-II: Declare local symbols static

commit 93a9f7f32612aa041e150b0d897ba3cdfda6e1db
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Fri May 15 07:10:20 2020 -0700

    MinGW64, MIB-II: Fix a linker error
    
    Fix the following linker error:
    
    ld.exe: ./.libs/libnetsnmpmibs.a(var_route.o):var_route.c:(.bss+0x8): multiple definition of `create_flag'; ./.libs/libnetsnmpmibs.a(at_iphlpapi.o):at_iphlpapi.c:(.bss+0x8): first defined here

commit 68a8dcd937ca9d69764f20e495b1723d818d12b7
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Thu May 14 20:28:53 2020 -0700

    ci/net-snmp-run-python-tests: Use Python3 interpreter

commit c01c5544bf02a139a3d103eead3c92378e75f737
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Thu May 14 20:26:28 2020 -0700

    python: Define PY_SSIZE_T_CLEAN
    
    See also https://docs.python.org/3/c-api/arg.html .

commit e4a4f0abca261bb62ea97c275223cf604b23288d
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Thu May 14 19:28:43 2020 -0700

    python: Improve Python3 port
    
    See also https://github.com/net-snmp/net-snmp/issues/80.
    
    [ bvanassche: Removed commented out code and fixed compiler warnings ]

commit 6a8ede044a269f2c10a6463e96d03709bb974151
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Fri May 8 19:32:52 2020 -0700

    Python: Fix compiler warnings

commit 5de21610ff249d456c42530d0b8179bf1420a0e0
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Fri May 8 19:10:48 2020 -0700

    perl/SNMP/t/bulkwalk.t: Improve the reliability of this test
    
    Use ok($a, $b) instead of ok($a eq $b) to make error reporting more
    informative. Unbless $list[3] before iterating over it to make this
    test passs on DragonFly BSD. In the loop that looks for the loop
    network adapter, check whether the index of that adapter is numeric
    instead of comparing it with one.

commit 8bdae3bf48b3e80e148c2b20dc0f284119dc4548
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Fri May 8 21:41:52 2020 +0000

    perl/SNMP/t/bulkwalk.t: Make this test easier to debug

commit 57936ba304d18e6c23f31b242ff6d0a95e846c4f
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Fri May 8 19:33:10 2020 -0700

    libsnmp: Declare the arguments of netsnmp_transport_create_config() const

commit 78beea8ef011702c026fdb3b32f118edcd2d6de4
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Tue May 5 08:25:55 2020 -0700

    configure: Do not use -Wl,-no-undefined if -fsanitize= has been specified
    
    Apparently these two compiler flags are incompatible. This patch should
    fix the following build failure:
    
    https://bugs.chromium.org/p/oss-fuzz/issues/detail?id=22010

commit 2d6ccd92f16a0ea2cf03ff26bdbdc46f0c93e4f8
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Tue May 5 07:49:58 2020 -0700

    configure: Ignore the krb5_config -flto=auto flag
    
    -flto=auto is incompatible with clang, hence ignore that compiler flag.

commit fd2f267370435996eca54be70525f592fec3f0d8
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Mon May 4 17:32:30 2020 -0700

    libsnmp: Declare decode_keychange() input arguments const

commit 998a1686cbc202d2a5f3b4bc3933719cb13aaebd
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Mon May 4 15:11:59 2020 -0700

    snmpd: Fix a buffer overflow triggered by processing "getnext"
    
    This patch fixes the following Valgrind complaint:
    
    Invalid write of size 8
       at 0x4864DD4: netsnmp_scalar_helper_handler (scalar.c:225)
       by 0x4872008: netsnmp_call_handler (agent_handler.c:546)
       by 0x4872369: netsnmp_call_next_handler (agent_handler.c:660)
       by 0x48655B6: netsnmp_serialize_helper_handler (serialize.c:86)
       by 0x4872008: netsnmp_call_handler (agent_handler.c:546)
       by 0x487219C: netsnmp_call_handlers (agent_handler.c:631)
       by 0x4881D52: handle_var_requests (snmp_agent.c:3012)
       by 0x488245A: handle_getnext_loop (snmp_agent.c:3502)
       by 0x4882D97: handle_pdu (snmp_agent.c:3849)
       by 0x4882F03: netsnmp_handle_request (snmp_agent.c:3685)
       by 0x48835AB: handle_snmp_packet (snmp_agent.c:2294)
       by 0x4C53CA7: _sess_process_packet_handle_pdu (snmp_api.c:5809)
       by 0x4C5409F: _sess_process_packet (snmp_api.c:5858)
       by 0x4C5443C: _sess_read (snmp_api.c:6115)
       by 0x4C55009: snmp_sess_read2 (snmp_api.c:6387)
       by 0x4C55046: snmp_read2 (snmp_api.c:5907)
       by 0x403E43: receive (snmpd.c:1311)
       by 0x405765: main (snmpd.c:1089)
     Address 0x63a0908 is 0 bytes after a block of size 72 alloc'd
       at 0x483877F: malloc (in /usr/lib64/valgrind/vgpreload_memcheck-amd64-linux.so)
       by 0x4C5002E: snmp_duplicate_objid (snmp_api.c:7844)
       by 0x4872992: netsnmp_handler_registration_dup (agent_handler.c:844)
       by 0x487575C: netsnmp_subtree_deepcopy (agent_registry.c:524)
       by 0x4875B61: netsnmp_subtree_split (agent_registry.c:660)
       by 0x487666F: netsnmp_subtree_load (agent_registry.c:940)
       by 0x48766A4: netsnmp_subtree_load (agent_registry.c:947)
       by 0x48766A4: netsnmp_subtree_load (agent_registry.c:947)
       by 0x48766A4: netsnmp_subtree_load (agent_registry.c:947)
       by 0x48770A4: netsnmp_register_mib (agent_registry.c:1214)
       by 0x4872655: netsnmp_register_handler (agent_handler.c:318)
       by 0x48656AB: netsnmp_register_serialize (serialize.c:56)
       by 0x4864F07: netsnmp_register_scalar (scalar.c:98)
       by 0x48712FC: netsnmp_register_watched_scalar2 (watcher.c:211)
       by 0x49822AC: _register_extend (extend.c:221)
       by 0x4982870: extend_parse_config (extend.c:576)
       by 0x4C65EAD: run_config_handler (read_config.c:541)
       by 0x4C66D19: read_config (read_config.c:960)
       by 0x4C67422: read_config_with_type_when (read_config.c:481)
       by 0x4C6770A: read_configs_optional (read_config.c:1018)
       by 0x4C6809D: read_configs (read_config.c:1049)
       by 0x4C55418: init_snmp (snmp_api.c:907)
       by 0x405013: main (snmpd.c:911)

commit 836cd352bb43f3e1483a0e4937c5f05f6eab1eb9
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Mon May 4 08:35:45 2020 -0700

    libsnmp, snmpd: Handle PDU cloning failures

commit 644a9aa6f4816f5739161c674b793a28d99f69c3
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Mon May 4 10:53:54 2020 -0700

    libsnmp: Declare USM input parameters const

commit a9219e3ecee5ce0cafdcbfaee50ac70ef290fc5b
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Mon May 4 09:13:00 2020 -0700

    libsnmp: Declare the usm_get_user() arguments const

commit 7d27dd105f2633f4dfa3e3ee0a7689e5a5752b13
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Mon May 4 07:49:33 2020 -0700

    libsnmp, snmpd: Fix two potential buffer overflows
    
    Both bugs were introduced before 2001.
    
    See also https://github.com/net-snmp/net-snmp/issues/110 .

commit 6c4fe0e446d3da50ed5ca8bd79f8949f0b803ddd
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Mon May 4 07:45:56 2020 -0700

    libsnmp: Declare a build_oid_noalloc() input argument const

commit a5495798fa1e18f819a5e54f06deefe5fb798942
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun May 3 20:14:59 2020 -0700

    snmpd: Remove a dead assignment
    
    Additionally, remove an explicit \0-termination because snprintf() is
    required to do \0-termination (see also
    https://pubs.opengroup.org/onlinepubs/9699919799/functions/fprintf.html).
    
    This patch fixes the following Coverity complaint:
    CID 144418 (#1 of 1): Unused value (UNUSED_VALUE)
    assigned_pointer: Assigning value from cur + snprintf(cur, ep - cur, " %i %i \"%s\" %s %i %i", curr_struct->timeout, curr_struct->retryCount, curr_struct->tagListData, curr_struct->paramsData, curr_struct->storageType, curr_struct->rowStatus) to cur here, but that stored value is overwritten before it can be used.

commit 5ab2436f775bcd1de1ed86fd5a39d55b4f30ea4f
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun May 3 19:52:23 2020 -0700

    agent/mibgroup/agent/extend.c: Remove dead code
    
    This patch fixes the following Coverity complaint:
    
    arith_non_null: The result of pointer arithmetic compatability_entries + idx is never null.
    dead_error_condition: The condition exten must be true.
    
    Fixes: 436bfa49439f ("Backwards-compatability implementation of the UCD-SNMP-MIB::extTable (if the ucd-snmp/extensible module isn't configured in).")

commit 559b8f5f9fdc66cf7612a31ff1a52825546f4f60
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun May 3 16:02:24 2020 -0700

    AIX: Also define aix4 on AIX5 and AIX6
    
    This patch allows to simplify the test defined(aix4) || defined(aix5) ||
    defined(aix6) into defined(aix4).

commit aebf5909df24692e1a03327ba2e49581a8574aa8
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun May 3 16:23:44 2020 -0700

    configure: Improve the MIT crypto API check

commit fc7002ecced1329b62238f6278576b11846da173
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun May 3 14:26:17 2020 -0700

    AIX: Fix one build error and also a compiler warning
    
    n_name is a #define on AIX and hence using 'n_name' as a variable name
    triggers a compiler error.

commit ee7eed065f652ccfc58cade8aef5848073cce7bf
Author: Bart Van Assche <bart@localhost>
Date:   Sat May 2 17:21:41 2020 -0700

    kFreeBSD: Fix the build
    
    See also https://github.com/net-snmp/net-snmp/issues/103.

commit f44565fc195698e8b79fdd905c17217f0e493196
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun May 3 11:21:10 2020 -0700

    Suppress recently introduced compiler warnings about close() not being declared

commit cb9b87d9b6e2b925065bf9cf700f9c44e5462d93
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat May 2 08:44:10 2020 -0700

    Always use -Wl,-no-undefined when linking a shared library
    
    Undefined symbols in a Net-SNMP shared library indicate a bug. Make sure
    that this is detected at link time instead of at run time.

commit 1fe4c024aa8e7d1e493039c3e1ca91dd06ffc5be
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat May 2 09:26:37 2020 -0700

    configure: Add -lkrb5 to LNETSNMPLIBS instead of LIBS
    
    Only the Net-SNMP library needs to be linked with the Kerberos libraries.
    Link with libk5crypto if necessary.

commit dfa82c4810b68181cb70fef07a7e8000beb98262
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat May 2 07:13:29 2020 -0700

    FreeBSD: Use the freebsd3 macro instead of __FreeBSD__
    
    Use the 'freebsd3' macro to guard code that is FreeBSD-specific. This will
    make it easier to fix the build for kFreeBSD. Note: the freebsd3 macro is
    defined if the FreeBSD version is >= 3.

commit 7c562f9b61397d8174b41c13244d2c69d729e13b
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat May 2 08:24:40 2020 -0700

    perl/SNMP/t/notify.t: Make this test more robust

commit 15737583d5271f398a38b2f11f900fbd73a7025b
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat May 2 08:17:40 2020 -0700

    UCD-SNMP-MIB: Move an include directive and a few constants into proc.c

commit 05c6c29c2c458261605fee8d3a8d59c97bba2878
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat May 2 08:10:29 2020 -0700

    ci/net-snmp-configure: Build without MySQL support

commit ca585bbbae9e4831a6e622bfb9356689187bea70
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Thu Apr 30 07:38:35 2020 -0700

    ci/net-snmp-run-tests: Fix the test that verifies whether Perl modules have been enabled

commit b323fe9f83ff070244f00363d5493b9528e4300d
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Thu Apr 30 10:09:07 2020 -0700

    perl/SNMP/t/bulkwalk.t: Improve the robustness of this test
    
    Instead of only examining the network interface that occurs first in the
    interfaces table, examine all network interfaces.

commit d589ab4eab9aa5f21290ae9e20fb4f8d0c75f105
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Thu Apr 30 17:01:20 2020 -0700

    perl/TrapReceiver/t/1.t: Use ok() instead of print()

commit 93c22da673e88a72d59e1d6e66a8d4836f9c6828
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Thu Apr 30 11:52:16 2020 -0700

    perl/ASN/test.pl: Convert to the Perl Test framework

commit 6c9f36b09b8a6486eb09f7496e5a73df18905a2f
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Mon Apr 27 17:14:58 2020 -0700

    perl/MakefileSubs.pm: Define the MinGW compiler flags correctly

commit e227abee97c3d43c53e5082c94892fc904780ffd
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Thu Apr 30 07:17:30 2020 -0700

    perl/MakefileSubs.pm: Remove -Iinclude/net-snmp from the Windows flags
    
    Remove include/net-snmp from the include path because it is not used.

commit 9f176cbee62338b2fb19de6165c4ae4f8799c822
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Thu Apr 30 07:20:10 2020 -0700

    agent/snmp_perl.c: Remove an obsolete definition
    
    _WIN32_WINNT is either defined by the configure script (MinGW, Cygwin) or
    by win32/Configure (MSVC).

commit bbd745acaf022524b9ae686953ea010d98c68ec5
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Thu Apr 30 08:02:39 2020 -0700

    configure: Simplify the size_t format specifier check
    
    Assume that Unix compilers are ANSI C compliant and use the 'z' format
    specifier on Unix. Only check for the underlying type of size_t on
    MinGW. Remove the unused NETSNMP_PRI32 format specifier.

commit 108cce420ee10857d0d9407f0f5b45b6e7c0fc48
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Wed Apr 29 18:36:45 2020 -0700

    ci/build.bat: Check whether make perl_test succeeded for the MSVC build

commit 93fe38cf5f7cdf339df48d94caff140c91e50ac7
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Wed Apr 29 14:35:34 2020 -0700

    perl/SNMP/Makefile.PL: Simplify GetTestInfo()

commit 50eeb76544810cf8fbcde94a2696519ba3e8acf3
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Wed Apr 29 12:01:36 2020 -0700

    perl/SNMP/t/dump-session.t: Call snmptest_cleanup() after the test has finished

commit e69984355cfd0d4bedd4077367f3a3c89de72109
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Wed Apr 29 11:04:22 2020 -0700

    perl/SNMP/t/startagent.pl: Improve kill_by_pid_file robustness

commit 905ab798cf6a419bafa68d29f6b262a21d3a382f
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Wed Apr 29 12:13:10 2020 -0700

    perl/SNMP/t/startagent.pl: Make starting processes faster

commit e2349372287809b518dc76e16b4e0602dffeca21
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Wed Apr 29 09:51:04 2020 -0700

    perl/default_store/test.pl: Convert to the Perl Test framework

commit 498b243e35d105d72ee205e42d17fd4505f99b25
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Wed Apr 29 10:51:20 2020 -0700

    Perl tests: Use $mibdir instead of ../../mibs

commit b16a0e0d917bf2cbd32e5dc95b73d7e5407533a9
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Wed Apr 29 15:18:44 2020 -0700

    perl/SNMP/t/startagent.pl: Split this Perl script

commit f253df86c4560d762cc22f8234cd879d9b143b1e
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Wed Apr 29 08:20:38 2020 -0700

    Perl tests: Enable 'use strict' and 'use warnings'

commit 917b0f281c31ab152528e6dc4e5c2ab5027d5353
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Wed Apr 29 09:53:24 2020 -0700

    Perl tests: do not modify @INC

commit dc43e75282c7b5de51463964571e5f6b633c582f
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Wed Apr 29 12:50:30 2020 -0700

    ci/perl.bat: Suppress two uninteresting Visual Studio compiler warnings

commit bc2a9a7fedf8a99073a4e5cb4872124101abd3d8
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Wed Apr 29 10:24:41 2020 -0700

    win32/Makefile.in: Tell the Perl DynaLoader where to find netsnmp.dll

commit 5bacc9af2baa5a5a02b0e3ffc6abf963adff6a71
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Wed Apr 29 13:30:38 2020 -0700

    snmpd: Do not open /dev/kmem on Linux even if libelf-devel has been installed
    
    See also f1647e3db242 ("snmpd: Do not open /dev/kmem on Linux")

commit 59e8b5b28db8bed05d68c4d508a89932437e9cb6
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Wed Apr 29 11:46:50 2020 -0700

    snmpd: Make init_kmem() report "success" if /dev/kmem is not opened
    
    Fixes: f1647e3db242 ("snmpd: Do not open /dev/kmem on Linux")

commit 595751cdf7b74083631b2ffd335be45f0b691a88
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Wed Apr 29 07:38:50 2020 -0700

    ci/build.bat: Unbreak the MSVCSTATIC64 build
    
    This patch fixes the following error that is triggered by the win32/Configure script:
    
    Can't locate ExtUtils/Embed.pm in @INC (you may need to install the ExtUtils::Embed module) (@INC contains: /usr/lib/perl5/site_perl /usr/share/perl5/site_perl /usr/lib/perl5/vendor_perl /usr/share/perl5/vendor_perl /usr/lib/perl5/core_perl /usr/share/perl5/core_perl) at Configure line 9.

commit d84f0c6e160951318a35e72fe76ef2e0ffd91044
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Tue Apr 28 20:42:46 2020 -0700

    Windows, MSVC: Fix Perl module compilation
    
    This patch fixes the following error message:
    
    default_store.c: loadable library and perl binaries are mismatched (got handshake key 0000000010500080, needed 0000000010A00080)
    
    See also https://github.com/net-snmp/net-snmp/issues/104.

commit 42aa220a7d3d686eb91bfd354c9b5094afbe6d97
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Tue Apr 28 15:55:59 2020 -0700

    ci/build.bat, MSVC: Run Perl tests

commit a4a8a70dbef581a30c3ba814de39b514f76072f8
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Tue Apr 28 15:40:59 2020 -0700

    Perl: Use $Config{path_sep} instead of ';' for Windows

commit 4990ca1af1d16a3e3144d455cb1e41108f00b691
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Tue Apr 28 14:50:44 2020 -0700

    win32/Makefile.in: Set PERL5LIB before running tests
    
    This is necessary to let the Perl interpreter find the Net-SNMP Perl modules.

commit 0e33f5025a483e4d724b6e417e8ef6b0788819e9
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Tue Apr 28 18:14:17 2020 -0700

    testing/RUNFULLTESTS: Fix the --with-perl-modules test

commit e621ae3038c82f92666c37da9c0e2ceb09df93f0
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Tue Apr 28 13:58:30 2020 -0700

    testing/RUNFULLTESTS: Fix PERL5LIB
    
    Fixes 5a86cfb005db ("testing: Unbreak RUNFULLTESTS").

commit 61822884421eae193ca9fd1f55da488000480789
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Tue Apr 28 13:53:12 2020 -0700

    ci/build.bat: Fix a comment

commit 467c5ee95ba804275e719a4848d2d46f18a9eee1
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Apr 25 15:54:06 2020 -0700

    ci, .appveyor.yml: Switch to Visual Studio 2019 image

commit f7ae854c12c35c2561979873e53d217da688e809
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Tue Apr 28 13:09:14 2020 -0700

    win32/dist/build-binary.pl: Remove the dependency on File::Which
    
    File::Which is a CPAN module and hence is not present in the core Perl
    distribution.
    
    Fixes: ed630cf540f6 ("win32/dist/build-binary.pl: Search %PATH% for tar.exe and gzip.exe")

commit 4f61570bca1d765bfdb11c6010c887cbe3176f29
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Tue Apr 28 13:33:44 2020 -0700

    ci/build.sh: Install MSYS Perl MakeMaker and Test-Harness

commit 62fb93df0641b4beed3db28d594ca1f87ec63b0c
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Mon Apr 27 21:50:53 2020 -0700

    ci/AppVeyor: Reduce build time
    
    Only download and build Perl when building with the Visual Studio
    compiler and for dynamic builds. Otherwise use the Perl interpreter that
    is included with the development environment (MinGW or Cygwin).

commit 8df783a81996f03e2927fe0f56182ab0250e317e
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Mon Apr 27 13:06:09 2020 -0700

    ci/build.bat: Fail if win32/Configure fails

commit aea52476b536d85f42a31d05a2bb5bcefe484823
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Mon Apr 27 12:45:17 2020 -0700

    win32/Makefile.in: Set NET-SNMP-PATH

commit bb8923f55329276debe86f787e3a0edd537c308f
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Mon Apr 27 15:17:40 2020 -0700

    perl/SNMP/Makefile.PL: Use NET-SNMP-PATH if it has been set
    
    Additionally, ignore the unused NETSNMP_PREFIX environment variable.

commit 4d614474f9157809d8a5ab8c265246e5b2e56374
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Mon Apr 27 13:22:39 2020 -0700

    perl/MakefileSubs.pm: Restore support for the -NET-SNMP-PATH option
    
    Fixes: 273cd3379613 ("perl Makefiles: MinGW / MSYS fixes")

commit 93299804393dd777ec1a188807bb4f664475eac0
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Mon Apr 27 17:29:35 2020 -0700

    perl/Makefile.PL: Simplify this file

commit 5135d509ed8bb1ac69b50f5980d97b237efb4f29
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Mon Apr 27 11:27:54 2020 -0700

    ci/perl.bat: Make this batch file compatible with Windows tar

commit 04adea6a0f33286e9b884f498989d26fbf28e896
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Mon Apr 27 11:18:04 2020 -0700

    ci/perl.bat: Bump Perl version

commit 0be093688013b90896f2db3204bb20e790d70149
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Mon Apr 27 08:23:16 2020 -0700

    configure: Report supported authentication and encryption modes correctly
    
    Commit 9e49de2e03b1 ("NEWS: snmplib: AES-192/AES-256 compatibility with SNMP
    Research / CISCO") removed SHA-128 and SHA-192 support and added support for
    SHA-224, SHA-256, SHA-384 and SHA-512. Commit 329a9d3c9d63 ("revamp auth/priv
    protocol constants handling") added support for several AES encryption modes.
    Make the configure script report which modes are supported.

commit 05739bdb63ef192bf9e9130fbc9b560baa8852ec
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Fri Apr 24 10:16:07 2020 -0700

    CHANGES: Windows, MSVC: snmpd: Switch from mibII/interfaces to if-mib/ifTable
    
    Provide IF-MIB::ifTable and IF-MIB::ifXTable through the agent instead of
    MIB-II::ifTable. This matches the default behavior of the Linux SNMP agent.
    
    From the IF-MIB: "This MIB is an updated version of MIB-II's ifTable".

commit 0c880d6f7a2bcb4a4a6f93c4dc577f9bc22c6e6a
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Apr 26 12:04:20 2020 -0700

    Windows, include/net-snmp/types.h: Fix socklen_t type definition

commit f1647e3db24241f0c42449506aee4b406a37b1b5
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Apr 26 11:10:46 2020 -0700

    snmpd: Do not open /dev/kmem on Linux
    
    The Net-SNMP agent only uses /dev/kmem to access kernel data structures on
    BSD systems. Hence do not open /dev/kmem on Linux. A side effect of this
    patch is that it enables cross-compilation from Linux to MinGW. /dev/kmem
    exists on Linux but the code in agent/kernel.c that is surrounded with
     #ifdef HAVE_KMEM / #endif does not build with the MinGW compiler.

commit 9ee2a5ccf50098f8e7371051e878b169b1e58cc3
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Apr 26 11:36:40 2020 -0700

    agent/mibgroup/host/hr_disk.c: #include <unistd.h>
    
    Fixes: e91559e38d23 ("Net-SNMP include files: Minimize #include directives")

commit b7f44bbdbe484bd03b438595e7c6b58eda005897
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Apr 26 09:33:51 2020 -0700

    Cygwin, MIB-II: Fix a few compiler warnings

commit 8e9dfcc27b6cdb538ec4a4d5596641a88dd8a2d9
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Apr 26 08:04:46 2020 -0700

    Cygwin, IF-MIB: Temporarily disable the iphlpapi implementation
    
    Making the iphlpapi implementation compatible with Cygwin requires more
    work. Hence temporarily disable the iphlpapi implementation for Cygwin.

commit dcec69ba971388d1da74acd1ca514e1c14ed8fa2
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Apr 25 19:39:21 2020 -0700

    Windows, IF-MIB: Minimize #include directives
    
    This prevents a conflict on Cygwin between the Cygwin socket header files
    and the Winsock header files.

commit e91559e38d230934c9b10fe0f0a51394e008dda9
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Apr 25 19:30:45 2020 -0700

    Net-SNMP include files: Minimize #include directives
    
    Move several #include directives from Net-SNMP include files into .c files.

commit 6945b208a74aabe9acebdae7e4642038ab8e1c96
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Apr 25 11:58:48 2020 -0700

    include/net-snmp/system/cygwin.h: Simplify this file

commit 8c686545d71894d1ba5b7eef846d559dae9fe06e
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Apr 25 15:53:06 2020 -0700

    ci, .travis.yml: Use OS/X 10.14

commit 193062739789a63affe09d2eb80affd57157b233
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Apr 25 10:18:39 2020 -0700

    Net-SNMP headers: Move in_addr_t definition into <net-snmp/net-snmp-config.h>
    
    This allows to remove #include <netinet/in.h> from <net-snmp/types.h>.
    That change allows to include <net-snmp/net-snmp-config.h> from source
    files that include Winsock header files. Cygwin BSD socket header files
    conflict with Winsock header files.
    
    See also commit a7f53c44a53d ("move include for in_addr_t to net-snmp/
    types.h, where in_addr_t is defined for systems w/out netinet/in.h").

commit b3d2d0896a67be6f8fbbd2f025e077ba293a52a5
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Apr 25 10:14:18 2020 -0700

    Net-SNMP headers: Only include <sys/time.h> if necessary
    
    Minimizing #include directives reduces the build time.

commit e981bcbab5034ccd9cf8445d4ba60d1420b23b3d
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Apr 25 07:59:04 2020 -0700

    IF-MIB: Unbreak the MinGW32 build
    
    Fixes: c33140b0110c ("Win32, IF-MIB: Implement interface table support")

commit 72405d2efb5874f48b6871ac0197d86d0e4f109c
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Apr 25 08:51:21 2020 -0700

    apps/Makefile.in: Make this Makefile again compatible with non-GNU make implementations
    
    'ifneq' is a GNU extension. Instead of using 'ifneq', use a mechanism that is
    compatible with GNU make.
    
    Fixes: 71f46f7126b4 ("apps: Only build snmpps and snmptop if a curses library is available")

commit 5c209f9a6fe444b13d7c39eac12f5390e5e5fcb4
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Fri Apr 24 21:46:40 2020 -0700

    Darwin: Add support for Darwin versions 18..21
    
    See also https://github.com/net-snmp/net-snmp/issues/101.

commit c33140b0110cead76039da6d985878ea9d05b2fd
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Thu Apr 23 18:10:39 2020 -0700

    Win32, IF-MIB: Implement interface table support
    
    On Windows Vista, Windows 2008 and later the ifOperStatus information is
    more accurate than on older Windows versions.

commit 026348ef082d3bda5f2b394002b1d770d71ccec3
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Fri Apr 24 16:42:34 2020 -0700

    Windows: Increase _WIN32_WINNT to 0xffff
    
    Instead of restricting the Windows features to a certain version of the
    Windows API, enable all Windows API functionality.

commit d560f542c0853fdfef2bf9cdf0365ac75dfdf40b
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Wed Apr 22 19:27:26 2020 -0700

    MIBs: Remove the NETSNMP_INCLUDE_IFTABLE_REWRITES and NETSNMP_ACCESS_INTERFACE_NOARCH macros
    
    Switch all platforms to the rewritten ifTable implementation. Instead of defining
    NETSNMP_ACCESS_INTERFACE_NOARCH if no data access implementation is available, use
    the "unsup" dummy implementation.

commit e86230436ea0d3126a4525a98ff7dde60cd448b1
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Tue Apr 21 09:48:31 2020 -0700

    Windows, IF-MIB: Switch to the rewritten ifTable implementation
    
    Since the IF-MIB is not yet implemented on Windows, all switching to the rewritten
    ifTable implementation involves is to provide a dummy implementation of the data
    access functions.

commit d15cae3cb7e2eb5a1cfea8832d530fb81c317858
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Tue Apr 21 10:13:27 2020 -0700

    IF-MIB: Fix the build for the case !defined(HAVE_PCRE_H) && !defined(HAVE_REGEX_H)

commit 4803af75945291ee7ad270d93425781e9e79f3f1
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Tue Apr 21 15:04:39 2020 -0700

    ci/openssl.bat: Bump the OpenSSL version

commit 71f46f7126b4f5cf1858d16be633a0d7a2002e6d
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Tue Apr 21 08:34:44 2020 -0700

    apps: Only build snmpps and snmptop if a curses library is available
    
    Additionally, only search for curses header files if a curses library is available.

commit 435ddb821bdae5950829d225d1c087784214d41c
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Tue Apr 21 07:53:15 2020 -0700

    configure: Skip pcre.h check if --without-pcre has been specified
    
    Fixes: 213941dfbee6 ("CHANGES: agent: PATCH 3525595: from dhubler: Add support for finding processes via regex")

commit 2f1c4d06bc49da5fc4a0fb7be373a8c6f9d3d4a6
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Mon Apr 20 14:40:13 2020 -0700

    ci, FreeBSD: Improve the code that detects the OpenSSL version

commit b59e896245d001ebc13c415c86fb8c203b639f07
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Mon Apr 20 13:44:31 2020 -0700

    ci, MinGW: Build HOST-MIB

commit 90ea93b038ea0f70a78f315d89f68d34615c1902
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Jun 23 09:18:12 2018 -0700

    tests: Rename SUCCESS() and FAILED()
    
    This is necessary to avoid conflicts with constants with the same
    name in the Windows header files.

commit c083ccbe9b365a06b7192be1d1b6a31695c677d1
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Mon Apr 20 21:18:33 2020 -0700

    MinGW, T008asn1_clib.c: Fix compiler warnings

commit f78d56a80e89aaa36a6da2b7318c9e012badfef9
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Mon Apr 20 21:13:13 2020 -0700

    MinGW: Fix multiple compiler warnings

commit c55a1421da1bed9acdbc08381744238aeca897c6
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Mon Apr 20 13:20:18 2020 -0700

    agent/mibgroup/utilities/execute.c: Only define tokenize_exec_command() if necessary

commit 1ff5be497f7ef551c26bf320aab995ece596cca9
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Mon Apr 20 20:00:31 2020 -0700

    MinGW, MIB-II: Fix a linker error

commit fbb0e883abf2e3b2b021aabdc4e9ae56bba35ced
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Mon Apr 20 12:58:03 2020 -0700

    MinGW: Fix agent/mibgroup/host/hr_system.c build

commit 3074aa18898b0461bc06b61041382d9622e83cf7
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Mon Apr 20 12:52:30 2020 -0700

    agent/mibgroup/host/data_access/swrun_null: Fix a compiler warning

commit 3c9e5f2608eebacd31c4e08eabe11dbb183ee685
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Mon Apr 20 10:32:43 2020 -0700

    MinGW: Fix cross-compilation
    
    Fix building for MinGW on a non-MinGW system (--host=x86_64-w64-mingw32). Add
    LT_LANG([Windows Resource]). Use @RC@ instead of windres such that the proper
    cross-compilation prefix is used in front of the windres executable.

commit fda7c07b0ec3ab1384646548edd79e62138b71eb
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Mon Apr 20 11:19:08 2020 -0700

    testing/fulltests/unit-tests/T008asn1_clib: Fix MinGW build

commit 44fd72624285fd52337c97577d92b94333b8dadb
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Mon Apr 20 11:18:41 2020 -0700

    apps/snmpping: Fix MinGW build

commit 319f4d717fb9ab2ef0f7696d4afb348ed34054ae
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Apr 18 20:16:52 2020 -0700

    HOST-MIB: Reorder function definitions
    
    Reorder the function definitions in hw_fsys.c such that the forward function
    declarations can be removed.

commit 5732d8b3debdb149ea5f12d85b2804b41b98d22e
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Apr 18 19:54:49 2020 -0700

    HOST-MIB: Declare _fsys_cache and _fsys_container static
    
    Neither _fsys_cache nor _fsys_container is used outside the source file these
    variables are declared in. Hence declare these variables static.

commit 3300c1f03e5899dc4301c39c104ff3cfbd840a79
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Apr 18 18:46:09 2020 -0700

    testing: Make the tests pass for --enable-minimalist and --enable-mini-agent

commit 228cba5710b2213cf4bb5c2d60d56608f2497831
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Apr 18 11:10:29 2020 -0700

    testing: Add a test for "extend OID"
    
    See also https://github.com/net-snmp/net-snmp/issues/97 .

commit 633b8214eeb6558519efdb18a5fea1e53b7f2ba3
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Apr 12 19:28:13 2020 -0700

    libsnmp: Only define strcasecmp() and strncasecmp() if necessary

commit ea4e62bf9242a2c4792bc60eb3fff0b97fa76060
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Apr 12 04:12:43 2020 +0000

    testing/fulltests/support/myip: Suppress Perl error messages
    
    Suppress the following error message:
    
    Constant subroutine main::AF_INET6 redefined at /System/Library/Perl/5.18/Exporter.pm line 66.
     at (eval 1) line 2.
    Prototype mismatch: sub main::AF_INET6 () vs none at /System/Library/Perl/5.18/Exporter.pm line 66.
     at (eval 1) line 2.
    usage:   sin_sv = sockaddr_in6(port,iaddr)) at ../support/myip line 39.

commit cc2eece940c5e8508d635a1620eb1cddf25fd136
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Apr 11 20:32:03 2020 -0700

    ci/openssl.bat: Bump the OpenSSL version

commit 5f1986c79e8b9d3d8574fc73001d6e193bed7c79
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Apr 11 20:11:35 2020 -0700

    HOST-MIB: Log statfs() failures once
    
    See also https://github.com/net-snmp/net-snmp/issues/94.

commit c94fdd4084fdefafaebcd3421f1c0fa644cda928
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Apr 11 20:10:58 2020 -0700

    HOST-MIB: Do not assume that statfs() returns meaningful values if it fails

commit e1b57bd02670818a44966ba4aad2a6d7ce9839b5
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Apr 11 19:56:31 2020 -0700

    libsnmp: Suppress a clang warning about debug_indent()
    
    Suppress the following clang warning:
    
    snmp_debug.c:91:19: warning: adding 'unsigned long' to a string does not append\
     to the string [-Wstring-plus-int]
        return SPACES + sizeof(SPACES) - 1 - debugindent;
               ~~~~~~~^~~~~~~~~~~~~~~~
    snmp_debug.c:91:19: note: use array indexing to silence this warning
        return SPACES + sizeof(SPACES) - 1 - debugindent;
                      ^
               &      [               ]

commit 23fe19d9b63df63446c4f39ae1c9a60cd9c198d0
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Apr 11 17:15:55 2020 -0700

    testing/fulltests/support/myip: Make this work with older Perl versions
    
    Older Perl versions have Socket6 and Socket modules. Newer Perl versions
    support the Socket module but not Socket6. Make the myip script work with
    all Perl versions.

commit bf4964241391b197e1ce2afca225b684f94f7451
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Apr 12 01:54:58 2020 +0000

    IF-MIB: Fix regexec() argument types
    
    Fixes: e6795b2d67b4 ("IF-MIB: Add regex support for include_ifmib_iface_prefix")

commit 9180ccb8772f7cd3317afcb6db676c8bdeedbcb9
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Apr 11 18:31:27 2020 -0700

    NetBSD: Fix compilation of snmplib/snmpksm.c

commit 6d722dcf108055c24e783cb367cb6985f11bd850
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Apr 11 11:33:21 2020 -0700

    Regenerate the configure script
    
    Fixes: e65031b76367 ("CHANGES: building: Remove extra argument to NETSNMP_SEARCH_LIBS to make libnl-3 end up in the right group of libraries")

commit e65031b76367696234f7f0e7ecb2d0379e094457
Author: Magnus Fromreide <magfr@lysator.liu.se>
Date:   Tue Apr 7 05:41:14 2020 +0200

    CHANGES: building: Remove extra argument to NETSNMP_SEARCH_LIBS to make libnl-3 end up in the right group of libraries

commit b04dd9585aee57615edc2f973ac3b43a3c758812
Author: Magnus Fromreide <magfr@lysator.liu.se>
Date:   Mon Apr 6 02:46:12 2020 +0200

    CHANGES: net-snmp-config: Allow nine or more files in --compile-subagent

commit b078c7eac1d98c340d3682341ae7d0ceb3504f12
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Apr 4 19:40:02 2020 -0700

    Revert "swinst_apt: Use dpkg for modified date"
    
    The reasons for the revert are:
    - The modified_date_t change that I made is wrong.
    - Apparently not all Debian systems support ${db-fsys:Last-Modified}. From
      the dpkg man page: "It contains the timestamp in seconds of the last time
      the package filesystem entries were modified (since dpkg 1.19.3)."

commit 001cbbc32a8be87041ddb7a80a3642550691ecfb
Author: Craig Small <csmall@dropbear.xyz>
Date:   Sat Apr 4 12:00:43 2020 +1100

    swinst_apt: Use dpkg for modified date
    
    Instead of trawling through dpkg's files, let dpkg-query tell us
    when the package was last modified. It means if the directory
    changes or any other internal changes happen, this will still
    keep working.
    
    db-sys:Last-Modified field has been in since dpkg-query 1.19.3
    which means it works for Debian stable (Buster) onwards.
    
    References: https://bugs.debian.org/905668
    
    [ bvanassche: reworked an unsafe cast ]

commit d6551405ddcbdc003302d991cc550270c701d9db
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Tue Mar 31 20:51:48 2020 -0700

    ci: Move the mariadb installation code from .travis.yml into ci/before.sh
    
    Additionally, display /etc/hosts on all operating systems.

commit 49485cd90f9e978d2e68678f9efdff0a645a34d2
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Fri Mar 27 21:54:02 2020 -0700

    testing/fulltests/support/clib_build: Fix a recently introduced bug
    
    Prevent that linking the regression tests fails as follows on Ubuntu:
    /usr/bin/ld: cannot find -lnetsnmpmibs
    /usr/bin/ld: cannot find -lnetsnmpagent
    collect2: error: ld returned 1 exit status
    
    Fixes: 9db9d55f9511 ("testing: Add a unit test for run_exec_command()")

commit e6795b2d67b45dddcb4deb99e9af51f7659d5a0c
Author: lbw <lbw@telstra.com>
Date:   Sat Mar 21 17:03:21 2020 +1100

    IF-MIB: Add regex support for include_ifmib_iface_prefix
    
    [ bvanassche: consolidated error paths ]

commit b49ff2207661c48bad46bb312f6f0627ffbbb825
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Mar 22 21:33:00 2020 -0700

    testing/fulltests/unit-tests/T024run_exec_command_clib.c, Darwin: Fix executable paths

commit 418dd7012dd45612b6506d6519e128ec823918d5
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Mar 22 21:29:04 2020 -0700

    agent/netsnmp_close_fds.c, Darwin: Suppress two compiler warnings

commit 5459b69c4bc0f228f2e329b5913320a8d5acccc9
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Mar 22 20:51:32 2020 -0700

    ci: .travis.yml: Add Python 3 packages

commit f0bca593510e3776c6aca1c44556ae04e7a1109b
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Mar 22 15:34:04 2020 -0700

    agent/mibgroup/utilities/execute.c: Handle errors instead of ignoring these

commit 166a236be4f76796db0a49917415b790eec9ef89
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Mar 22 15:30:33 2020 -0700

    agent/mibgroup/utilities/execute.c: Fix tokenize_exec_command()
    
    Do not discard the 100th argument. Fix a buffer overflow.

commit 85a536c06f4de67fbb4f0382d4137be4b97b7ff3
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Mar 22 15:41:55 2020 -0700

    agent/mibgroup/utilities/execute.c: Remove the setPerrorstatus() macro

commit 6a666952e58c69225a2c681cc2059de7a782c4ee
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Mar 22 15:28:16 2020 -0700

    agent/mibgroup/utilities/execute.c: Declare input arguments const

commit f8f6cb8e7513f38c782bf96a285e2f81cfeb98f1
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Mar 22 15:26:12 2020 -0700

    agent/mibgroup/utilities/execute.c: Convert tabs into spaces

commit 9db9d55f95116300c282aa48dd329764773af59b
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Mar 22 16:22:36 2020 -0700

    testing: Add a unit test for run_exec_command()

commit a524e99cb6524353883c72721f6df5b470740408
Author: Igor Ryzhov <iryzhov@nfware.com>
Date:   Fri Mar 20 16:45:41 2020 +0300

    mib2c: fix size_t format specifier in mfd generated code
    
    Signed-off-by: Igor Ryzhov <iryzhov@nfware.com>

commit 6141634d652cbd5a9e20982c88b95984d093099b
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Mar 21 20:52:37 2020 -0700

    libsnmp: Fix a potential buffer overflow in netsnmp_tlstmAddr_restore_common()
    
    This patch fixes the following Coverity complaint:
    
    CID 344591 (#1 of 1): Out-of-bounds access (OVERRUN)
    5. overrun-buffer-arg: Overrunning array fingerprint of 256 bytes by passing
    it to a function which accesses it at byte offset 256 using argument fp_len
    (which evaluates to 256).

commit 3d5eab844a70367d2ea00a93ad37206ec7b91793
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Mar 21 20:48:08 2020 -0700

    libsnmp: Document the is_labelchar() argument range
    
    This patch suppresses the following Coverity complaint:
    
    CID 344592 (#1 of 1): Improper use of negative value (NEGATIVE_RETURNS)
    32. negative_returns: ch_next = netsnmp_getc(fp) is passed to a parameter
    that cannot be negative.

commit 3f9aa163160e96b877f975519415ce3277d5da0a
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Mar 21 20:44:16 2020 -0700

    snmplib/sd-daemon.c: Check LISTEN_FDS before using it
    
    This patch fixes the following Coverity complaint:
    
    CID 344596 (#1 of 1): Untrusted loop bound (TAINTED_SCALAR)
    15. tainted_data: Using tainted variable 3 + (int)l as a loop boundary.

commit b67afb81eb0f7ad89496cd3e672654bfd8c55d0e
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Mar 21 20:03:13 2020 -0700

    snmpd: UCD-SNMP proxy: Fix a crash triggered by a wrong passphrase
    
    See also https://github.com/net-snmp/net-snmp/issues/82 .

commit b83b0ddcf8fa27108b198bbb0fe247e18d2dae4f
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Mar 21 20:01:18 2020 -0700

    libsnmp: Improve snmp_async_send() and snmp_sess_async_send() documentation

commit 2e517c5d60fcf9f96d2ad8045e7aec9b60dec041
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Mar 21 13:59:27 2020 -0700

    Python: Port to Python 3
    
    Make the configure script look for the 'python3' interpreter instead of
    'python'. Make all Python source code compatible with Python 2.7 and
    Python 3. Make python/netsnmp/client_intf.c compatibly with Python 2.7
    and Python 3.

commit 7fd595cbdf0fe855aafaf54fcc39e8b3b2f96c08
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Mar 21 14:24:16 2020 -0700

    python/netsnmp/client_intf.c: Improve coding style conformance
    
    Limit source code to 80 columns, move the body of if-statements to a
    separate line and leave a blank line after declarations.

commit 9619aa41d5cf353ec1d9b94d3ed4b4a61a51bc34
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Mar 21 14:54:46 2020 -0700

    python/netsnmp/client_intf.c: Add more comments

commit dfd0b638dd5ce9cabcc65afbd589a3177749fac3
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Mar 21 15:10:14 2020 -0700

    python/netsnmp/client_intf.c: Change the return type of py_netsnmp_attr_long() from long long into long
    
    The type 'long' is big enough to fit all possible return values.

commit 3fb925a5a93ab2326b588899d81e0e412e0f321b
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Mar 21 15:08:16 2020 -0700

    python/netsnmp/client_intf.c: Fix the netsnmp_create_session_tunneled() return value

commit d9577374329fa4516ba0220bc8ff68c3f316b430
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Mar 21 13:35:10 2020 -0700

    Python: Reorder function definitions
    
    Reorder function definitions such that the forward declarations can be
    removed.

commit df1c17d2a0d1ba2a3130c9fdd2bd4c03dba4a947
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Fri Mar 20 20:36:21 2020 -0700

    Perl: Complain about attempts to send a TRAP with an unsupported SNMP version

commit 883b354d4be90c13166bc11eb8ac65880f51e57d
Author: Peter Valdemar Mørch <peter@morch.com>
Date:   Wed Sep 25 18:13:36 2019 +0200

    Perl: Allow informs to be sent with SNMP v2(c).
    
    Before informs required SNMP v3. But informs actually work just fine
    with v2c too too.

commit dfe3c8bdff9bceb796fc9425ef21676a99138d33
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Wed Mar 18 21:54:28 2020 -0700

    ci/openssl.bat: Bump the OpenSSL version

commit 62eea843bf46162db557e7f39f87958de2fee26a
Author: Igor Ryzhov <iryzhov@nfware.com>
Date:   Wed Mar 18 22:24:27 2020 +0300

    mib2c: use struct counter64 instead of U64 in generated code
    
    The U64 typedef was replaced with struct counter64 in net-snmp
    code because of the conflicts with Perl headers. But mib2c still
    generates the code with U64.
    
    Signed-off-by: Igor Ryzhov <iryzhov@nfware.com>
    [ bvanassche: Adjusted indentation of source code comments ]

commit 1a8b31c175e69e0e0a8ef6b7068aff6c45980eea
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Mar 15 21:55:36 2020 -0700

    CHANGES: configure: Assume that memcmp() works
    
    From the autoconf documentation: "Macro: AC_FUNC_MEMCMP. If the memcmp
    function is not available, or does not work on 8-bit data (like the one
    on SunOS 4.1.3), or fails when comparing 16 bytes or more and with at
    least one buffer not starting on a 4-byte boundary (such as the one on
    NeXT x86 OpenStep), require an AC_LIBOBJ replacement for `memcmp`.
    
    This macro is obsolescent, as current systems have a working memcmp.
    New programs need not use this macro."
    
    Hence remove the AC_FUNC_MEMCMP invocation.
    
    See also https://github.com/net-snmp/net-snmp/issues/81.

commit 8c02e747d35d1df12c3482895879caf38e448c44
Author: Niels Baggesen <nba@users.sourceforge.net>
Date:   Wed Mar 11 20:38:50 2020 +0100

    fsys_mrtent: add glusterfs as a recognized filesystem type.
            Thanks to Josef Ricky.

commit 3bc8e2de4e54b7c5f72f0c4d1b753d0c32ae9805
Author: Niels Baggesen <nba@users.sourceforge.net>
Date:   Wed Mar 11 20:26:27 2020 +0100

    snmplib/parse: change the tclist (TEXTUAL-CONVENTION) data structure
    to be dynamically allocated.

commit ddb3a0b1f8b8cf2734f9c2cc4e434c79370b2cb5
Author: Mukesh Jain <mukesh.jain@newnet.com>
Date:   Tue Mar 3 03:47:49 2020 +0530

    snmpd: Fix a memory leak in handle_agentx_packet()
    
    Fix a memory leak when contextName is used in the PDU. The memory for
    contextName is assigned to community and is hence lost. This patch
    fixes the following Valgrind complaint:
    
    at 0x4C29EA3: malloc (vg_replace_malloc.c:309)
    by 0x653F294: snmp_clone_mem (in /usr/lib64/libnetsnmp.so.31.0.2)
    by 0x653F3E7: ??? (in /usr/lib64/libnetsnmp.so.31.0.2)
    by 0x653F90D: snmp_clone_pdu (in /usr/lib64/libnetsnmp.so.31.0.2)
    by 0x60E3837: handle_agentx_packet (in /usr/lib64/libnetsnmpagent.so.31.0.2)
    by 0x6567ED0: ??? (in /usr/lib64/libnetsnmp.so.31.0.2)
    by 0x6568F40: _sess_read (in /usr/lib64/libnetsnmp.so.31.0.2)
    by 0x65698A8: snmp_sess_read2 (in /usr/lib64/libnetsnmp.so.31.0.2)
    by 0x65698FA: snmp_read2 (in /usr/lib64/libnetsnmp.so.31.0.2)
    by 0x656993B: snmp_read (in /usr/lib64/libnetsnmp.so.31.0.2)
    by 0x60DF30A: agent_check_and_process (in /usr/lib64/libnetsnmpagent.so.31.0.2)
    
    See also https://github.com/net-snmp/net-snmp/pull/78.
    See also https://github.com/net-snmp/net-snmp/issues/58.
    
    [ bvanassche: modified commit message and patch ]

commit 67fde288efa0d07df2dbd5dcc3d39b937b69b176
Author: Niels Baggesen <nba@users.sourceforge.net>
Date:   Mon Mar 2 21:18:52 2020 +0100

    Support for NetBSD 9.0

commit a49aa9c132cd38a9170de19b454dc27a67c2683c
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Fri Feb 28 20:26:34 2020 -0800

    ci: Skip the DTLS and TLS tests
    
    Since the DTLS and TLS code is broken, skip the corresponding tests.

commit b900b83258aa8b92895b9f988b02a1b086420322
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Fri Feb 28 20:14:54 2020 -0800

    libsnmp: Fix cert:map:secname fingerprint selection
    
    See also https://github.com/net-snmp/net-snmp/issues/75.
    
    Fixes: f51321751caf ("lots of new cert functionality")

commit a7c4831997a1deaf8a6a285babea28877bae15a8
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Tue Feb 25 21:15:19 2020 -0800

    libsnmp: Surround MAKE_ENTRY() definition with do { } while (0)

commit eecd4d23b166a49ba4840264a4763ae5f9caad0e
Author: Gisle Vanem <gvanem@yahoo.no>
Date:   Tue Feb 25 20:50:55 2020 +0100

    libsnmp: Surround multiple macros with do { } while (0)
    
    This patch suppresses the following clang warning:
    
    empty expression statement has no effect; remove unnecessary ';' to silence this warning
    
    See also https://github.com/net-snmp/net-snmp/pull/76.
    
    [ bvanassche : combined three patches into one ]

commit e1d9a6181dd46dc14101665c38a3c875d8b6f303
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Feb 22 14:44:18 2020 -0800

    configure: Upgrade libtool and automake
    
    The parts of the configure script generated by libtool and aclocal come from
    libtool v2.4 (released on 2010-09-21) and automake v1.11 (released on
    2009-05-16). Upgrade libtool to v2.4.6 and automake to v1.11.6.

commit db50cd646a49cf18c91c63a0737eb7a704e69099
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Feb 22 08:13:06 2020 -0800

    CHANGES: Remove dmalloc and efence support
    
    Tools like dmalloc and efence were important to root cause memory corruption
    issues until about 2005, when Valgrind became available. Remove support for
    dmalloc and efence since tools like Valgrind and compiler sanitizers are
    superior compared to dmalloc and efence. For more information about Valgrind
    and the compiler sanitizers, see also:
    * http://valgrind.org/
    * https://en.wikipedia.org/wiki/AddressSanitizer
    * https://gcc.gnu.org/onlinedocs/gcc/Instrumentation-Options.html

commit f4ae8cf7d808ba54761d6ba8bd593c7a6669b9c3
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Mon Jan 14 18:39:45 2019 -0800

    configure: Re-enable shared library support for FreeBSD 10 and later
    
    See also
    https://lists.freebsd.org/pipermail/freebsd-current/2013-March/040460.html .
    See also commit 7d66a35cd6bf ("configure: Enable shared library support for
    FreeBSD 10 and later") # v5.8.1.pre1.
    Fixes: 84355f7122da ("configure: Regenerate with autoconf v2.69").

commit 10823f0194e167b2e7860acd4f96d14380ae36b3
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Feb 22 07:55:55 2020 -0800

    configure: Add exp() library to LMIBLIBS instead of LIBS
    
    This change allows the ceil() test to add -lm to LNETSNMPLIBS.
    
    This patch is a follow-up for commit d63e35a3a384 ("configure: Add -lm to
    LNETSNMPLIBS if ceil() exists in libm").
    
    See also https://github.com/net-snmp/net-snmp/issues/72.

commit 21e318b418f206cd3acc22f3ff7a58b864f287f0
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Fri Feb 21 20:33:07 2020 -0800

    dist/autoconf-version: Bump to v2.69
    
    Fixes: 9a2753282c6a ("new autoconf")

commit d63e35a3a384c9f917bc4ab117d9239af2f01fc4
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Fri Feb 21 19:42:11 2020 -0800

    configure: Add -lm to LNETSNMPLIBS if ceil() exists in libm
    
    See also https://github.com/net-snmp/net-snmp/issues/72.
    
    Reported-by: Stuart Henderson
    Fixes: 7497e2eade8a ("check if libm is needed for ceil function") # v5.8.pre2

commit f0f9279ad18ff03542e6dae156b6633628d36762
Author: Stuart Henderson <stu@spacehopper.org>
Date:   Fri Feb 21 14:59:21 2020 +0000

    TCP-MIB, UDP-MIB: Fix these tables for OpenBSD >= 5.6
    
    OpenBSD changed from CIRCLEQ to TAILQ for inpt_queue in OpenBSD 5.6
    (November 2014), the version of Net-SNMP in ports has been carrying this
    patch since then.
    
    [ bvanassche: modified patch title ]

commit bd276c697ae51cb7744b6731477f67203430cdbf
Author: Stuart Henderson <sthen@users.noreply.github.com>
Date:   Fri Feb 21 14:56:05 2020 +0000

    snmpps: Avoid null pointer dereference for SNMP_NOSUCHOBJECT
    
    Handle SNMP_NOSUCHOBJECT as well as SNMP_NOSUCHINSTANCE. If snmpps/snmptop
    are pointed at an agent which doesn't provide the required objects, before
    this change it tries to dereference a null pointer when setting the
    variables (noticed against OpenBSD snmpd which only implements part of
    hrSWRunPerf and misses CPU/Mem).
    
    [ bvanassche: modified patch description ]

commit 9a2753282c6a8dc09ed5dc4bc01683e8ba1f4850
Author: Wes Hardaker <opensource@hardakers.net>
Date:   Thu Feb 20 14:23:41 2020 -0800

    new autoconf

----------------------------------------------------------------------

Changes: V5.8.1.pre1 -> V5.8.1.pre2

commit 8436b3bbf944b87873e31c3c81694f03635082bf
Author: Wes Hardaker <opensource@hardakers.net>
Date:   Tue Feb 18 15:41:04 2020 -0800

    Version number update: 5.8.1.pre2

commit 473734ac3302210b4bf4175e20657029d55439e5
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Feb 8 09:36:58 2020 -0800

    perl: Use netsnmp_memdup() where appropriate

commit dac831d3220e2ff9013955a314aada6c1c88fef5
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Fri Feb 7 20:13:06 2020 -0800

    perl: Allow empty strings in notifications
    
    Adding a string of length zero is not necessarily an error. In fact, treating
    it as such, prevents us from sending the empty string as an otherwise valid
    OCTET STRING in traps/notifications.
    
    This is a modified version of a patch provided by Peter Valdemar Mørch
    <peter@morch.com>.

commit 6725c4f7219fca50b7e455bcf2efc5bdfe7e9469
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Fri Feb 7 20:06:52 2020 -0800

    perl: Only call netsnmp_malloc() if necessary
    
    Change the netsnmp_malloc() call into a netsnmp_memdup() call and only call
    that function if len > 0.
    
    This is a modified version of a patch provided by Peter Valdemar Mørch
    <peter@morch.com>.

commit db95f59860c0d06e3aa591e71a278630dc3f48ee
Author: Alexander Dahl <post@lespocky.de>
Date:   Wed Feb 5 01:49:37 2020 +0100

    Add unit test for int8_t input to snmp_set_var_value()
    
    This new test fails on 32bit arm, e.g. on Raspberry Pi, but not on x86
    or x86_64. See output of a failing test:
    
        Testing snmp_set_var_value() ................................ 1/?
        not ok 3 - 128 =?= -128
        not ok 5 - 233 =?= -23
        not ok 7 - 255 =?= -1
        Testing snmp_set_var_value() ................................ Failed 3/13 subtests
    
    Reason is type "char" can be signed or unsigned, but
    snmp_set_var_value() implicitly assumes "char" is always signed.
    
    [ bvanassche: reformatted unit test source code ]

commit a3a4e65b5d4fdd37520d75e74d5f0f57501326a4
Author: Alexander Dahl <ada@thorsis.com>
Date:   Tue Feb 4 15:34:29 2020 +0100

    libsnmp: Cast signed char to signed int when setting value
    
    We have an INT8 in a MIB, an Integer32(-128..127) to be more specific.
    In a custom software we call 'snmp_pdu_add_variable()' with
    type == ASN_INTEGER and len == 1. Deeper down the code path, we come to
    'snmp_set_var_value()' and this part:
    
            else if (vars->val_len == sizeof(char)) {
                if (ASN_INTEGER == vars->type) {
                    const char      *val_char
                        = (const char *) value;
                    *(vars->val.integer) = (long) *val_char;
                } else {
                        const u_char    *val_uchar
                        = (const u_char *) value;
                    *(vars->val.integer) = (unsigned long) *val_uchar;
                }
    
    Obviously the intent is to cast depending on whether the integer is
    supposed to be signed or not, but although he jumps to the right code
    path here, the result in vars->val.integer is wrong then. It does not
    work with type 'char' like above.
    
    We got values looking unsigned added to our pdu which we set to our
    net-snmp server then and got them back unsigned on SNMP get requests
    later, for example we fed an int8_t with value -32 we read back 224.
    
    So this patch explicitly uses type 'signed char' which works for us.
    
    Compiler is gcc 4.7 and we're cross-compiling for
    arm-v5te-linux-gnueabi on Linux.
    
    Fixes: 8e7458661b0eeb72d787a69cb915c16b151beee1
    Signed-off-by: Alexander Dahl <ada@thorsis.com>

commit dd6cb372db7c1d7ca606c0d13c48f20148da8038
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Feb 1 11:21:47 2020 -0800

    FreeBSD, HOST-RESOURCES-MIB: Fix two compiler warnings
    
    Fix the following compiler warnings:
    
    hardware/cpu/cpu_sysctl.c:204:20: warning: unused variable 'mem_mib' [-Wunused-variable]
        int            mem_mib[] = { CTL_VM, NETSNMP_VM_STATS };
                       ^
    hardware/cpu/cpu_sysctl.c:205:20: warning: unused variable 'mem_size' [-Wunused-variable]
        size_t         mem_size  = sizeof(NETSNMP_VM_STATS_TYPE);
                       ^
    
    Fixes: 2bbad43c53ff ("Patch for cpu_sysctl for FreeBSD 12")

commit d4d09af41f6e794271e62a986f2216357f8f11ef
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Feb 1 11:33:47 2020 -0800

    FreeBSD, HOST-RESOURCES-MIB: Move a misplaced comment

commit 5846564f5be46e0e362be894d4cb57be383c5b3d
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Feb 1 10:28:48 2020 -0800

    FreeBSD, HOST-MIB: Fix a memory leak in swrun_kinfo.c
    
    See also:
    * https://sourceforge.net/p/net-snmp/bugs/2717/.
    * https://sourceforge.net/p/net-snmp/patches/1341/.
    * https://bugs.freebsd.org/bugzilla/show_bug.cgi?id=219072.

commit 7229e320abd63512ba7e9d69adaa5f44553c6566
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Feb 1 10:11:34 2020 -0800

    HOST-MIB: Remove a superfluous include directive
    
    The only source file from which _ftime() is called is snmplib/gettimeofday.c.
    Hence do not include <sys/timeb.h> from the host MIB implementation.

commit 0ded321a1588b7e1281f505c2f6266aa979168c6
Author: Thomas Abraham <tabraham@suse.com>
Date:   Tue Jan 7 11:20:39 2020 -0500

    Recognize NSS pools and NSS volumes (Open Enterprise Server)

commit bd92f4d6fec0dd278c8092c95437d09903c16bb2
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Fri Jan 3 18:33:28 2020 -0800

    configure, include/net-snmp/net-snmp-config.h.in: Fix a description
    
    Fixes: 5da4fc8c8e08 ("MinGW64: Fix select() and ioctlsocket() calls")

commit d3e17f70f26898dfe870cff03c56be628b9c0fd2
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Dec 7 15:34:31 2019 -0800

    Fix -D_FORTIFY_SOURCE=1 compiler warnings
    
    See also https://github.com/net-snmp/net-snmp/issues/51
    
